(self["webpackChunk_datalayer_jupyter_viewer"] = self["webpackChunk_datalayer_jupyter_viewer"] || []).push([["ui_packages_react_lib_index_js-webpack_sharing_consume_default_codemirror_language-webpack_sh-0fd2e6"],{

/***/ "../ui/packages/lite/server/lib/app.js":
/*!*********************************************!*\
  !*** ../ui/packages/lite/server/lib/app.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "JupyterLiteServer": () => (/* binding */ JupyterLiteServer)
/* harmony export */ });
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_application__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/application */ "webpack/sharing/consume/default/@lumino/application");
/* harmony import */ var _lumino_application__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_application__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var mock_socket__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! mock-socket */ "../../../node_modules/mock-socket/dist/mock-socket.js");
/* harmony import */ var mock_socket__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(mock_socket__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./router */ "../ui/packages/lite/server/lib/router.js");
// Copyright (c) Jupyter Development Team.
// Distributed under the terms of the Modified BSD License.




/**
 * Server is the main application class. It is instantiated once and shared.
 */
class JupyterLiteServer extends _lumino_application__WEBPACK_IMPORTED_MODULE_1__.Application {
    /**
     * Construct a new JupyterLite object.
     *
     * @param options The instantiation options for a JupyterLiteServer application.
     */
    constructor(options) {
        super(options);
        this._serviceManager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__.ServiceManager({
            standby: 'never',
            serverSettings: {
                ..._jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__.ServerConnection.makeSettings(),
                WebSocket: mock_socket__WEBPACK_IMPORTED_MODULE_2__.WebSocket,
                fetch: this.fetch.bind(this) ?? undefined,
            },
        });
    }
    /**
     * The name of the application.
     */
    name = 'JupyterLite Server';
    /**
     * A namespace/prefix plugins may use to denote their provenance.
     */
    namespace = this.name;
    /**
     * The version of the application.
     */
    version = 'unknown';
    /**
     * Get the underlying `Router` instance.
     */
    get router() {
        return this._router;
    }
    /**
     * Get the underlying lite service manager for this app.
     */
    get serviceManager() {
        return this._serviceManager;
    }
    /**
     * Handle an incoming request from the client.
     *
     * @param req The incoming request
     * @param init The optional init request
     */
    async fetch(req, init) {
        if (!(req instanceof Request)) {
            throw Error('Request info is not a Request');
        }
        return this._router.route(req);
    }
    /**
     * Attach the application shell to the DOM.
     *
     * @param id - The id of the host node for the shell, or `''`.
     *
     * #### Notes
     * For this server application there is no shell to attach
     */
    attachShell(id) {
        // no-op
    }
    /**
     * A method invoked on a window `'resize'` event.
     *
     * #### Notes
     * For this server application there is no shell to update
     */
    evtResize(event) {
        // no-op
    }
    /**
     * Register plugins from a plugin module.
     *
     * @param mod - The plugin module to register.
     */
    registerPluginModule(mod) {
        let data = mod.default;
        // Handle commonjs exports.
        if (!Object.prototype.hasOwnProperty.call(mod, '__esModule')) {
            data = mod;
        }
        if (!Array.isArray(data)) {
            data = [data];
        }
        data.forEach((item) => {
            try {
                this.registerPlugin(item);
            }
            catch (error) {
                console.error(error);
            }
        });
    }
    /**
     * Register the plugins from multiple plugin modules.
     *
     * @param mods - The plugin modules to register.
     */
    registerPluginModules(mods) {
        mods.forEach((mod) => {
            this.registerPluginModule(mod);
        });
    }
    _router = new _router__WEBPACK_IMPORTED_MODULE_3__.Router();
    _serviceManager;
}


/***/ }),

/***/ "../ui/packages/lite/server/lib/router.js":
/*!************************************************!*\
  !*** ../ui/packages/lite/server/lib/router.js ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Router": () => (/* binding */ Router)
/* harmony export */ });
/**
 * A simple router.
 */
class Router {
    /**
     * Add a new GET route
     *
     * @param pattern The pattern to match
     * @param callback The function to call on pattern match
     *
     */
    get(pattern, callback) {
        this._add('GET', pattern, callback);
    }
    /**
     * Add a new PUT route
     *
     * @param pattern The pattern to match
     * @param callback The function to call on pattern match
     *
     */
    put(pattern, callback) {
        this._add('PUT', pattern, callback);
    }
    /**
     * Add a new POST route
     *
     * @param pattern The pattern to match
     * @param callback The function to call on pattern match
     *
     */
    post(pattern, callback) {
        this._add('POST', pattern, callback);
    }
    /**
     * Add a new PATCH route
     *
     * @param pattern The pattern to match
     * @param callback The function to call on pattern match
     *
     */
    patch(pattern, callback) {
        this._add('PATCH', pattern, callback);
    }
    /**
     * Add a new DELETE route
     *
     * @param pattern The pattern to match
     * @param callback The function to call on pattern match
     *
     */
    delete(pattern, callback) {
        this._add('DELETE', pattern, callback);
    }
    /**
     * Route a request.
     *
     * @param req The request to route.
     */
    async route(req) {
        const url = new URL(req.url);
        const { method } = req;
        const { pathname } = url;
        for (const r of this._routes) {
            if (r.method !== method) {
                continue;
            }
            const match = pathname.match(r.pattern);
            if (!match) {
                continue;
            }
            const matches = match.slice(1);
            let body;
            if (r.method === 'PATCH' || r.method === 'PUT' || r.method === 'POST') {
                try {
                    body = JSON.parse(await req.text());
                }
                catch {
                    body = undefined;
                }
            }
            return r.callback.call(null, {
                pathname,
                body,
                query: Object.fromEntries(url.searchParams),
            }, ...matches);
        }
        throw new Error('Cannot route ' + req.method + ' ' + req.url);
    }
    /**
     * Add a new route.
     *
     * @param method The method
     * @param pattern The pattern
     * @param callback The callback
     */
    _add(method, pattern, callback) {
        if (typeof pattern === 'string') {
            pattern = new RegExp(pattern);
        }
        this._routes.push({
            method,
            pattern,
            callback,
        });
    }
    _routes = [];
}


/***/ }),

/***/ "../ui/packages/react/lib/components/cell/Cell.js":
/*!********************************************************!*\
  !*** ../ui/packages/react/lib/components/cell/Cell.js ***!
  \********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Cell": () => (/* binding */ Cell),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/cells */ "webpack/sharing/consume/default/@jupyterlab/cells");
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Box/Box.js");
/* harmony import */ var _CellState__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./CellState */ "../ui/packages/react/lib/components/cell/CellState.js");
/* harmony import */ var _CellAdapter__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./CellAdapter */ "../ui/packages/react/lib/components/cell/CellAdapter.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");









const DEFAULT_SOURCE = `from IPython.display import display

for i in range(10):
    display('String {} added to the DOM in separated DIV.'.format(i))`;
const Cell = (props) => {
    const { source, autoStart } = props;
    const { serverSettings, injectableStore, defaultKernel } = (0,_jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_4__.useJupyter)();
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_2__.useDispatch)();
    const [adapter, setAdapter] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => {
        injectableStore.inject('cell', _CellState__WEBPACK_IMPORTED_MODULE_5__.cellReducer);
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (source && defaultKernel) {
            const adapter = new _CellAdapter__WEBPACK_IMPORTED_MODULE_6__["default"](source, serverSettings, defaultKernel);
            dispatch(_CellState__WEBPACK_IMPORTED_MODULE_5__.cellActions.update({ adapter }));
            dispatch(_CellState__WEBPACK_IMPORTED_MODULE_5__.cellActions.source(props.source));
            adapter.codeCell.model.contentChanged.connect((cellModel, changedArgs) => {
                dispatch(_CellState__WEBPACK_IMPORTED_MODULE_5__.cellActions.source(cellModel.sharedModel.getSource()));
            });
            adapter.codeCell.outputArea.outputLengthChanged.connect((outputArea, outputsCount) => {
                dispatch(_CellState__WEBPACK_IMPORTED_MODULE_5__.cellActions.outputsCount(outputsCount));
            });
            adapter.sessionContext.initialize().then(() => {
                if (autoStart) {
                    const execute = _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCell.execute(adapter.codeCell, adapter.sessionContext);
                    execute.then((msg) => {
                        dispatch(_CellState__WEBPACK_IMPORTED_MODULE_5__.cellActions.update({
                            kernelAvailable: true,
                        }));
                    });
                }
            });
            setAdapter(adapter);
        }
    }, [source, defaultKernel]);
    return adapter
        ?
            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_7__["default"], { sx: {
                    '& .dla-JupyterCell': {
                        position: 'relative !important',
                        contain: 'content !important',
                        //            height: '100% !important',
                        //            marginTop: '30px',
                    },
                    '& .jp-Toolbar': {
                        height: 'auto !important',
                        position: 'relative',
                        //            display: 'none',
                    },
                    '& .lm-BoxPanel': {
                        //            height: 'auto !important',
                        //            minHeight: 'auto !important',
                        position: 'relative',
                    },
                    '& .jp-Cell': {
                        //            width: '100%',
                        //            height: '100% !important',
                        position: 'relative',
                    },
                    '& .jp-CodeCell': {
                        height: 'auto !important',
                        position: 'relative',
                        //            top: 'auto !important',
                    },
                    '& .jp-Cell-outputArea': {
                        paddingBottom: '30px',
                    },
                    '& .jp-CodeMirrorEditor': {
                        cursor: 'text !important',
                    },
                }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_8__["default"], { children: adapter.panel }) })
        :
            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_7__["default"], { children: "Loading Jupyter Cell..." });
};
Cell.defaultProps = {
    source: DEFAULT_SOURCE,
    autoStart: true,
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Cell);


/***/ }),

/***/ "../ui/packages/react/lib/components/cell/CellAdapter.js":
/*!***************************************************************!*\
  !*** ../ui/packages/react/lib/components/cell/CellAdapter.js ***!
  \***************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellAdapter": () => (/* binding */ CellAdapter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/commands */ "webpack/sharing/consume/default/@lumino/commands");
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_commands__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/cells */ "webpack/sharing/consume/default/@jupyterlab/cells");
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/codemirror */ "webpack/sharing/consume/default/@jupyterlab/codemirror");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @jupyterlab/completer */ "webpack/sharing/consume/default/@jupyterlab/completer");
/* harmony import */ var _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @jupyterlab/rendermime */ "webpack/sharing/consume/default/@jupyterlab/rendermime");
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @jupyter/ydoc */ "webpack/sharing/consume/default/@jupyter/ydoc");
/* harmony import */ var _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @jupyter-widgets/html-manager */ "../../../node_modules/@jupyter-widgets/html-manager/lib/index.js");
/* harmony import */ var _jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @jupyter-widgets/html-manager/lib/output_renderers */ "../../../node_modules/@jupyter-widgets/html-manager/lib/output_renderers.js");
/* harmony import */ var _jupyter_ipywidgets_IPyWidgetsClassicManager__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ../../jupyter/ipywidgets/IPyWidgetsClassicManager */ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsClassicManager.js");
/* harmony import */ var _CellCommands__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./CellCommands */ "../ui/packages/react/lib/components/cell/CellCommands.js");














class CellAdapter {
    _panel;
    _codeCell;
    _sessionContext;
    constructor(source, serverSettings, kernel) {
        const kernelManager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_8__.KernelManager({
            serverSettings
        });
        const sessionManager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_8__.SessionManager({
            serverSettings,
            kernelManager
        });
        const specsManager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_8__.KernelSpecManager({
            serverSettings
        });
        const kernelPreference = kernel
            ? {
                id: kernel.id,
                shouldStart: true,
                autoStartDefault: false,
            } : {
            shouldStart: true,
            autoStartDefault: true,
            name: 'python',
        };
        this._sessionContext = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.SessionContext({
            name: 'Jupyter React Cell',
            sessionManager,
            specsManager,
            kernelPreference
        });
        const themes = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorThemeRegistry();
        for (const theme of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorThemeRegistry.getDefaultThemes()) {
            themes.addTheme(theme);
        }
        const editorExtensions = () => {
            const registry = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorExtensionRegistry();
            for (const extensionFactory of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorExtensionRegistry.getDefaultExtensions({ themes })) {
                registry.addExtension(extensionFactory);
            }
            registry.addExtension({
                name: 'shared-model-binding',
                factory: options => {
                    const sharedModel = options.model.sharedModel;
                    return _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorExtensionRegistry.createImmutableExtension((0,_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.ybinding)({
                        ytext: sharedModel.ysource,
                        undoManager: sharedModel.undoManager ?? undefined,
                    }));
                }
            });
            return registry;
        };
        const languages = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorLanguageRegistry();
        // Register default languages.
        for (const language of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.EditorLanguageRegistry.getDefaultLanguages()) {
            languages.addLanguage(language);
        }
        // Add Jupyter Markdown flavor here to support code block highlighting.
        languages.addLanguage({
            name: 'ipythongfm',
            mime: 'text/x-ipythongfm',
            load: async () => {
                // TODO: add support for LaTeX
                const m = await __webpack_require__.e(/*! import() */ "vendors-node_modules_codemirror_lang-markdown_dist_index_js").then(__webpack_require__.bind(__webpack_require__, /*! @codemirror/lang-markdown */ "../../../node_modules/@codemirror/lang-markdown/dist/index.js"));
                return m.markdown({
                    codeLanguages: (info) => languages.findBest(info)
                });
            }
        });
        const mimeService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.CodeMirrorMimeTypeService(languages);
        const commands = new _lumino_commands__WEBPACK_IMPORTED_MODULE_1__.CommandRegistry();
        const useCapture = true;
        document.addEventListener('keydown', event => {
            commands.processKeydownEvent(event);
        }, useCapture);
        const rendermime = new _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_7__.RenderMimeRegistry({ initialFactories: _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_7__.standardRendererFactories });
        const iPyWidgetsClassicManager = new _jupyter_ipywidgets_IPyWidgetsClassicManager__WEBPACK_IMPORTED_MODULE_12__.IPyWidgetsClassicManager({ loader: _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_10__.requireLoader });
        rendermime.addFactory({
            safe: false,
            mimeTypes: [_jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_11__.WIDGET_MIMETYPE],
            createRenderer: (options) => new _jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_11__.WidgetRenderer(options, iPyWidgetsClassicManager),
        }, 0);
        const factoryService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_4__.CodeMirrorEditorFactory({
            extensions: editorExtensions(),
            languages
        });
        this._codeCell = new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCell({
            rendermime,
            model: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCellModel({
                sharedModel: (0,_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_9__.createStandaloneCell)({
                    cell_type: 'code',
                    source: source,
                    metadata: {}
                })
            }),
            contentFactory: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.Cell.ContentFactory({
                editorFactory: factoryService.newInlineEditor.bind(factoryService)
            }),
        });
        this._codeCell.addClass('dla-JupyterCell');
        this._codeCell.initializeState();
        this._sessionContext.kernelChanged.connect((sender, arg) => {
            const kernelConnection = arg.newValue;
            iPyWidgetsClassicManager.registerWithKernel(kernelConnection);
        });
        this._sessionContext.kernelChanged.connect(() => {
            void this._sessionContext.session?.kernel?.info.then(info => {
                const lang = info.language_info;
                const mimeType = mimeService.getMimeTypeByLanguage(lang);
                this._codeCell.model.mimeType = mimeType;
            });
        });
        const editor = this._codeCell.editor;
        const model = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.CompleterModel();
        const completer = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.Completer({ editor, model });
        const timeout = 1000;
        const provider = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.KernelCompleterProvider();
        const reconciliator = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.ProviderReconciliator({
            context: { widget: this._codeCell, editor, session: this._sessionContext.session },
            providers: [provider],
            timeout,
        });
        const handler = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.CompletionHandler({ completer, reconciliator });
        void this._sessionContext.ready.then(() => {
            const provider = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.KernelCompleterProvider();
            handler.reconciliator = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_6__.ProviderReconciliator({
                context: { widget: this._codeCell, editor, session: this._sessionContext.session },
                providers: [provider],
                timeout,
            });
        });
        handler.editor = editor;
        (0,_CellCommands__WEBPACK_IMPORTED_MODULE_13__["default"])(commands, this._codeCell, this._sessionContext, handler);
        completer.hide();
        completer.addClass('jp-Completer-Cell');
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.Widget.attach(completer, document.body);
        const toolbar = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.Toolbar();
        toolbar.addItem('spacer', _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.Toolbar.createSpacerItem());
        const runButton = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.ToolbarButton({
            icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_5__.runIcon,
            onClick: () => {
                _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCell.execute(this._codeCell, this._sessionContext);
            },
            tooltip: 'Run'
        });
        toolbar.addItem('run', runButton);
        toolbar.addItem('interrupt', _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.Toolbar.createInterruptButton(this._sessionContext));
        toolbar.addItem('restart', _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.Toolbar.createRestartButton(this._sessionContext));
        // toolbar.addItem('name', Toolbar.createKernelNameItem(this._sessionContext));
        toolbar.addItem('status', _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_2__.Toolbar.createKernelStatusItem(this._sessionContext));
        this._codeCell.outputsScrolled = false;
        this._codeCell.activate();
        this._panel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.BoxPanel();
        this._panel.direction = 'top-to-bottom';
        this._panel.spacing = 0;
        this._panel.addWidget(toolbar);
        this._panel.addWidget(this._codeCell);
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.BoxPanel.setStretch(toolbar, 0);
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.BoxPanel.setStretch(this._codeCell, 1);
        window.addEventListener('resize', () => {
            this._panel.update();
        });
        this._panel.update();
    }
    get panel() {
        return this._panel;
    }
    get codeCell() {
        return this._codeCell;
    }
    get sessionContext() {
        return this._sessionContext;
    }
    execute = () => {
        _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCell.execute(this._codeCell, this._sessionContext);
    };
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CellAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/cell/CellCommands.js":
/*!****************************************************************!*\
  !*** ../ui/packages/react/lib/components/cell/CellCommands.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellCommands": () => (/* binding */ CellCommands),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/cells */ "webpack/sharing/consume/default/@jupyterlab/cells");
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0__);

const cmdIds = {
    invoke: "completer:invoke",
    select: "completer:select",
};
const CellCommands = (commandRegistry, codeCell, sessionContext, completerHandler) => {
    commandRegistry.addCommand(cmdIds.invoke, {
        label: "Completer: Invoke",
        execute: () => completerHandler.invoke(),
    });
    commandRegistry.addCommand(cmdIds.select, {
        label: "Completer: Select",
        execute: () => completerHandler.completer.selectActive(),
    });
    commandRegistry.addCommand('run:cell', {
        execute: () => _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_0__.CodeCell.execute(codeCell, sessionContext)
    });
    commandRegistry.addKeyBinding({
        selector: '.jp-InputArea-editor.jp-mod-completer-enabled',
        keys: ['Tab'],
        command: cmdIds.invoke
    });
    commandRegistry.addKeyBinding({
        selector: '.jp-InputArea-editor',
        keys: ['Shift Enter'],
        command: 'run:cell'
    });
    const bindings = [
        {
            selector: `.jp-InputArea-editor.jp-mod-completer-active`,
            keys: ["Enter"],
            command: cmdIds.select,
        },
    ];
    bindings.map((binding) => commandRegistry.addKeyBinding(binding));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CellCommands);


/***/ }),

/***/ "../ui/packages/react/lib/components/cell/CellState.js":
/*!*************************************************************!*\
  !*** ../ui/packages/react/lib/components/cell/CellState.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellActionType": () => (/* binding */ CellActionType),
/* harmony export */   "cellActions": () => (/* binding */ cellActions),
/* harmony export */   "cellInitialState": () => (/* binding */ cellInitialState),
/* harmony export */   "cellReducer": () => (/* binding */ cellReducer),
/* harmony export */   "selectCell": () => (/* binding */ selectCell)
/* harmony export */ });
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const cellInitialState = {
    source: '',
    outputsCount: -1,
    kernelAvailable: false,
};
/* Selectors */
const selectCell = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_1__.useSelector)((state) => {
    if (state.cell) {
        return state.cell;
    }
    return cellInitialState;
});
/* Actions */
var CellActionType;
(function (CellActionType) {
    CellActionType["SOURCE"] = "cell/SOURCE";
    CellActionType["OUTPUTS_COUNT"] = "cell/OUTPUTS_COUNT";
    CellActionType["EXECUTE"] = "cell/EXECUTE";
    CellActionType["UPDATE"] = "cell/UPDATE";
})(CellActionType || (CellActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_0__["default"])('jupyterReact');
const cellActions = {
    source: actionCreator(CellActionType.SOURCE),
    outputsCount: actionCreator(CellActionType.OUTPUTS_COUNT),
    execute: actionCreator(CellActionType.EXECUTE),
    update: actionCreator(CellActionType.UPDATE),
};
/* Reducers */
const cellReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(cellInitialState)
    .case(cellActions.execute, (state, payload) => {
    if (state.adapter) {
        state.adapter.execute();
    }
    return {
        ...state,
    };
})
    .case(cellActions.source, (state, source) => {
    return {
        ...state,
        source,
    };
})
    .case(cellActions.update, (state, partial) => ({
    ...state,
    ...partial,
}))
    .case(cellActions.outputsCount, (state, outputsCount) => {
    return {
        ...state,
        outputsCount,
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/codemirror/CodeMirrorEditor.js":
/*!**************************************************************************!*\
  !*** ../ui/packages/react/lib/components/codemirror/CodeMirrorEditor.js ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CodeMirrorEditor": () => (/* binding */ CodeMirrorEditor),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var codemirror__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! codemirror */ "../../../node_modules/codemirror/dist/index.js");
/* harmony import */ var _codemirror_state__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @codemirror/state */ "webpack/sharing/consume/default/@codemirror/state");
/* harmony import */ var _codemirror_state__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_codemirror_state__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _codemirror_view__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @codemirror/view */ "webpack/sharing/consume/default/@codemirror/view");
/* harmony import */ var _codemirror_view__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_codemirror_view__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _codemirror_lang_python__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @codemirror/lang-python */ "../../../node_modules/@codemirror/lang-python/dist/index.js");
/* harmony import */ var _CodeMirrorTheme__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./CodeMirrorTheme */ "../ui/packages/react/lib/components/codemirror/CodeMirrorTheme.js");
/* harmony import */ var _CodeMirrorOutputToolbar__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./CodeMirrorOutputToolbar */ "../ui/packages/react/lib/components/codemirror/CodeMirrorOutputToolbar.js");
/* harmony import */ var _output_OutputState__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../output/OutputState */ "../ui/packages/react/lib/components/output/OutputState.js");










const CodeMirrorEditor = (props) => {
    const { code, codePre, outputAdapter, autoRun, disableRun, sourceId, toolbarPosition, insertText, kernel } = props;
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_2__.useDispatch)();
    const [view, setView] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    const dataset = (0,_output_OutputState__WEBPACK_IMPORTED_MODULE_5__.selectDataset)(sourceId);
    const setSource = (0,_output_OutputState__WEBPACK_IMPORTED_MODULE_5__.selectJupyterSetSource)(sourceId);
    const editorDiv = (0,react__WEBPACK_IMPORTED_MODULE_1__.useRef)();
    const setEditorSource = (source) => {
        if (view && source) {
            view.dispatch({
                changes: {
                    from: 0,
                    to: view.state.doc.length,
                    insert: source,
                }
            });
        }
    };
    const doInsertText = (payload) => {
        if (view && insertText) {
            view.dispatch({
                changes: {
                    from: 0,
                    insert: insertText(payload)
                }
            });
        }
    };
    const executeCode = (editorView, code) => {
        if (disableRun) {
            alert('Code execution is disabled for this editor. There should be a button on the page to run this editor.');
            return true;
        }
        if (code) {
            outputAdapter.execute(code);
        }
        else {
            outputAdapter.execute(editorView.state.doc.toString());
        }
        return true;
    };
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        dispatch(_output_OutputState__WEBPACK_IMPORTED_MODULE_5__.outputActions.source({
            sourceId,
            source: code,
        }));
        let editorView;
        const language = new _codemirror_state__WEBPACK_IMPORTED_MODULE_3__.Compartment();
        const keyBinding = [
            {
                key: 'Shift-Enter',
                run: () => executeCode(editorView),
                preventDefault: true,
            },
        ];
        const state = _codemirror_state__WEBPACK_IMPORTED_MODULE_3__.EditorState.create({
            doc: code,
            extensions: [
                codemirror__WEBPACK_IMPORTED_MODULE_6__.basicSetup,
                language.of((0,_codemirror_lang_python__WEBPACK_IMPORTED_MODULE_7__.python)()),
                _codemirror_view__WEBPACK_IMPORTED_MODULE_4__.EditorView.lineWrapping,
                _codemirror_view__WEBPACK_IMPORTED_MODULE_4__.keymap.of([...keyBinding]),
                _CodeMirrorTheme__WEBPACK_IMPORTED_MODULE_8__["default"],
                _codemirror_view__WEBPACK_IMPORTED_MODULE_4__.EditorView.updateListener.of((viewUpdate) => {
                    if (viewUpdate.docChanged) {
                        const source = viewUpdate.state.doc.toString();
                        dispatch(_output_OutputState__WEBPACK_IMPORTED_MODULE_5__.outputActions.source({
                            sourceId,
                            source,
                        }));
                    }
                })
            ],
        });
        editorView = new _codemirror_view__WEBPACK_IMPORTED_MODULE_4__.EditorView({
            state: state,
            parent: editorDiv.current,
        });
        setView(editorView);
        if (autoRun) {
            executeCode(editorView);
        }
        return () => {
            editorView.destroy();
        };
    }, [code]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        doInsertText(dataset?.dataset);
    }, [dataset]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        setEditorSource(setSource?.source);
    }, [setSource]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: [kernel && toolbarPosition === 'up' &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_CodeMirrorOutputToolbar__WEBPACK_IMPORTED_MODULE_9__["default"], { editorView: view, codePre: codePre, kernel: kernel, outputAdapter: outputAdapter, executeCode: executeCode }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { ref: editorDiv }), kernel && toolbarPosition === 'middle' &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_CodeMirrorOutputToolbar__WEBPACK_IMPORTED_MODULE_9__["default"], { editorView: view, codePre: codePre, kernel: kernel, outputAdapter: outputAdapter, executeCode: executeCode })] }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CodeMirrorEditor);


/***/ }),

/***/ "../ui/packages/react/lib/components/codemirror/CodeMirrorOutputToolbar.js":
/*!*********************************************************************************!*\
  !*** ../ui/packages/react/lib/components/codemirror/CodeMirrorOutputToolbar.js ***!
  \*********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CodeMirrorOutputToolbar": () => (/* binding */ CodeMirrorOutputToolbar),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ActionMenu.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Button/IconButton.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ActionList/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Box/Box.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ThemeProvider.js");
/* harmony import */ var _primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @primer/octicons-react */ "../../../node_modules/@primer/octicons-react/dist/index.esm.js");




const CodeMirrorOutputToolbarMenu = (props) => {
    const { executeCode, outputAdapter, editorView } = props;
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_2__.ActionMenu, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_2__.ActionMenu.Anchor, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.IconButton, { "aria-labelledby": "", icon: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.KebabHorizontalIcon, variant: "invisible" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_2__.ActionMenu.Overlay, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.Item, { onSelect: e => { e.preventDefault(); executeCode(editorView); }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.ArrowRightIcon, {}) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.TrailingVisual, { children: "\u21E7 \u21B5" }), "Run code"] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.Item, { onSelect: e => { e.preventDefault(); outputAdapter.interrupt(); }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.StopIcon, {}) }), "Interrupt kernel"] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.Item, { variant: "danger", onClick: e => { e.preventDefault(); outputAdapter.clearOutput(); }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.PaintbrushIcon, {}) }), "Clear outputs"] })] }) })] }));
};
const KernelStatus = ({ color }) => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__["default"], { sx: { backgroundColor: color, width: '14px', height: '14px', borderRadius: 3 } }));
const CodeMirrorOutputToolbar = (props) => {
    const { executeCode, editorView, kernel, codePre } = props;
    const { theme } = (0,_primer_react__WEBPACK_IMPORTED_MODULE_7__.useTheme)();
    const okColor = (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => theme?.colorSchemes.light.colors.success.muted, []);
    const nokColor = (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => theme?.colorSchemes.light.colors.severe.muted, []);
    const [kernelStatus, setKernelStatus] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)('unknown');
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (kernel) {
            kernel.connection.then((kernelConnection) => {
                if (codePre) {
                    executeCode(editorView, codePre);
                }
                setKernelStatus(kernelConnection.status);
                kernelConnection.statusChanged.connect((kernelConnection, status) => {
                    setKernelStatus(status);
                });
            });
        }
    }, [kernel]);
    const getKernelStatusColor = (status) => {
        if (status === "idle") {
            return okColor;
        }
        return nokColor;
    };
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_6__["default"], { display: "flex", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__["default"], { flexGrow: 1 }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__["default"], { sx: { paddingTop: '6px' }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(KernelStatus, { color: getKernelStatusColor(kernelStatus) }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__["default"], { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(CodeMirrorOutputToolbarMenu, { ...props }) })] }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CodeMirrorOutputToolbar);


/***/ }),

/***/ "../ui/packages/react/lib/components/codemirror/CodeMirrorTheme.js":
/*!*************************************************************************!*\
  !*** ../ui/packages/react/lib/components/codemirror/CodeMirrorTheme.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "codeMirrorTheme": () => (/* binding */ codeMirrorTheme),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _codemirror_view__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @codemirror/view */ "webpack/sharing/consume/default/@codemirror/view");
/* harmony import */ var _codemirror_view__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_codemirror_view__WEBPACK_IMPORTED_MODULE_0__);

const theme = _codemirror_view__WEBPACK_IMPORTED_MODULE_0__.EditorView.theme({
    "&": {
        fontSize: "9pt",
        border: "1px solid #c0c0c0"
    },
    ".cm-content": {
        fontFamily: "Menlo, Monaco, Lucida Console, monospace",
        minHeight: "10px"
    },
    ".cm-gutters": {
        minHeight: "10px"
    },
    ".cm-scroller": {
        overflow: "auto",
        //    maxHeight: "600px"
    }
}, { dark: false });
const codeMirrorTheme = [theme];
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (codeMirrorTheme);


/***/ }),

/***/ "../ui/packages/react/lib/components/commands/Commands.js":
/*!****************************************************************!*\
  !*** ../ui/packages/react/lib/components/commands/Commands.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Commands": () => (/* binding */ Commands),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _CommandsAdapter__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./CommandsAdapter */ "../ui/packages/react/lib/components/commands/CommandsAdapter.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");



const Commands = () => {
    const commandsAdapter = new _CommandsAdapter__WEBPACK_IMPORTED_MODULE_1__["default"]();
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__["default"], { children: commandsAdapter.panel });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Commands);


/***/ }),

/***/ "../ui/packages/react/lib/components/commands/CommandsAdapter.js":
/*!***********************************************************************!*\
  !*** ../ui/packages/react/lib/components/commands/CommandsAdapter.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/commands */ "webpack/sharing/consume/default/@lumino/commands");
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_commands__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_1__);



class CommandsAdapter {
    commandsPanel;
    constructor() {
        this.commandsPanel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.BoxPanel();
        this.commandsPanel.id = 'datalayer-jupyter-commands';
        this.commandsPanel.spacing = 0;
        // Initialize the command registry with the key bindings.
        const commands = new _lumino_commands__WEBPACK_IMPORTED_MODULE_0__.CommandRegistry();
        const palette = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.CommandPalette({ commands });
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.BoxPanel.setStretch(palette, 0);
        this.commandsPanel.addWidget(palette);
        // Handle resize events.
        window.addEventListener('resize', () => {
            this.commandsPanel.update();
        });
        const selector = '.jp-ConsolePanel';
        const category = 'Console';
        const command = 'console:execute';
        commands.addCommand(command, {
            label: 'Execute Cell',
            execute: () => {
                window.alert('Execute Cell');
            }
        });
        palette.addItem({ command, category });
        commands.addKeyBinding({ command, selector, keys: ['Shift Enter'] });
    }
    get panel() {
        return this.commandsPanel;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CommandsAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/commands/CommandsState.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/components/commands/CommandsState.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CommandsActionType": () => (/* binding */ CommandsActionType),
/* harmony export */   "commandsActions": () => (/* binding */ commandsActions),
/* harmony export */   "commandsInitialState": () => (/* binding */ commandsInitialState),
/* harmony export */   "commandsReducer": () => (/* binding */ commandsReducer),
/* harmony export */   "selectCommands": () => (/* binding */ selectCommands)
/* harmony export */ });
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const commandsInitialState = {
    outputs: 0
};
/* Selectors */
const selectCommands = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_1__.useSelector)((state) => {
    if (state.commands) {
        return state.commands;
    }
    return { outputs: 0 };
});
/* Actions */
var CommandsActionType;
(function (CommandsActionType) {
    CommandsActionType["OUTPUTS"] = "commands/OUTPUTS";
    CommandsActionType["EXECUTE"] = "commands/EXECUTE";
})(CommandsActionType || (CommandsActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_0__["default"])('jupyterReact');
const commandsActions = {
    outputs: actionCreator(CommandsActionType.OUTPUTS),
    execute: actionCreator(CommandsActionType.EXECUTE),
};
/* Reducers */
const commandsReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(commandsInitialState)
    .case(commandsActions.outputs, (state, success) => {
    return {
        ...state,
        outputs: success
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/console/Console.js":
/*!**************************************************************!*\
  !*** ../ui/packages/react/lib/components/console/Console.js ***!
  \**************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Console": () => (/* binding */ Console),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./../../jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");
/* harmony import */ var _ConsoleAdapter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./ConsoleAdapter */ "../ui/packages/react/lib/components/console/ConsoleAdapter.js");





const Console = () => {
    const { serviceManager } = (0,_jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.useJupyter)();
    if (!serviceManager) {
        return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: "Loading..." });
    }
    const consoleAdapter = new _ConsoleAdapter__WEBPACK_IMPORTED_MODULE_2__["default"](serviceManager);
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_3__["default"], { children: consoleAdapter.panel });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Console);


/***/ }),

/***/ "../ui/packages/react/lib/components/console/ConsoleAdapter.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/components/console/ConsoleAdapter.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/rendermime */ "webpack/sharing/consume/default/@jupyterlab/rendermime");
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/commands */ "webpack/sharing/consume/default/@lumino/commands");
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_commands__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/codemirror */ "webpack/sharing/consume/default/@jupyterlab/codemirror");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/console */ "webpack/sharing/consume/default/@jupyterlab/console");
/* harmony import */ var _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__);





class ConsoleAdapter {
    _panel;
    constructor(serviceManager) {
        this._panel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.BoxPanel();
        this._panel.direction = 'top-to-bottom';
        this._panel.spacing = 0;
        this._panel.addClass('dla-JupyterLab-Console');
        serviceManager.ready.then(() => {
            this.startConsole('console-path', serviceManager, this._panel);
        });
    }
    startConsole(path, serviceManager, panel) {
        const commands = new _lumino_commands__WEBPACK_IMPORTED_MODULE_1__.CommandRegistry();
        document.addEventListener('keydown', event => {
            commands.processKeydownEvent(event);
        });
        const themes = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorThemeRegistry();
        for (const theme of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorThemeRegistry.getDefaultThemes()) {
            themes.addTheme(theme);
        }
        const editorExtensions = () => {
            const registry = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorExtensionRegistry();
            for (const extensionFactory of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorExtensionRegistry.getDefaultExtensions({ themes })) {
                registry.addExtension(extensionFactory);
            }
            registry.addExtension({
                name: 'shared-model-binding',
                factory: options => {
                    const sharedModel = options.model.sharedModel;
                    return _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorExtensionRegistry.createImmutableExtension((0,_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.ybinding)({
                        ytext: sharedModel.ysource,
                        undoManager: sharedModel.undoManager ?? undefined
                    }));
                }
            });
            return registry;
        };
        const languages = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorLanguageRegistry();
        // Register default languages.
        for (const language of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.EditorLanguageRegistry.getDefaultLanguages()) {
            languages.addLanguage(language);
        }
        // Add Jupyter Markdown flavor here to support code block highlighting.
        languages.addLanguage({
            name: 'ipythongfm',
            mime: 'text/x-ipythongfm',
            load: async () => {
                // TODO: add support for LaTeX
                const m = await __webpack_require__.e(/*! import() */ "vendors-node_modules_codemirror_lang-markdown_dist_index_js").then(__webpack_require__.bind(__webpack_require__, /*! @codemirror/lang-markdown */ "../../../node_modules/@codemirror/lang-markdown/dist/index.js"));
                return m.markdown({
                    codeLanguages: (info) => languages.findBest(info)
                });
            }
        });
        const factoryService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.CodeMirrorEditorFactory({
            extensions: editorExtensions(),
            languages
        });
        const rendermime = new _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_0__.RenderMimeRegistry({ initialFactories: _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_0__.standardRendererFactories });
        const mimeTypeService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_2__.CodeMirrorMimeTypeService(languages);
        const editorFactory = factoryService.newInlineEditor;
        const contentFactory = new _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__.ConsolePanel.ContentFactory({ editorFactory });
        const consolePanel = new _jupyterlab_console__WEBPACK_IMPORTED_MODULE_4__.ConsolePanel({
            manager: serviceManager,
            rendermime,
            path,
            contentFactory,
            mimeTypeService,
            kernelPreference: {
                shouldStart: true,
                name: 'python',
                //        autoStartDefault: true,
            }
        });
        consolePanel.title.label = 'Console';
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.BoxPanel.setStretch(consolePanel, 1);
        panel.addWidget(consolePanel);
        window.addEventListener('resize', () => {
            panel.update();
        });
        const selector = '.jp-ConsolePanel';
        let command;
        command = 'console:clear';
        commands.addCommand(command, {
            label: 'Clear',
            execute: () => {
                consolePanel.console.clear();
            }
        });
        command = 'console:execute';
        commands.addCommand(command, {
            label: 'Execute Prompt',
            execute: () => {
                return consolePanel.console.execute();
            }
        });
        commands.addKeyBinding({ command, selector, keys: ['Enter'] });
        command = 'console:execute-forced';
        commands.addCommand(command, {
            label: 'Execute Cell (forced)',
            execute: () => {
                return consolePanel.console.execute(true);
            }
        });
        commands.addKeyBinding({ command, selector, keys: ['Shift Enter'] });
        command = 'console:linebreak';
        commands.addCommand(command, {
            label: 'Insert Line Break',
            execute: () => {
                consolePanel.console.insertLinebreak();
            }
        });
        commands.addKeyBinding({ command, selector, keys: ['Ctrl Enter'] });
    }
    get panel() {
        return this._panel;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (ConsoleAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/console/ConsoleState.js":
/*!*******************************************************************!*\
  !*** ../ui/packages/react/lib/components/console/ConsoleState.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ConsoleActionType": () => (/* binding */ ConsoleActionType),
/* harmony export */   "consoleActions": () => (/* binding */ consoleActions),
/* harmony export */   "consoleInitialState": () => (/* binding */ consoleInitialState),
/* harmony export */   "consoleReducer": () => (/* binding */ consoleReducer),
/* harmony export */   "selectConsole": () => (/* binding */ selectConsole)
/* harmony export */ });
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");


const consoleInitialState = {
    outputs: 0,
};
/* Selectors */
const selectConsole = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.console) {
        return state.console;
    }
    return { outputs: 0 };
});
/* Actions */

var ConsoleActionType;
(function (ConsoleActionType) {
    ConsoleActionType["OUTPUTS"] = "console/OUTPUTS";
    ConsoleActionType["EXECUTE"] = "console/EXECUTE";
})(ConsoleActionType || (ConsoleActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_2__["default"])('jupyterReact');
const consoleActions = {
    outputs: actionCreator(ConsoleActionType.OUTPUTS),
    execute: actionCreator(ConsoleActionType.EXECUTE),
};
/* Reducers */
const consoleReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_1__.reducerWithInitialState)(consoleInitialState)
    .case(consoleActions.outputs, (state, success) => {
    return {
        ...state,
        outputs: success
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/dialog/Dialog.js":
/*!************************************************************!*\
  !*** ../ui/packages/react/lib/components/dialog/Dialog.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Dialog": () => (/* binding */ Dialog),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyter_lumino_LuminoDetached__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../jupyter/lumino/LuminoDetached */ "../ui/packages/react/lib/jupyter/lumino/LuminoDetached.js");
/* harmony import */ var _DialogAdapter__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./DialogAdapter */ "../ui/packages/react/lib/components/dialog/DialogAdapter.js");




const Dialog = () => {
    const [dialogAdapter, _] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(new _DialogAdapter__WEBPACK_IMPORTED_MODULE_2__["default"]());
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        dialogAdapter.dialog.launch().then(success => success);
    }, []);
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_LuminoDetached__WEBPACK_IMPORTED_MODULE_3__["default"], { children: dialogAdapter.dialog });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Dialog);


/***/ }),

/***/ "../ui/packages/react/lib/components/dialog/DialogAdapter.js":
/*!*******************************************************************!*\
  !*** ../ui/packages/react/lib/components/dialog/DialogAdapter.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "DialogAdapter": () => (/* binding */ DialogAdapter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__);

class DialogAdapter {
    dialog;
    constructor() {
        this.dialog = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.Dialog({
            title: 'Dialog Title',
            body: 'This is the body of the dialog...',
            buttons: [
                _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.Dialog.cancelButton(),
                _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.Dialog.okButton(),
            ]
        });
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (DialogAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/filebrowser/FileBrowser.js":
/*!**********************************************************************!*\
  !*** ../ui/packages/react/lib/components/filebrowser/FileBrowser.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FileBrowser": () => (/* binding */ FileBrowser),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/TreeView/TreeView.js");
/* harmony import */ var _primer_octicons_react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @primer/octicons-react */ "../../../node_modules/@primer/octicons-react/dist/index.esm.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./../../jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _jupyter_services_Services__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./../../jupyter/services/Services */ "../ui/packages/react/lib/jupyter/services/Services.js");






const initialTree = {
    id: 'root',
    name: 'Jupyter Content',
};
const FileBrowser = () => {
    const [tree, setTree] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(initialTree);
    const [, forceUpdate] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useReducer)(x => x + 1, 0);
    const { serviceManager } = (0,_jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_2__.useJupyter)();
    const loadPath = (services, subTree, path) => {
        const loadFolderItems = (services, path) => {
            const folderItems = services
                .contents()
                .get(path.join('/'))
                .then(res => {
                const items = res.content.map((e) => {
                    if (e.type === 'directory') {
                        return {
                            id: 'folder_' + e.name,
                            name: e.name,
                            children: new Array(),
                        };
                    }
                    else {
                        return {
                            id: 'file_' + e.name,
                            name: e.name,
                        };
                    }
                });
                return items;
            });
            return folderItems;
        };
        loadFolderItems(services, path).then(folderItems => {
            subTree.children = folderItems;
            for (const child of subTree.children) {
                if (child.id.startsWith('folder_')) {
                    loadPath(services, child, path.concat(child.name));
                }
            }
            setTree(initialTree);
            forceUpdate();
        });
    };
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (serviceManager) {
            const services = new _jupyter_services_Services__WEBPACK_IMPORTED_MODULE_3__["default"](serviceManager);
            loadPath(services, initialTree, []);
        }
    }, [serviceManager]);
    const renderTree = (nodes) => {
        return nodes.map((node) => ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.Item, { id: node.id, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.LeadingVisual, { children: Array.isArray(node.children) ? ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.DirectoryIcon, {})) : ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_5__.FileIcon, {})) }), node.name, Array.isArray(node.children) && ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.SubTree, { children: renderTree(node.children) }))] })));
    };
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.Item, { id: tree.id, defaultExpanded: true, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.DirectoryIcon, {}) }), tree.name, Array.isArray(tree.children) && ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.TreeView.SubTree, { children: renderTree(tree.children) }))] }) }) }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (FileBrowser);


/***/ }),

/***/ "../ui/packages/react/lib/components/filebrowser/FileBrowserAdapter.js":
/*!*****************************************************************************!*\
  !*** ../ui/packages/react/lib/components/filebrowser/FileBrowserAdapter.js ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/commands */ "webpack/sharing/consume/default/@lumino/commands");
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_commands__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/algorithm */ "webpack/sharing/consume/default/@lumino/algorithm");
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_algorithm__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @jupyterlab/codemirror */ "webpack/sharing/consume/default/@jupyterlab/codemirror");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @jupyterlab/docmanager */ "webpack/sharing/consume/default/@jupyterlab/docmanager");
/* harmony import */ var _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @jupyterlab/docregistry */ "webpack/sharing/consume/default/@jupyterlab/docregistry");
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @jupyterlab/filebrowser */ "webpack/sharing/consume/default/@jupyterlab/filebrowser");
/* harmony import */ var _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @jupyterlab/fileeditor */ "webpack/sharing/consume/default/@jupyterlab/fileeditor");
/* harmony import */ var _jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_10___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_10__);
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_11___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_11__);













class FileBrowserAdapter {
    fileBrowserPanel;
    constructor() {
        this.fileBrowserPanel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.SplitPanel();
        this.fileBrowserPanel.id = 'dla-jlab-filebrowser';
        this.fileBrowserPanel.orientation = 'horizontal';
        this.fileBrowserPanel.spacing = 0;
        const manager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_4__.ServiceManager();
        void manager.ready.then(() => {
            createApp(manager, this.fileBrowserPanel);
        });
        function createApp(manager, panel) {
            const widgets = [];
            let activeWidget;
            const opener = {
                opened: new _lumino_signaling__WEBPACK_IMPORTED_MODULE_2__.Signal(this),
                open: (widget) => {
                    if (widgets.indexOf(widget) === -1) {
                        dock.addWidget(widget, { mode: 'tab-after' });
                        widgets.push(widget);
                    }
                    dock.activateWidget(widget);
                    activeWidget = widget;
                    widget.disposed.connect((w) => {
                        const index = widgets.indexOf(w);
                        widgets.splice(index, 1);
                    });
                }
            };
            const docRegistry = new _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_8__.DocumentRegistry();
            const docManager = new _jupyterlab_docmanager__WEBPACK_IMPORTED_MODULE_7__.DocumentManager({
                registry: docRegistry,
                manager,
                opener
            });
            const languages = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6__.EditorLanguageRegistry();
            _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6__.EditorLanguageRegistry.getDefaultLanguages()
                .filter(language => ['ipython', 'julia', 'python'].includes(language.name.toLowerCase()))
                .forEach(language => {
                languages.addLanguage(language);
            });
            // Language for Markdown cells
            languages.addLanguage({
                name: 'ipythongfm',
                mime: 'text/x-ipythongfm',
                load: async () => {
                    const m = await __webpack_require__.e(/*! import() */ "vendors-node_modules_codemirror_lang-markdown_dist_index_js").then(__webpack_require__.bind(__webpack_require__, /*! @codemirror/lang-markdown */ "../../../node_modules/@codemirror/lang-markdown/dist/index.js"));
                    return m.markdown({
                        codeLanguages: (info) => languages.findBest(info)
                    });
                }
            });
            const editorServices = {
                factoryService: new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6__.CodeMirrorEditorFactory(),
                mimeTypeService: new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_6__.CodeMirrorMimeTypeService(languages)
            };
            const wFactory = new _jupyterlab_fileeditor__WEBPACK_IMPORTED_MODULE_10__.FileEditorFactory({
                editorServices,
                factoryOptions: {
                    name: 'Editor',
                    modelName: 'text',
                    fileTypes: ['*'],
                    defaultFor: ['*'],
                    preferKernel: false,
                    canStartKernel: true
                }
            });
            docRegistry.addWidgetFactory(wFactory);
            const commands = new _lumino_commands__WEBPACK_IMPORTED_MODULE_0__.CommandRegistry();
            const fbModel = new _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_9__.FilterFileBrowserModel({
                manager: docManager
            });
            const fbWidget = new _jupyterlab_filebrowser__WEBPACK_IMPORTED_MODULE_9__.FileBrowser({
                id: 'filebrowser',
                model: fbModel
            });
            // Add a creator toolbar item.
            const creator = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5__.ToolbarButton({
                icon: _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_11__.addIcon,
                onClick: () => {
                    void docManager
                        .newUntitled({
                        type: 'file',
                        path: fbModel.path
                    })
                        .then(model => {
                        docManager.open(model.path);
                    });
                }
            });
            fbWidget.toolbar.insertItem(0, 'create', creator);
            panel.addWidget(fbWidget);
            _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.SplitPanel.setStretch(fbWidget, 0);
            const dock = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.DockPanel();
            panel.addWidget(dock);
            _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.SplitPanel.setStretch(dock, 1);
            dock.spacing = 8;
            document.addEventListener('focus', event => {
                for (let i = 0; i < widgets.length; i++) {
                    const widget = widgets[i];
                    if (widget.node.contains(event.target)) {
                        activeWidget = widget;
                        break;
                    }
                }
            });
            // Add commands.
            commands.addCommand('file-open', {
                label: 'Open',
                //        icon: 'fa fa-folder-open-o',
                mnemonic: 0,
                execute: () => {
                    (0,_lumino_algorithm__WEBPACK_IMPORTED_MODULE_1__.each)(fbWidget.selectedItems(), item => {
                        docManager.openOrReveal(item.path);
                    });
                }
            });
            commands.addCommand('file-rename', {
                label: 'Rename',
                //        icon: 'fa fa-edit',
                mnemonic: 0,
                execute: () => {
                    return fbWidget.rename();
                }
            });
            commands.addCommand('file-save', {
                execute: () => {
                    const context = docManager.contextForWidget(activeWidget);
                    return context?.save();
                }
            });
            commands.addCommand('file-cut', {
                label: 'Cut',
                //        icon: 'fa fa-cut',
                execute: () => {
                    fbWidget.cut();
                }
            });
            commands.addCommand('file-copy', {
                label: 'Copy',
                //        icon: 'fa fa-copy',
                mnemonic: 0,
                execute: () => {
                    fbWidget.copy();
                }
            });
            commands.addCommand('file-delete', {
                label: 'Delete',
                //        icon: 'fa fa-remove',
                mnemonic: 0,
                execute: () => {
                    return fbWidget.delete();
                }
            });
            commands.addCommand('file-duplicate', {
                label: 'Duplicate',
                //        icon: 'fa fa-copy',
                mnemonic: 0,
                execute: () => {
                    return fbWidget.duplicate();
                }
            });
            commands.addCommand('file-paste', {
                label: 'Paste',
                //        icon: 'fa fa-paste',
                mnemonic: 0,
                execute: () => {
                    return fbWidget.paste();
                }
            });
            commands.addCommand('file-download', {
                label: 'Download',
                //        icon: 'fa fa-download',
                execute: () => {
                    return fbWidget.download();
                }
            });
            commands.addCommand('file-shutdown-kernel', {
                label: 'Shut Down Kernel',
                //        icon: 'fa fa-stop-circle-o',
                execute: () => {
                    return fbWidget.shutdownKernels();
                }
            });
            commands.addCommand('file-dialog-demo', {
                label: 'Dialog Demo',
                execute: () => {
                    dialogDemo();
                }
            });
            commands.addCommand('file-info-demo', {
                label: 'Info Demo',
                execute: () => {
                    const msg = 'The quick brown fox jumped over the lazy dog';
                    void (0,_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5__.showDialog)({
                        title: 'Cool Title',
                        body: msg,
                        buttons: [_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5__.Dialog.okButton()]
                    });
                }
            });
            commands.addKeyBinding({
                keys: ['Enter'],
                selector: '.jp-DirListing',
                command: 'file-open'
            });
            commands.addKeyBinding({
                keys: ['Accel S'],
                selector: '.jp-CodeMirrorEditor',
                command: 'file-save'
            });
            window.addEventListener('keydown', event => {
                commands.processKeydownEvent(event);
            });
            // Create a context menu.
            const menu = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.Menu({ commands });
            menu.addItem({ command: 'file-open' });
            menu.addItem({ command: 'file-rename' });
            menu.addItem({ command: 'file-remove' });
            menu.addItem({ command: 'file-duplicate' });
            menu.addItem({ command: 'file-delete' });
            menu.addItem({ command: 'file-cut' });
            menu.addItem({ command: 'file-copy' });
            menu.addItem({ command: 'file-paste' });
            menu.addItem({ command: 'file-shutdown-kernel' });
            menu.addItem({ command: 'file-dialog-demo' });
            menu.addItem({ command: 'file-info-demo' });
            // Add a context menu to the dir listing.
            const node = fbWidget.node.getElementsByClassName('jp-DirListing-content')[0];
            node.addEventListener('contextmenu', (event) => {
                event.preventDefault();
                const x = event.clientX;
                const y = event.clientY;
                menu.open(x, y);
            });
            // Handle resize events.
            window.addEventListener('resize', () => {
                panel.update();
            });
        }
        /**
         * Create a non-functional dialog demo.
         */
        function dialogDemo() {
            const body = document.createElement('div');
            const input = document.createElement('input');
            input.value = 'Untitled.ipynb';
            const selector = document.createElement('select');
            const option0 = document.createElement('option');
            option0.value = 'python';
            option0.text = 'Python';
            selector.appendChild(option0);
            const option1 = document.createElement('option');
            option1.value = 'julia';
            option1.text = 'Julia';
            selector.appendChild(option1);
            body.appendChild(input);
            body.appendChild(selector);
            void (0,_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_5__.showDialog)({
                title: 'Create new notebook'
            });
        }
    }
    get panel() {
        return this.fileBrowserPanel;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (FileBrowserAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/filebrowser/FileBrowserLab.js":
/*!*************************************************************************!*\
  !*** ../ui/packages/react/lib/components/filebrowser/FileBrowserLab.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FileBrowserLab": () => (/* binding */ FileBrowserLab),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _FileBrowserAdapter__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./FileBrowserAdapter */ "../ui/packages/react/lib/components/filebrowser/FileBrowserAdapter.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");



const FileBrowserLab = () => {
    const fileBrowserAdapter = new _FileBrowserAdapter__WEBPACK_IMPORTED_MODULE_1__["default"]();
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__["default"], { children: fileBrowserAdapter.panel });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (FileBrowserLab);


/***/ }),

/***/ "../ui/packages/react/lib/components/filebrowser/FileBrowserState.js":
/*!***************************************************************************!*\
  !*** ../ui/packages/react/lib/components/filebrowser/FileBrowserState.js ***!
  \***************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "FileBrowserActionType": () => (/* binding */ FileBrowserActionType),
/* harmony export */   "fileBrowserActions": () => (/* binding */ fileBrowserActions),
/* harmony export */   "fileBrowserInitialState": () => (/* binding */ fileBrowserInitialState),
/* harmony export */   "fileBrowserReducer": () => (/* binding */ fileBrowserReducer),
/* harmony export */   "selectFileBrowser": () => (/* binding */ selectFileBrowser)
/* harmony export */ });
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const fileBrowserInitialState = {
    outputs: 0
};
/* Selectors */
const selectFileBrowser = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_1__.useSelector)((state) => {
    if (state.fileBrowser) {
        return state.fileBrowser;
    }
    return { outputs: 0 };
});
/* Actions */
var FileBrowserActionType;
(function (FileBrowserActionType) {
    FileBrowserActionType["OUTPUTS"] = "fileBrowser/OUTPUTS";
    FileBrowserActionType["EXECUTE"] = "fileBrowser/EXECUTE";
})(FileBrowserActionType || (FileBrowserActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_0__["default"])('jupyterReact');
const fileBrowserActions = {
    outputs: actionCreator(FileBrowserActionType.OUTPUTS),
    execute: actionCreator(FileBrowserActionType.EXECUTE),
};
/* Reducers */
const fileBrowserReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(fileBrowserInitialState)
    .case(fileBrowserActions.outputs, (state, success) => {
    return {
        ...state,
        outputs: success,
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/ipywidgets/IPyWidgetsOutput.js":
/*!**************************************************************************!*\
  !*** ../ui/packages/react/lib/components/ipywidgets/IPyWidgetsOutput.js ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "IPyWidgetsOutput": () => (/* binding */ IPyWidgetsOutput),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _jupyter_lumino_IPyWidgetsAttached__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../jupyter/lumino/IPyWidgetsAttached */ "../ui/packages/react/lib/jupyter/lumino/IPyWidgetsAttached.js");



const IPyWidgetsOutput = (props) => {
    const { view, state } = props;
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_IPyWidgetsAttached__WEBPACK_IMPORTED_MODULE_1__["default"], { view: view, state: state }) }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (IPyWidgetsOutput);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/Notebook.js":
/*!****************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/Notebook.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Notebook": () => (/* binding */ Notebook),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-dom */ "webpack/sharing/consume/default/react-dom");
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Box/Box.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./../../jupyter/utils/Ids */ "../ui/packages/react/lib/jupyter/utils/Ids.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");
/* harmony import */ var _jupyter_lumino_LuminoObservable__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./../../jupyter/lumino/LuminoObservable */ "../ui/packages/react/lib/jupyter/lumino/LuminoObservable.js");
/* harmony import */ var _cell_metadata_CellMetadataEditor__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./cell/metadata/CellMetadataEditor */ "../ui/packages/react/lib/components/notebook/cell/metadata/CellMetadataEditor.js");
/* harmony import */ var _NotebookAdapter__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./NotebookAdapter */ "../ui/packages/react/lib/components/notebook/NotebookAdapter.js");
/* harmony import */ var _NotebookState__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./NotebookState */ "../ui/packages/react/lib/components/notebook/NotebookState.js");













/**
 * This component creates a Notebook as a collection of snippets
 * with sidebars.
 *
 * @param props The notebook properties.
 * @returns A Notebook React.js component.
 */
const Notebook = (props) => {
    const { serviceManager, defaultKernel, kernelManager, injectableStore } = (0,_jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_4__.useJupyter)();
    const { kernel, readOnly, nbgrader, uid: propsUid, height, maxHeight } = props;
    const [uid] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(propsUid || (0,_jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_5__.newUuid)());
    const effectiveKernel = kernel || defaultKernel;
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_3__.useDispatch)();
    const portals = (0,_NotebookState__WEBPACK_IMPORTED_MODULE_6__.selectNotebookPortals)(uid);
    const [adapter, setAdapter] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        injectableStore.inject('notebook', _NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookReducer, _NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookEpics);
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (uid && serviceManager && kernelManager && effectiveKernel) {
            const adapter = new _NotebookAdapter__WEBPACK_IMPORTED_MODULE_7__["default"]({
                ...props,
                kernel: effectiveKernel,
                uid,
            }, injectableStore, serviceManager);
            setAdapter(adapter);
            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.update({ uid, partialState: { adapter } }));
            adapter.serviceManager.ready.then(() => {
                if (!readOnly) {
                    const activeCell = adapter.notebookPanel.content.activeCell;
                    if (activeCell) {
                        dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.activeCellChange({ uid, cellModel: activeCell }));
                    }
                    const activeCellChanged$ = (0,_jupyter_lumino_LuminoObservable__WEBPACK_IMPORTED_MODULE_8__.asObservable)(adapter.notebookPanel.content.activeCellChanged);
                    activeCellChanged$.subscribe((cellModel) => {
                        dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.activeCellChange({ uid, cellModel }));
                        const panelDiv = document.getElementById('right-panel-id');
                        if (panelDiv) {
                            const cellMetadataOptions = ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_9__["default"], { mt: 3, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_cell_metadata_CellMetadataEditor__WEBPACK_IMPORTED_MODULE_10__["default"], { notebookId: uid, cell: cellModel, nbgrader: nbgrader }) }));
                            const portal = (0,react_dom__WEBPACK_IMPORTED_MODULE_2__.createPortal)(cellMetadataOptions, panelDiv);
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.setPortalDisplay({ uid, portalDisplay: { portal, pinned: false } }));
                        }
                    });
                }
                adapter.notebookPanel?.model?.contentChanged.connect((notebookModel, _) => {
                    dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.modelChange({ uid, notebookModel }));
                });
                /*
                adapter.notebookPanel?.model!.sharedModel.changed.connect((_, notebookChange) => {
                  dispatch(notebookActions.notebookChange({ uid, notebookChange }));
                });
                adapter.notebookPanel?.content.modelChanged.connect((notebook, _) => {
                  dispatÅch(notebookActions.notebookChange({ uid, notebook }));
                });
                */
                adapter.notebookPanel?.content.activeCellChanged.connect((_, cellModel) => {
                    if (cellModel === null) {
                        dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.activeCellChange({ uid, cellModel: undefined }));
                    }
                    else {
                        dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.activeCellChange({ uid, cellModel }));
                    }
                });
                adapter.notebookPanel?.sessionContext.statusChanged.connect((_, kernelStatus) => {
                    dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.kernelStatusChanged({ uid, kernelStatus }));
                });
            });
            return () => {
                adapter.dispose();
                setAdapter(undefined);
                dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.setPortalDisplay({ uid, portalDisplay: undefined }));
                dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_6__.notebookActions.dispose(uid));
            };
        }
    }, [uid, serviceManager, kernelManager, effectiveKernel]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)("div", { style: { height, width: '100%', position: "relative" }, id: "dla-Jupyter-Notebook", children: [props.Toolbar && (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(props.Toolbar, { notebookId: props.uid }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_9__["default"], { className: "box-notebook", sx: {
                    '& .dla-Jupyter-Notebook': {
                        height,
                        maxHeight,
                        width: '100%',
                        overflowY: 'hidden',
                    },
                    '& .jp-Notebook': {
                        flex: '1 1 auto !important',
                        height: '100%',
                        overflowY: 'scroll',
                    },
                    '& .jp-NotebookPanel': {
                        height: '100% !important',
                        width: "100% !important",
                    },
                    '& .jp-Toolbar': {
                        display: 'none',
                        zIndex: 0,
                    },
                    '& .jp-Toolbar .jp-HTMLSelect.jp-DefaultStyle select': {
                        fontSize: '14px',
                    },
                    '& .jp-Toolbar > .jp-Toolbar-responsive-opener': {
                        display: 'none',
                    },
                    '& .jp-Toolbar-kernelName': {
                        display: 'none',
                    },
                    '& .jp-Cell': {
                        width: `calc(100% - ${props.cellSidebarMargin}px)`,
                    },
                    '& .jp-Notebook-footer': {
                        width: `calc(100% - ${props.cellSidebarMargin + 82}px)`,
                    },
                    '& .jp-Cell .jp-CellHeader': {
                        position: 'absolute',
                        top: '-5px',
                        left: `${props.cellSidebarMargin + 10}px`,
                        height: 'auto',
                    },
                    '& .jp-Cell .dla-CellHeader-Container': {
                        padding: '4px 8px',
                        width: `${props.cellSidebarMargin + 10}px`,
                        marginLeft: 'auto',
                    },
                    '& .jp-CodeMirrorEditor': {
                        cursor: 'text !important',
                    },
                    '.box-notebook': {
                        position: 'relative',
                    },
                }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: portals?.map((portal) => portal) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_9__["default"], { children: adapter &&
                            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_11__["default"], { children: adapter.panel }) })] })] }));
};
Notebook.defaultProps = {
    ipywidgets: 'classic',
    readOnly: false,
    nbgrader: false,
    cellMetadataPanel: false,
    cellSidebarMargin: 120,
    height: '100vh',
    maxHeight: '100vh',
    renderers: [],
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Notebook);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/NotebookAdapter.js":
/*!***********************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/NotebookAdapter.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NotebookAdapter": () => (/* binding */ NotebookAdapter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/commands */ "webpack/sharing/consume/default/@lumino/commands");
/* harmony import */ var _lumino_commands__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_commands__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/docregistry */ "webpack/sharing/consume/default/@jupyterlab/docregistry");
/* harmony import */ var _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/rendermime */ "webpack/sharing/consume/default/@jupyterlab/rendermime");
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/json-extension */ "webpack/sharing/consume/default/@jupyterlab/json-extension");
/* harmony import */ var _jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyterlab/javascript-extension */ "webpack/sharing/consume/default/@jupyterlab/javascript-extension");
/* harmony import */ var _jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @jupyterlab/codemirror */ "webpack/sharing/consume/default/@jupyterlab/codemirror");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @jupyterlab/completer */ "webpack/sharing/consume/default/@jupyterlab/completer");
/* harmony import */ var _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @jupyterlab/mathjax-extension */ "webpack/sharing/consume/default/@jupyterlab/mathjax-extension");
/* harmony import */ var _jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @jupyter-widgets/html-manager */ "../../../node_modules/@jupyter-widgets/html-manager/lib/index.js");
/* harmony import */ var _jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @jupyter-widgets/html-manager/lib/output_renderers */ "../../../node_modules/@jupyter-widgets/html-manager/lib/output_renderers.js");
/* harmony import */ var _content_JupyterReactContentFactory__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./content/JupyterReactContentFactory */ "../ui/packages/react/lib/components/notebook/content/JupyterReactContentFactory.js");
/* harmony import */ var _model_JupyterReactNotebookModelFactory__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./model/JupyterReactNotebookModelFactory */ "../ui/packages/react/lib/components/notebook/model/JupyterReactNotebookModelFactory.js");
/* harmony import */ var _NotebookCommands__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./NotebookCommands */ "../ui/packages/react/lib/components/notebook/NotebookCommands.js");
/* harmony import */ var _jupyter_ipywidgets_IPyWidgetsClassicManager__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./../../jupyter/ipywidgets/IPyWidgetsClassicManager */ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsClassicManager.js");
/* harmony import */ var _jupyter_ipywidgets_IPyWidgetsJupyterLabPlugin__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./../../jupyter/ipywidgets/IPyWidgetsJupyterLabPlugin */ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsJupyterLabPlugin.js");
/* harmony import */ var _marked_marked__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./marked/marked */ "../ui/packages/react/lib/components/notebook/marked/marked.js");


















// import { activatePlotlyWidgetExtension } from "./../../jupyter/ipywidgets/plotly/JupyterlabPlugin";
class NotebookAdapter {
    _boxPanel;
    _notebookPanel;
    _uid;
    _serviceManager;
    _commandRegistry;
    _path;
    _nbformat;
    _tracker;
    _kernel;
    _store;
    _ipywidgets;
    _iPyWidgetsClassicManager;
    _CellSidebar;
    _nbgrader;
    //  private _readOnly: boolean;
    _context;
    _renderers;
    _rendermime;
    constructor(props, store, serviceManager) {
        this._path = props.path;
        this._store = store;
        this._serviceManager = serviceManager;
        this._nbformat = props.nbformat;
        this._CellSidebar = props.CellSidebar;
        this._nbgrader = props.nbgrader;
        //    this._readOnly = props.readOnly;
        this._ipywidgets = props.ipywidgets;
        this._kernel = props.kernel;
        this._uid = props.uid;
        this._renderers = props.renderers;
        this._boxPanel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.BoxPanel();
        this._boxPanel.addClass('dla-Jupyter-Notebook');
        this._boxPanel.spacing = 0;
        this._commandRegistry = new _lumino_commands__WEBPACK_IMPORTED_MODULE_0__.CommandRegistry();
        //    this.loadNotebook = this.loadNotebook.bind(this);
        this.loadNotebook();
    }
    loadNotebook() {
        const useCapture = true;
        document.addEventListener('keydown', event => { this._commandRegistry?.processKeydownEvent(event); }, useCapture);
        const rendererFactories = _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_3__.standardRendererFactories.filter(factory => factory.mimeTypes[0] !== 'text/javascript');
        rendererFactories.push(_jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_4__.rendererFactory);
        rendererFactories.push(_jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_5__.rendererFactory);
        this._renderers.map(renderer => rendererFactories.push(renderer));
        const languages = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorLanguageRegistry();
        // Register default languages.
        for (const language of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorLanguageRegistry.getDefaultLanguages()) {
            languages.addLanguage(language);
        }
        // Add Jupyter Markdown flavor here to support code block highlighting.
        languages.addLanguage({
            name: 'ipythongfm',
            mime: 'text/x-ipythongfm',
            load: async () => {
                // TODO: add support for LaTeX
                const m = await __webpack_require__.e(/*! import() */ "vendors-node_modules_codemirror_lang-markdown_dist_index_js").then(__webpack_require__.bind(__webpack_require__, /*! @codemirror/lang-markdown */ "../../../node_modules/@codemirror/lang-markdown/dist/index.js"));
                return m.markdown({
                    codeLanguages: (info) => languages.findBest(info)
                });
            }
        });
        this._rendermime = new _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_3__.RenderMimeRegistry({
            initialFactories: rendererFactories,
            latexTypesetter: new _jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_9__.MathJaxTypesetter(),
            markdownParser: (0,_marked_marked__WEBPACK_IMPORTED_MODULE_12__["default"])(languages),
        });
        const documentRegistry = new _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__.DocumentRegistry({});
        const mimeTypeService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.CodeMirrorMimeTypeService(languages);
        const themes = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorThemeRegistry();
        for (const theme of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorThemeRegistry.getDefaultThemes()) {
            themes.addTheme(theme);
        }
        const editorExtensions = () => {
            const registry = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorExtensionRegistry();
            for (const extensionFactory of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorExtensionRegistry.getDefaultExtensions({ themes })) {
                registry.addExtension(extensionFactory);
            }
            registry.addExtension({
                name: 'shared-model-binding',
                factory: options => {
                    const sharedModel = options.model.sharedModel;
                    return _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.EditorExtensionRegistry.createImmutableExtension((0,_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.ybinding)({
                        ytext: sharedModel.ysource,
                        undoManager: sharedModel.undoManager ?? undefined
                    }));
                }
            });
            return registry;
        };
        const factoryService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_7__.CodeMirrorEditorFactory({
            extensions: editorExtensions(),
            languages
        });
        const editorServices = {
            factoryService,
            mimeTypeService,
        };
        const editorFactory = editorServices.factoryService.newInlineEditor;
        const contentFactory = this._CellSidebar
            ?
                new _content_JupyterReactContentFactory__WEBPACK_IMPORTED_MODULE_13__["default"](this._CellSidebar, this._uid, this._nbgrader, this._commandRegistry, { editorFactory }, this._store)
            :
                new _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6__.NotebookPanel.ContentFactory({ editorFactory });
        this._tracker = new _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6__.NotebookTracker({ namespace: this._uid });
        switch (this._ipywidgets) {
            case 'classic': {
                this._iPyWidgetsClassicManager = new _jupyter_ipywidgets_IPyWidgetsClassicManager__WEBPACK_IMPORTED_MODULE_14__.IPyWidgetsClassicManager({ loader: _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_10__.requireLoader });
                this._rendermime.addFactory({
                    safe: false,
                    mimeTypes: [_jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_11__.WIDGET_MIMETYPE],
                    createRenderer: (options) => new _jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_11__.WidgetRenderer(options, this._iPyWidgetsClassicManager),
                }, 1);
                break;
            }
            case 'lab': {
                (0,_jupyter_ipywidgets_IPyWidgetsJupyterLabPlugin__WEBPACK_IMPORTED_MODULE_15__.activateWidgetExtension)(this._rendermime, this._tracker, null, null);
                //        activatePlotlyWidgetExtension(widgetRegistry);
                break;
            }
        }
        const notebookWidgetFactory = new _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6__.NotebookWidgetFactory({
            name: 'Notebook',
            modelName: 'notebook',
            fileTypes: ['notebook'],
            defaultFor: ['notebook'],
            preferKernel: true,
            canStartKernel: false,
            rendermime: this._rendermime,
            contentFactory,
            mimeTypeService: editorServices.mimeTypeService,
        });
        notebookWidgetFactory.widgetCreated.connect((sender, notebookPanel) => {
            notebookPanel.context.pathChanged.connect(() => {
                void this._tracker?.save(notebookPanel);
            });
            void this._tracker?.add(notebookPanel);
        });
        documentRegistry.addWidgetFactory(notebookWidgetFactory);
        const notebookModelFactory = new _model_JupyterReactNotebookModelFactory__WEBPACK_IMPORTED_MODULE_16__["default"]({
            nbformat: this._nbformat,
        });
        documentRegistry.addModelFactory(notebookModelFactory);
        this._context = new _jupyterlab_docregistry__WEBPACK_IMPORTED_MODULE_2__.Context({
            manager: this._serviceManager,
            factory: notebookModelFactory,
            path: this._path || "ping.ipynb",
            kernelPreference: {
                //        id: this.kernel?.kernelId,
                shouldStart: false,
                autoStartDefault: false,
                shutdownOnDispose: false,
            }
        });
        /*
        const content = new Notebook({
          rendermime: this._rendermime,
          contentFactory,
          mimeTypeService,
          notebookConfig: {
            ...StaticNotebook.defaultNotebookConfig,
            windowingMode: 'none'
          }
        });
        this._notebookPanel = new NotebookPanel({
          context: this._context,
          content,
        })
        */
        this._notebookPanel = documentRegistry.getWidgetFactory('Notebook')?.createNew(this._context);
        if (this._ipywidgets === 'classic') {
            this._notebookPanel.sessionContext.kernelChanged.connect((sender, args) => {
                this._iPyWidgetsClassicManager?.registerWithKernel(args.newValue);
            });
        }
        const isNew = ((this._path !== undefined) && (this._path !== "")) ? false : true;
        this._context.initialize(isNew).then(() => {
            if (this._kernel) {
                //     this._kernel.getJupyterKernel().then(kernelConnection => {
                this.changeKernel(this._kernel);
                //     });
            }
        });
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.BoxPanel.setStretch(this._notebookPanel, 0);
        this._boxPanel.addWidget(this._notebookPanel);
        window.addEventListener('resize', () => {
            this._notebookPanel?.update();
        });
        //    const tracker = this._tracker;
        function getCurrent(args) {
            //      const widget = tracker.currentWidget;
            return this._tracker.currentWidget;
        }
        function isEnabled() {
            return (
            //        this._tracker.currentWidget !== null
            this._tracker.currentWidget !== null);
        }
        this._commandRegistry.addCommand('run-selected-codecell', {
            label: 'Run Cell',
            execute: args => {
                const current = getCurrent(args);
                if (current) {
                    const { context, content } = current;
                    _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_6__.NotebookActions.run(content, context.sessionContext);
                }
            },
            isEnabled,
        });
    }
    setNbformat(nbformat) {
        this._nbformat = nbformat;
        if (this._nbformat) {
            this._notebookPanel?.model?.fromJSON(nbformat);
        }
    }
    setupCompleter(notebookPanel) {
        const editor = notebookPanel.content.activeCell && notebookPanel.content.activeCell.editor;
        const sessionContext = notebookPanel.context.sessionContext;
        const completerModel = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.CompleterModel();
        const completer = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.Completer({ editor, model: completerModel });
        const completerTimeout = 1000;
        const provider = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.KernelCompleterProvider();
        const reconciliator = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.ProviderReconciliator({
            context: {
                widget: notebookPanel,
                editor,
                session: sessionContext.session
            },
            providers: [provider],
            timeout: completerTimeout,
        });
        const handler = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.CompletionHandler({ completer, reconciliator });
        void sessionContext.ready.then(() => {
            const provider = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.KernelCompleterProvider();
            const reconciliator = new _jupyterlab_completer__WEBPACK_IMPORTED_MODULE_8__.ProviderReconciliator({
                context: { widget: this._notebookPanel, editor, session: sessionContext.session },
                providers: [provider],
                timeout: completerTimeout,
            });
            handler.reconciliator = reconciliator;
        });
        handler.editor = editor;
        notebookPanel.content.activeCellChanged.connect((sender, snippet) => {
            handler.editor = snippet && snippet.editor;
        });
        completer.hide();
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_1__.Widget.attach(completer, document.body);
        return handler;
    }
    changeKernel(kernel) {
        this._kernel = kernel;
        this._kernel.connection.then(kernelConnection => {
            this._context?.sessionContext.changeKernel(kernelConnection.model).then(() => {
                const completerHandler = this.setupCompleter(this._notebookPanel);
                (0,_NotebookCommands__WEBPACK_IMPORTED_MODULE_17__.NotebookCommands)(this._commandRegistry, this._notebookPanel, completerHandler, this._path);
                this._iPyWidgetsClassicManager?.registerWithKernel(kernelConnection);
                (0,_jupyter_ipywidgets_IPyWidgetsJupyterLabPlugin__WEBPACK_IMPORTED_MODULE_15__.activateWidgetExtension)(this._rendermime, this._tracker, null, null);
                // activatePlotlyWidgetExtension(widgetRegistry);
            });
        });
    }
    get uid() {
        return this._uid;
    }
    get notebookPanel() {
        return this._notebookPanel;
    }
    get commands() {
        return this._commandRegistry;
    }
    get panel() {
        return this._boxPanel;
    }
    get serviceManager() {
        return this._serviceManager;
    }
    setDefaultCellType = (cellType) => {
        this._notebookPanel.content.notebookConfig.defaultCell = cellType;
    };
    changeCellType = (cellType) => {
        //    NotebookActions.changeCellType(this._notebookPanel?.content!, cellType);
        this.doChangeCellType(this._notebookPanel?.content, cellType);
    };
    doChangeCellType(notebook, value) {
        const notebookSharedModel = notebook.model.sharedModel;
        notebook.widgets.forEach((child, index) => {
            if (!notebook.isSelectedOrActive(child)) {
                return;
            }
            if (child.model.type !== value) {
                const raw = child.model.toJSON();
                notebookSharedModel.transact(() => {
                    notebookSharedModel.deleteCell(index);
                    const newCell = notebookSharedModel.insertCell(index, {
                        cell_type: value,
                        source: raw.source,
                        metadata: raw.metadata
                    });
                    if (raw.attachments && ['markdown', 'raw'].includes(value)) {
                        newCell.attachments =
                            raw.attachments;
                    }
                });
            }
            if (value === 'markdown') {
                // Fetch the new widget and unrender it.
                child = notebook.widgets[index];
                child.rendered = false;
            }
        });
        notebook.deselectAll();
    }
    dispose = () => {
        //    this._context?.dispose();
        //    this._notebookPanel?.dispose();
    };
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (NotebookAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/NotebookCommands.js":
/*!************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/NotebookCommands.js ***!
  \************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NotebookCommands": () => (/* binding */ NotebookCommands),
/* harmony export */   "cmdIds": () => (/* binding */ cmdIds),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_documentsearch__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/documentsearch */ "webpack/sharing/consume/default/@jupyterlab/documentsearch");
/* harmony import */ var _jupyterlab_documentsearch__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_documentsearch__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyterlab_translation__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/translation */ "webpack/sharing/consume/default/@jupyterlab/translation");
/* harmony import */ var _jupyterlab_translation__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_translation__WEBPACK_IMPORTED_MODULE_4__);





/**
 * The map of command ids used by the notebook.
 */
const cmdIds = {
    invoke: "completer:invoke",
    select: "completer:select",
    invokeNotebook: "completer:invoke-notebook",
    selectNotebook: "completer:select-notebook",
    startSearch: "documentsearch:start-search",
    findNext: "documentsearch:find-next",
    findPrevious: "documentsearch:find-previous",
    save: "notebook:save",
    interrupt: "notebook:interrupt-kernel",
    restart: "notebook:restart-kernel",
    switchKernel: "notebook:switch-kernel",
    runAndAdvance: "notebook-cells:run-and-advance",
    run: "notebook:run-cell",
    runAll: "notebook:run-all",
    deleteCells: "notebook-cells:delete",
    insertAbove: "notebook-cells:insert-above",
    insertBelow: "notebook-cells:insert-below",
    deleteCell: "notebook-cells:delete",
    selectAbove: "notebook-cells:select-above",
    selectBelow: "notebook-cells:select-below",
    extendAbove: "notebook-cells:extend-above",
    extendTop: "notebook-cells:extend-top",
    extendBelow: "notebook-cells:extend-below",
    extendBottom: "notebook-cells:extend-bottom",
    editMode: "notebook:edit-mode",
    merge: "notebook-cells:merge",
    split: "notebook-cells:split",
    commandMode: "notebook:command-mode",
    undo: "notebook-cells:undo",
    redo: "notebook-cells:redo",
    changeCellType: "notebook-cell:change-cell-type",
    toCode: "notebook-cell:to-code",
};
const NotebookCommands = (commandRegistry, notebookPanel, completerHandler, path) => {
    // Add commands.
    commandRegistry.addCommand(cmdIds.invoke, {
        label: "Completer: Invoke",
        execute: () => completerHandler.invoke(),
    });
    commandRegistry.addCommand(cmdIds.select, {
        label: "Completer: Select",
        execute: () => completerHandler.completer.selectActive(),
    });
    commandRegistry.addCommand(cmdIds.invokeNotebook, {
        label: "Invoke Notebook",
        execute: () => {
            if (notebookPanel.content.activeCell?.model.type === "code") {
                return commandRegistry.execute(cmdIds.invoke);
            }
        },
    });
    commandRegistry.addCommand(cmdIds.selectNotebook, {
        label: "Select Notebook",
        execute: () => {
            if (notebookPanel.content.activeCell?.model.type === "code") {
                return commandRegistry.execute(cmdIds.select);
            }
        },
    });
    if (path) {
        commandRegistry.addCommand(cmdIds.save, {
            label: "Save",
            execute: () => notebookPanel.context.save(),
        });
    }
    let searchInstance;
    commandRegistry.addCommand(cmdIds.startSearch, {
        label: 'Find…',
        execute: () => {
            if (!searchInstance) {
                const provider = new _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookSearchProvider(notebookPanel, _jupyterlab_translation__WEBPACK_IMPORTED_MODULE_4__.nullTranslator);
                const searchModel = new _jupyterlab_documentsearch__WEBPACK_IMPORTED_MODULE_2__.SearchDocumentModel(provider, 500);
                searchInstance = new _jupyterlab_documentsearch__WEBPACK_IMPORTED_MODULE_2__.SearchDocumentView(searchModel);
                /**
                 * Activate the target widget when the search panel is closing
                 */
                searchInstance.closed.connect(() => {
                    if (!notebookPanel.isDisposed) {
                        notebookPanel.activate();
                    }
                });
                searchInstance.disposed.connect(() => {
                    if (!notebookPanel.isDisposed) {
                        notebookPanel.activate();
                    }
                    // find next and previous are now disabled
                    commandRegistry.notifyCommandChanged();
                });
                /**
                 * Dispose resources when the widget is disposed.
                 */
                notebookPanel.disposed.connect(() => {
                    searchInstance?.dispose();
                    searchModel.dispose();
                    provider.dispose();
                });
            }
            if (!searchInstance.isAttached) {
                _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.Widget.attach(searchInstance, notebookPanel.node);
                searchInstance.node.style.top = `${notebookPanel.toolbar.node.getBoundingClientRect().height +
                    notebookPanel.contentHeader.node.getBoundingClientRect().height}px`;
                if (searchInstance.model.searchExpression) {
                    searchInstance.model.refresh();
                }
            }
            searchInstance.focusSearchInput();
        }
    });
    commandRegistry.addCommand(cmdIds.findNext, {
        label: 'Find Next',
        isEnabled: () => !!searchInstance,
        execute: async () => {
            if (!searchInstance) {
                return;
            }
            await searchInstance.model.highlightNext();
        }
    });
    commandRegistry.addCommand(cmdIds.findPrevious, {
        label: 'Find Previous',
        isEnabled: () => !!searchInstance,
        execute: async () => {
            if (!searchInstance) {
                return;
            }
            await searchInstance.model.highlightPrevious();
        }
    });
    commandRegistry.addCommand(cmdIds.interrupt, {
        label: "Interrupt",
        execute: async () => notebookPanel.context.sessionContext.session?.kernel?.interrupt(),
    });
    const sessionContextDialogs = new _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_0__.SessionContextDialogs();
    commandRegistry.addCommand(cmdIds.restart, {
        label: "Restart Kernel",
        execute: () => sessionContextDialogs.restart(notebookPanel.context.sessionContext),
    });
    commandRegistry.addCommand(cmdIds.switchKernel, {
        label: "Switch Kernel",
        execute: () => sessionContextDialogs.selectKernel(notebookPanel.context.sessionContext),
    });
    commandRegistry.addCommand(cmdIds.runAndAdvance, {
        label: "Run and Advance",
        execute: () => {
            return _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.runAndAdvance(notebookPanel.content, notebookPanel.context.sessionContext);
        },
    });
    commandRegistry.addCommand(cmdIds.run, {
        label: "Run",
        execute: () => {
            return _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.run(notebookPanel.content, notebookPanel.context.sessionContext);
        },
    });
    commandRegistry.addCommand(cmdIds.runAll, {
        label: "Run all",
        execute: () => {
            return _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.runAll(notebookPanel.content, notebookPanel.context.sessionContext);
        },
    });
    commandRegistry.addCommand(cmdIds.deleteCells, {
        label: "Delete",
        execute: () => {
            return _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.deleteCells(notebookPanel.content);
        },
    });
    commandRegistry.addCommand(cmdIds.insertAbove, {
        label: "Insert Above",
        execute: () => {
            return _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.insertAbove(notebookPanel.content);
        },
    });
    commandRegistry.addCommand(cmdIds.insertBelow, {
        label: "Insert Below",
        execute: () => {
            return _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.insertBelow(notebookPanel.content);
        },
    });
    commandRegistry.addCommand(cmdIds.editMode, {
        label: "Edit Mode",
        execute: () => {
            notebookPanel.content.mode = "edit";
        },
    });
    commandRegistry.addCommand(cmdIds.commandMode, {
        label: "Command Mode",
        execute: () => {
            notebookPanel.content.mode = "command";
        },
    });
    commandRegistry.addCommand(cmdIds.selectBelow, {
        label: "Select Below",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.selectBelow(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.selectAbove, {
        label: "Select Above",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.selectAbove(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.extendAbove, {
        label: "Extend Above",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.extendSelectionAbove(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.extendTop, {
        label: "Extend to Top",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.extendSelectionAbove(notebookPanel.content, true),
    });
    commandRegistry.addCommand(cmdIds.extendBelow, {
        label: "Extend Below",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.extendSelectionBelow(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.extendBottom, {
        label: "Extend to Bottom",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.extendSelectionBelow(notebookPanel.content, true),
    });
    commandRegistry.addCommand(cmdIds.merge, {
        label: "Merge Cells",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.mergeCells(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.split, {
        label: "Split Cell",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.splitCell(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.undo, {
        label: "Undo",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.undo(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.redo, {
        label: "Redo",
        execute: () => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.redo(notebookPanel.content),
    });
    commandRegistry.addCommand(cmdIds.toCode, {
        label: 'Change to Code Cell Type',
        execute: args => _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_1__.NotebookActions.changeCellType(notebookPanel.content, 'markdown')
    });
    const bindings = [
        {
            selector: ".jp-Notebook.jp-mod-editMode .jp-mod-completer-enabled",
            keys: ["Tab"],
            command: cmdIds.invokeNotebook,
        },
        {
            selector: `.jp-mod-completer-active`,
            keys: ["Enter"],
            command: cmdIds.selectNotebook,
        },
        {
            selector: ".jp-Notebook",
            keys: ["Ctrl Enter"],
            command: cmdIds.run,
        },
        {
            selector: ".jp-Notebook",
            keys: ["Shift Enter"],
            command: cmdIds.runAndAdvance,
        },
        {
            selector: ".jp-Notebook",
            keys: ["Accel F"],
            command: cmdIds.startSearch,
        },
        {
            selector: ".jp-Notebook",
            keys: ["Accel G"],
            command: cmdIds.findNext,
        },
        {
            selector: ".jp-Notebook",
            keys: ["Accel Shift G"],
            command: cmdIds.findPrevious,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["I", "I"],
            command: cmdIds.interrupt,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["0", "0"],
            command: cmdIds.restart,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["Enter"],
            command: cmdIds.editMode,
        },
        {
            selector: ".jp-Notebook.jp-mod-editMode",
            keys: ["Escape"],
            command: cmdIds.commandMode,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["Shift M"],
            command: cmdIds.merge,
        },
        {
            selector: ".jp-Notebook.jp-mod-editMode",
            keys: ["Ctrl Shift -"],
            command: cmdIds.split,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["J"],
            command: cmdIds.selectBelow,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["ArrowDown"],
            command: cmdIds.selectBelow,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["A"],
            command: cmdIds.insertAbove,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["B"],
            command: cmdIds.insertBelow,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["K"],
            command: cmdIds.selectAbove,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["ArrowUp"],
            command: cmdIds.selectAbove,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["Shift K"],
            command: cmdIds.extendAbove,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["Shift J"],
            command: cmdIds.extendBelow,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["Z"],
            command: cmdIds.undo,
        },
        {
            selector: ".jp-Notebook.jp-mod-commandMode:focus",
            keys: ["Y"],
            command: cmdIds.redo,
        },
    ];
    bindings.map((binding) => commandRegistry.addKeyBinding(binding));
    if (path) {
        commandRegistry.addKeyBinding({
            selector: ".jp-Notebook",
            keys: ["Accel S"],
            command: cmdIds.save,
        });
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (NotebookCommands);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/NotebookState.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/NotebookState.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ActionType": () => (/* binding */ ActionType),
/* harmony export */   "notebookActions": () => (/* binding */ notebookActions),
/* harmony export */   "notebookEpics": () => (/* binding */ notebookEpics),
/* harmony export */   "notebookInitialState": () => (/* binding */ notebookInitialState),
/* harmony export */   "notebookReducer": () => (/* binding */ notebookReducer),
/* harmony export */   "selectActiveCell": () => (/* binding */ selectActiveCell),
/* harmony export */   "selectKernelStatus": () => (/* binding */ selectKernelStatus),
/* harmony export */   "selectNotebook": () => (/* binding */ selectNotebook),
/* harmony export */   "selectNotebookModel": () => (/* binding */ selectNotebookModel),
/* harmony export */   "selectNotebookPortalDisplay": () => (/* binding */ selectNotebookPortalDisplay),
/* harmony export */   "selectNotebookPortals": () => (/* binding */ selectNotebookPortals),
/* harmony export */   "selectSaveRequest": () => (/* binding */ selectSaveRequest)
/* harmony export */ });
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var redux_observable__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! redux-observable */ "../../../node_modules/redux-observable/lib/esm/combineEpics.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rxjs/operators */ "../../../node_modules/rxjs/_esm5/internal/operators/tap.js");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! rxjs/operators */ "../../../node_modules/rxjs/_esm5/internal/operators/ignoreElements.js");
/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! rxjs/operators */ "../../../node_modules/rxjs/_esm5/internal/operators/map.js");
/* harmony import */ var _datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @datalayer/typescript-fsa-redux-observable */ "../../../node_modules/@datalayer/typescript-fsa-redux-observable/lib/index.js");
/* harmony import */ var _NotebookCommands__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./NotebookCommands */ "../ui/packages/react/lib/components/notebook/NotebookCommands.js");







const notebookInitialState = {
    notebooks: new Map(),
};
/* Selectors */
const selectNotebook = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        return state.notebook.notebooks.get(uid);
    }
    return undefined;
});
const selectNotebookModel = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        // We need a changed attribute to deal the React-Redux shallow equality.
        return {
            model: state.notebook.notebooks.get(uid)?.model,
            changed: state.notebook.notebooks.get(uid)?.model?.contentChanged,
        };
    }
    return undefined;
});
const selectKernelStatus = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        return state.notebook.notebooks.get(uid)?.kernelStatus;
    }
    return undefined;
});
const selectActiveCell = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        return state.notebook.notebooks.get(uid)?.activeCell;
    }
    return undefined;
});
const selectNotebookPortals = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        return state.notebook.notebooks.get(uid)?.portals;
    }
    return undefined;
});
const selectSaveRequest = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        return state.notebook.notebooks.get(uid)?.saveRequest;
    }
    return undefined;
});
const selectNotebookPortalDisplay = (uid) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.notebook) {
        return state.notebook.notebooks.get(uid)?.portalDisplay;
    }
    return undefined;
});
/* Actions */
var ActionType;
(function (ActionType) {
    ActionType["ACTIVE_CELL_CHANGE"] = "notebook/ACTIVE_CELL_CHANGE";
    ActionType["ADD_PORTALS"] = "notebook/ADD_PORTALS";
    ActionType["CHANGE_CELL_TYPE"] = "notebook/CHANGE_CELL_TYPE";
    ActionType["CHANGE_KERNEL"] = "notebook/CHANGE_KERNEL";
    ActionType["DELETE"] = "notebook/DELETE";
    ActionType["DISPOSE"] = "notebook/DISPOSE";
    ActionType["INSERT_ABOVE"] = "notebook/INSERT_ABOVE";
    ActionType["INSERT_BELOW"] = "notebook/INSERT_BELOW";
    ActionType["INTERRUPT"] = "notebook/INTERRUPT";
    ActionType["KERNEL_STATUS_CHANGE"] = "notebook/KERNEL_STATUS_CHANGE";
    ActionType["MODEL_CHANGE"] = "notebook/MODEL_CHANGE";
    ActionType["NOTEBOOK_CHANGE"] = "notebook/NOTEBOOK_CHANGE";
    ActionType["RESET"] = "notebook/RESET";
    ActionType["RUN"] = "notebook/RUN";
    ActionType["RUN_ALL"] = "notebook/RUN_ALL";
    ActionType["SAVE"] = "notebook/SAVE";
    ActionType["SET_PORTALS"] = "notebook/SET_PORTALS";
    ActionType["SET_PORTAL_DISPLAY"] = "notebook/SET_PORTAL_DISPLAY";
    ActionType["UPDATE"] = "notebook/UPDATE";
})(ActionType || (ActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_1__["default"])('jupyterNotebook');
const notebookActions = {
    reset: actionCreator(ActionType.RESET),
    update: actionCreator(ActionType.UPDATE),
    notebookChange: actionCreator(ActionType.NOTEBOOK_CHANGE),
    modelChange: actionCreator(ActionType.MODEL_CHANGE),
    changeKernel: actionCreator(ActionType.CHANGE_KERNEL),
    activeCellChange: actionCreator(ActionType.ACTIVE_CELL_CHANGE),
    kernelStatusChanged: actionCreator(ActionType.KERNEL_STATUS_CHANGE),
    addPortals: actionCreator(ActionType.ADD_PORTALS),
    setPortals: actionCreator(ActionType.SET_PORTALS),
    setPortalDisplay: actionCreator(ActionType.SET_PORTAL_DISPLAY),
    dispose: actionCreator(ActionType.DISPOSE),
    save: actionCreator.async(ActionType.SAVE),
    run: actionCreator.async(ActionType.RUN),
    runAll: actionCreator.async(ActionType.RUN_ALL),
    interrupt: actionCreator.async(ActionType.INTERRUPT),
    insertAbove: actionCreator.async(ActionType.INSERT_ABOVE),
    insertBelow: actionCreator.async(ActionType.INSERT_BELOW),
    delete: actionCreator.async(ActionType.DELETE),
    changeCellType: actionCreator.async(ActionType.CHANGE_CELL_TYPE)
};
/* Epics */
const runEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.run.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    state$.value.notebook.notebooks.get(action.payload)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.run);
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const runAllEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.runAll.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    state$.value.notebook.notebooks.get(action.payload)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.runAll);
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const interruptEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.interrupt.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    state$.value.notebook.notebooks.get(action.payload)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.interrupt);
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const insertAboveEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.insertAbove.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    state$.value.notebook.notebooks.get(action.payload.uid)?.adapter?.setDefaultCellType(action.payload.cellType);
    state$.value.notebook.notebooks.get(action.payload.uid)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.insertAbove);
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const insertBelowEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.insertBelow.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    state$.value.notebook.notebooks.get(action.payload.uid)?.adapter?.setDefaultCellType(action.payload.cellType);
    state$.value.notebook.notebooks.get(action.payload.uid)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.insertBelow);
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const deleteEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.delete.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    state$.value.notebook.notebooks.get(action.payload)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.deleteCells);
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const changeCellTypeEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.changeCellType.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_4__.tap)(action => {
    //      state$.value.notebook?.adapter?.commands.execute(cmdIds.toCode);
    state$.value.notebook.notebooks.get(action.payload.uid)?.adapter?.changeCellType(action.payload.cellType);
    /*
    NotebookActions.changeCellType(
      state$.value.notebook.notebooks.get(action.payload)?.adapter?.notebookPanel?.content!,
      action.payload
    );
    */
}), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_6__.ignoreElements)());
const saveEpic = (action$, state$) => action$.pipe((0,_datalayer_typescript_fsa_redux_observable__WEBPACK_IMPORTED_MODULE_3__.ofAction)(notebookActions.save.started), (0,rxjs_operators__WEBPACK_IMPORTED_MODULE_7__.map)(action => {
    state$.value.notebook.notebooks.get(action.payload.uid)?.adapter?.commands.execute(_NotebookCommands__WEBPACK_IMPORTED_MODULE_5__.cmdIds.save);
    return notebookActions.save.done({
        params: action.payload,
        result: action.payload,
    });
}));
const notebookEpics = (0,redux_observable__WEBPACK_IMPORTED_MODULE_8__.combineEpics)(runEpic, runAllEpic, interruptEpic, insertAboveEpic, insertBelowEpic, deleteEpic, changeCellTypeEpic, saveEpic);
/* Reducers */
const notebookReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(notebookInitialState)
    .case(notebookActions.reset, (state, _) => {
    return notebookInitialState;
})
    .case(notebookActions.update, (state, updateUid) => {
    const notebooks = state.notebooks;
    let notebook = notebooks.get(updateUid.uid);
    if (notebook) {
        notebook = { ...notebook, ...updateUid.partialState };
    }
    else {
        notebooks.set(updateUid.uid, {
            adapter: updateUid.partialState.adapter,
            portals: [],
        });
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.activeCellChange, (state, cellModelUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(cellModelUid.uid);
    if (notebook) {
        notebook.activeCell = cellModelUid.cellModel;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.modelChange, (state, notebookModelUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(notebookModelUid.uid);
    if (notebook) {
        notebook.model = notebookModelUid.notebookModel;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.notebookChange, (state, notebookChangeUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(notebookChangeUid.uid);
    if (notebook) {
        notebook.notebookChange = notebookChangeUid.notebookChange;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.kernelStatusChanged, (state, kernelStatusUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(kernelStatusUid.uid);
    if (notebook) {
        notebook.kernelStatus = kernelStatusUid.kernelStatus;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.changeKernel, (state, kernelChange) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(kernelChange.uid);
    if (notebook) {
        notebook.adapter?.changeKernel(kernelChange.kernel);
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.addPortals, (state, portalsUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(portalsUid.uid);
    if (notebook) {
        notebook.portals = notebook.portals.concat(portalsUid.portals);
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.dispose, (state, uid) => {
    const notebooks = state.notebooks;
    notebooks.delete(uid);
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.setPortals, (state, portalsUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(portalsUid.uid);
    if (notebook) {
        notebook.portals = portalsUid.portals;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.setPortalDisplay, (state, portalDisplayUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(portalDisplayUid.uid);
    if (notebook) {
        notebook.portalDisplay = portalDisplayUid.portalDisplay;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.save.done, (state, dateUid) => {
    const notebooks = state.notebooks;
    const notebook = notebooks.get(dateUid.result.uid);
    if (notebook) {
        notebook.saveRequest = dateUid.result.date;
    }
    return {
        ...state,
        notebooks,
    };
})
    .case(notebookActions.insertAbove.done, (state, _) => {
    return state;
})
    .case(notebookActions.insertBelow.done, (state, _) => {
    return state;
})
    .case(notebookActions.changeCellType.done, (state, _) => {
    return state;
})
    .case(notebookActions.run.done, (state, _) => {
    return state;
})
    .case(notebookActions.delete.done, (state, _) => {
    return state;
});


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/metadata/CellMetadataEditor.js":
/*!****************************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/metadata/CellMetadataEditor.js ***!
  \****************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellMetadataEditor": () => (/* binding */ CellMetadataEditor),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ActionList/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/TextInput/TextInput.js");
/* harmony import */ var _primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @primer/octicons-react */ "../../../node_modules/@primer/octicons-react/dist/index.esm.js");
/* harmony import */ var _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./NbGraderCells */ "../ui/packages/react/lib/components/notebook/cell/metadata/NbGraderCells.js");





const CellMetadataEditor = (props) => {
    const { cell } = props;
    const [cellGradeType, setCellGradeType] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)((0,_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__.getNbGraderType)(cell));
    const [nbg, setNbg] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(cell.model.getMetadata('nbgrader') || { grade_id: '', points: 0 });
    const handleGradeIdChange = (cell, gradeId) => {
        const nbgrader = cell.model.getMetadata("nbgrader");
        cell.model.setMetadata("nbgrader", {
            ...nbgrader,
            grade_id: gradeId,
        });
        setNbg({
            ...nbg,
            grade_id: gradeId,
        });
    };
    const handlePointsChange = (cell, points) => {
        var points_number = +points;
        if (!isNaN(points_number)) {
            const nbgrader = cell.model.getMetadata("nbgrader");
            cell.model.setMetadata("nbgrader", {
                ...nbgrader,
                points: points_number,
            });
            setNbg({
                ...nbg,
                points: points_number,
            });
        }
    };
    const assignCellGradeType = (cell, cellGradeType) => {
        switch (cellGradeType) {
            case _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].NotGraded: {
                cell.model.deleteMetadata("nbgrader");
                setCellGradeType(_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].NotGraded);
                break;
            }
            case _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedAnswer: {
                const nbgrader = cell.model.getMetadata("nbgrader");
                cell.model.setMetadata("nbgrader", {
                    ...nbgrader,
                    "grade": false,
                    "solution": true,
                    "locked": false,
                    "task": false,
                });
                setCellGradeType(_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedAnswer);
                break;
            }
            case _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedTest: {
                const nbgrader = cell.model.getMetadata("nbgrader");
                cell.model.setMetadata("nbgrader", {
                    ...nbgrader,
                    "grade": true,
                    "solution": false,
                    "locked": false,
                    "task": false,
                });
                setCellGradeType(_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedTest);
                break;
            }
            case _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedAnswer: {
                const nbgrader = cell.model.getMetadata("nbgrader");
                cell.model.setMetadata("nbgrader", {
                    ...nbgrader,
                    "grade": true,
                    "solution": true,
                    "locked": false,
                    "task": false,
                });
                setCellGradeType(_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedAnswer);
                break;
            }
            case _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedTask: {
                const nbgrader = cell.model.getMetadata("nbgrader");
                cell.model.setMetadata("nbgrader", {
                    ...nbgrader,
                    //        "points": 1,
                    "grade": false,
                    "solution": false,
                    "locked": true,
                    "task": true,
                });
                setCellGradeType(_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedTask);
                break;
            }
            case _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ReadonlyGraded: {
                const nbgrader = cell.model.getMetadata("nbgrader");
                cell.model.setMetadata("nbgrader", {
                    ...nbgrader,
                    "grade": false,
                    "solution": false,
                    "locked": true,
                    "task": false,
                });
                setCellGradeType(_NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ReadonlyGraded);
                break;
            }
        }
    };
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList, { showDividers: true, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Divider, {}), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Group, { title: "NbGrader Cell Type", variant: "subtle", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { onSelect: e => assignCellGradeType(cell, _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].NotGraded), children: [cellGradeType === _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].NotGraded &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.CheckIcon, {}) }), "None", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Description, { variant: "block", children: "Not a grader cell." })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { onSelect: e => assignCellGradeType(cell, _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedAnswer), children: [cellGradeType === _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedAnswer &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.CheckIcon, {}) }), "Autograded answer", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Description, { variant: "block", children: "An autograded answer cell." })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { role: "listitem", onClick: e => assignCellGradeType(cell, _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedTest), children: [cellGradeType === _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].AutogradedTest &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.CheckIcon, {}) }), "Autograded test", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Description, { variant: "block", children: "An autograded test cell." })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { onSelect: e => assignCellGradeType(cell, _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedTask), children: [cellGradeType === _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedTask &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.CheckIcon, {}) }), "Manually graded task", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Description, { variant: "block", children: "A manually graded task cell." })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { onSelect: e => assignCellGradeType(cell, _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedAnswer), children: [cellGradeType === _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ManuallyGradedAnswer &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.CheckIcon, {}) }), "Manually graded answer", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Description, { variant: "block", children: "A manually graded answer cell." })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { onSelect: e => assignCellGradeType(cell, _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ReadonlyGraded), children: [cellGradeType === _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].ReadonlyGraded &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_4__.CheckIcon, {}) }), "Readonly", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Description, { variant: "block", children: "A readonly grader cell." })] })] }), cellGradeType !== _NbGraderCells__WEBPACK_IMPORTED_MODULE_2__["default"].NotGraded &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Group, { title: "NbGrader Metadata", variant: "subtle", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { onSelect: e => e.preventDefault(), children: ["Grade ID: ", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__["default"], { block: true, value: nbg.grade_id, onChange: e => { e.preventDefault(); handleGradeIdChange(cell, e.target.value); } })] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_3__.ActionList.Item, { children: ["Points: ", (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__["default"], { block: true, value: nbg.points, onChange: e => { e.preventDefault(); handlePointsChange(cell, e.target.value); } })] })] })] }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CellMetadataEditor);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/metadata/NbGraderCells.js":
/*!***********************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/metadata/NbGraderCells.js ***!
  \***********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "NbGraderType": () => (/* binding */ NbGraderType),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   "getNbGraderType": () => (/* binding */ getNbGraderType)
/* harmony export */ });
/*
// Autograded answer (only for code cells) { grade: false, solution: true, locked: false  }
{
  "nbgrader": {
    "grade_id": "squares",
    "schema_version": 3,
    "grade": false,
    "solution": true,
    "locked": false
  }
}
// Autograded test (only for code cells) { grade: true, solution: false, locked: false, points: ... }
{
  "nbgrader": {
    "grade_id": "correct_squares",
    "schema_version": 3,
    "grade": true,
    "solution": false,
    "locked": false,
    "points": 1
  }
}
// Manually graded task { grade: false, solution: false, locked: true, task: true, points: ... }
{
  "nbgrader": {
    "grade_id": "part-a",
    "schema_version": 3,
    "grade": false,
    "solution": false,
    "locked": true,
    "task": true,
    "points": 0
  }
}
// Manually graded answer { grade: true, solution: true, locked: false, points: ... }
{
  "nbgrader": {
    "grade_id": "sum_of_squares_equation",
    "schema_version": 3,
    "grade": true,
    "solution": true,
    "locked": false,
    "points": 1
  }
}
// Readonly { grade: false, solution: false, solution: false, locked: true, task: false }
{
  "nbgrader": {
    "grade_id": "squares",
    "schema_version": 3,
    "grade": false,
    "solution": false,
    "locked": true,
    "task": false
  }
}
*/
var NbGraderType;
(function (NbGraderType) {
    NbGraderType[NbGraderType["NotGraded"] = 0] = "NotGraded";
    NbGraderType[NbGraderType["AutogradedAnswer"] = 1] = "AutogradedAnswer";
    NbGraderType[NbGraderType["AutogradedTest"] = 2] = "AutogradedTest";
    NbGraderType[NbGraderType["ManuallyGradedTask"] = 3] = "ManuallyGradedTask";
    NbGraderType[NbGraderType["ManuallyGradedAnswer"] = 4] = "ManuallyGradedAnswer";
    NbGraderType[NbGraderType["ReadonlyGraded"] = 5] = "ReadonlyGraded";
})(NbGraderType || (NbGraderType = {}));
const getNbGraderType = (cell) => {
    const nbgrader = cell.model.getMetadata("nbgrader");
    if (!nbgrader) {
        return NbGraderType.NotGraded;
    }
    const grade = nbgrader.grade;
    const solution = nbgrader.solution;
    const locked = nbgrader.locked;
    const task = nbgrader.task;
    // Autograded answer (only for code cells) { grade: false, solution: true, locked: false  }
    if (!grade && solution && !locked) {
        return NbGraderType.AutogradedAnswer;
    }
    // Autograded test (only for code cells) { grade: true, solution: false, locked: false, points: ... }
    if (grade && !solution && !locked) {
        return NbGraderType.AutogradedTest;
    }
    // Manually graded task { grade: false, solution: false, locked: true, task: true, points: ... }
    if (!grade && !solution && locked && task) {
        return NbGraderType.ManuallyGradedTask;
    }
    // Manually graded answer { grade: true, solution: true, locked: false, points: ... }
    if (grade && solution && !locked) {
        return NbGraderType.ManuallyGradedAnswer;
    }
    // Readonly { grade: false, solution: false, solution: false, locked: true, task: false }
    if (!grade && !solution && locked && !task) {
        return NbGraderType.ReadonlyGraded;
    }
    return NbGraderType.NotGraded;
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (NbGraderType);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/prompt/Countdown.js":
/*!*****************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/prompt/Countdown.js ***!
  \*****************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Countdown": () => (/* binding */ Countdown)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);


const Countdown = (props) => {
    const [count, setCount] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(props.count);
    let intervalRef = (0,react__WEBPACK_IMPORTED_MODULE_1__.useRef)();
    const decreaseNum = () => setCount((prev) => prev - 1);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        setCount(props.count);
    }, [props.count]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        intervalRef.current = setInterval(decreaseNum, 1000);
        return () => clearInterval(intervalRef.current);
    }, []);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: ["[", count, "]"] }));
};


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/prompt/CountdownInputPrompt.js":
/*!****************************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/prompt/CountdownInputPrompt.js ***!
  \****************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CountdownInputPrompt": () => (/* binding */ CountdownInputPrompt),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/apputils */ "webpack/sharing/consume/default/@jupyterlab/apputils");
/* harmony import */ var _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _Countdown__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./Countdown */ "../ui/packages/react/lib/components/notebook/cell/prompt/Countdown.js");



const INPUT_PROMPT_CLASS = 'jp-InputPrompt';
class CountdownInputPrompt extends _jupyterlab_apputils__WEBPACK_IMPORTED_MODULE_1__.ReactWidget {
    _executionCount = null;
    state = {
        count: 100
    };
    constructor() {
        super();
        this.addClass(INPUT_PROMPT_CLASS);
    }
    /** @override */
    render() {
        return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_Countdown__WEBPACK_IMPORTED_MODULE_2__.Countdown, { count: this.state.count });
    }
    get executionCount() {
        return this._executionCount;
    }
    set executionCount(value) {
        this._executionCount = value;
        if (value === null) {
            this.state = {
                count: 0
            };
        }
        else {
            if (value === '*') {
                this.state = {
                    count: 0
                };
            }
            else {
                this.state = {
                    count: Number(value)
                };
                this.update();
            }
        }
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CountdownInputPrompt);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/sidebar/CellSidebarDefault.js":
/*!***************************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/sidebar/CellSidebarDefault.js ***!
  \***************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellSidebarDefault": () => (/* binding */ CellSidebarDefault),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Box/Box.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Button/Button.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ActionMenu.js");
/* harmony import */ var _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @primer/octicons-react */ "../../../node_modules/@primer/octicons-react/dist/index.esm.js");
/* harmony import */ var _NotebookState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../NotebookState */ "../ui/packages/react/lib/components/notebook/NotebookState.js");
/* harmony import */ var _metadata_CellMetadataEditor__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../metadata/CellMetadataEditor */ "../ui/packages/react/lib/components/notebook/cell/metadata/CellMetadataEditor.js");
/* harmony import */ var _lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./lumino/CellSidebarWidget */ "../ui/packages/react/lib/components/notebook/cell/sidebar/lumino/CellSidebarWidget.js");








const CellSidebarDefault = (props) => {
    const { notebookId, cellId, nbgrader } = props;
    const [visible, setVisible] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(false);
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_2__.useDispatch)();
    const activeCell = (0,_NotebookState__WEBPACK_IMPORTED_MODULE_3__.selectActiveCell)(notebookId);
    const layout = (activeCell?.layout);
    if (layout) {
        const cellWidget = layout.widgets[0];
        if (cellWidget?.node.id === cellId) {
            if (!visible) {
                setVisible(true);
            }
        }
        if (cellWidget?.node.id !== cellId) {
            if (visible) {
                setVisible(false);
            }
        }
    }
    if (!visible) {
        return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", {});
    }
    return activeCell ?
        ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_4__["default"], { className: _lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_5__.DATALAYER_CELL_HEADER_CLASS, sx: {
                '& p': {
                    marginBottom: '0 !important',
                }
            }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.ChevronRightIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.run.started(notebookId));
                        }, children: "Run" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.ChevronUpIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.insertAbove.started({ uid: notebookId, cellType: "code" }));
                        }, children: "Code" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.ChevronUpIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.insertAbove.started({ uid: notebookId, cellType: "markdown" }));
                        }, children: "Markdown" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: activeCell.model.type === "code" ?
                        (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.SquareIcon, variant: "invisible", size: "small", onClick: (e) => {
                                e.preventDefault();
                                dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.changeCellType.started({ uid: notebookId, cellType: "markdown" }));
                            }, children: "To Markdown" })
                        :
                            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.SquareIcon, variant: "invisible", size: "small", onClick: (e) => {
                                    e.preventDefault();
                                    dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.changeCellType.started({ uid: notebookId, cellType: "code" }));
                                }, children: "To Code" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.ChevronDownIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.insertBelow.started({ uid: notebookId, cellType: "markdown" }));
                        }, children: "Markdown" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.ChevronDownIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.insertBelow.started({ uid: notebookId, cellType: "code" }));
                        }, children: "Code" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { leadingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.XIcon, variant: "invisible", size: "small", onClick: (e) => {
                            e.preventDefault();
                            dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions["delete"].started(notebookId));
                        }, children: "Delete" }) }), nbgrader &&
                    (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_8__.ActionMenu, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_metadata_CellMetadataEditor__WEBPACK_IMPORTED_MODULE_9__["default"], { notebookId: notebookId, cell: activeCell, nbgrader: nbgrader }) })] }))
        :
            ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, {}));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CellSidebarDefault);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/sidebar/CellSidebarRun.js":
/*!***********************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/sidebar/CellSidebarRun.js ***!
  \***********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellSidebarRun": () => (/* binding */ CellSidebarRun),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Box/Box.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Button/Button.js");
/* harmony import */ var _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @primer/octicons-react */ "../../../node_modules/@primer/octicons-react/dist/index.esm.js");
/* harmony import */ var _NotebookState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../NotebookState */ "../ui/packages/react/lib/components/notebook/NotebookState.js");
/* harmony import */ var _lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./lumino/CellSidebarWidget */ "../ui/packages/react/lib/components/notebook/cell/sidebar/lumino/CellSidebarWidget.js");







const CellSidebarRun = (props) => {
    const { notebookId } = props;
    const [visible, setVisible] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(false);
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_2__.useDispatch)();
    const activeCell = (0,_NotebookState__WEBPACK_IMPORTED_MODULE_3__.selectActiveCell)(notebookId);
    const layout = (activeCell?.layout);
    if (layout) {
        const cellWidget = layout.widgets[0];
        if (!visible && (cellWidget?.node.id === props.cellId)) {
            setVisible(true);
        }
        if (visible && (cellWidget?.node.id !== props.cellId)) {
            setVisible(false);
        }
    }
    if (!visible) {
        return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", {});
    }
    return (activeCell ?
        (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__["default"], { className: _lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_5__.DATALAYER_CELL_HEADER_CLASS, sx: {
                '& p': {
                    marginBottom: '0 !important',
                }
            }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("span", { style: { display: "flex" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_6__.ButtonComponent, { trailingVisual: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_7__.PlayIcon, size: "small", variant: "invisible", onClick: (e) => {
                        e.preventDefault();
                        dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookActions.run.started(notebookId));
                    }, children: "Run" }) }) })
        :
            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, {}));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CellSidebarRun);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/cell/sidebar/lumino/CellSidebarWidget.js":
/*!*********************************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/cell/sidebar/lumino/CellSidebarWidget.js ***!
  \*********************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "CellSidebarWidget": () => (/* binding */ CellSidebarWidget),
/* harmony export */   "DATALAYER_CELL_HEADER_CLASS": () => (/* binding */ DATALAYER_CELL_HEADER_CLASS),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-dom */ "webpack/sharing/consume/default/react-dom");
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../../../../../jupyter/utils/Ids */ "../ui/packages/react/lib/jupyter/utils/Ids.js");
/* harmony import */ var _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../../../../jupyter/lumino/ReactPortalWidget */ "../ui/packages/react/lib/jupyter/lumino/ReactPortalWidget.js");
/* harmony import */ var _NotebookState__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../../../NotebookState */ "../ui/packages/react/lib/components/notebook/NotebookState.js");






const DATALAYER_CELL_HEADER_CLASS = 'dla-CellHeader-Container';
class CellSidebarWidget extends _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_3__.ReactPortalWidget {
    commands;
    constructor(CellSidebar, notebookId, nbgrader, commands, store) {
        super();
        this.commands = commands;
        this.addClass('jp-CellHeader');
        this.id = (0,_jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_4__.newUuid)();
        const props = {
            notebookId: notebookId,
            cellId: this.id,
            command: this.commands,
            nbgrader,
        };
        const sidebar = (0,react__WEBPACK_IMPORTED_MODULE_1__.createElement)(CellSidebar, props);
        const portalDiv = ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { className: DATALAYER_CELL_HEADER_CLASS, children: sidebar }));
        const portal = (0,react_dom__WEBPACK_IMPORTED_MODULE_2__.createPortal)(portalDiv, this.node);
        store.dispatch(_NotebookState__WEBPACK_IMPORTED_MODULE_5__.notebookActions.addPortals({
            uid: notebookId,
            portals: [portal]
        }));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CellSidebarWidget);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/content/JupyterReactContentFactory.js":
/*!******************************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/content/JupyterReactContentFactory.js ***!
  \******************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "JupyterReactContentFactory": () => (/* binding */ JupyterReactContentFactory),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _cell_sidebar_lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../cell/sidebar/lumino/CellSidebarWidget */ "../ui/packages/react/lib/components/notebook/cell/sidebar/lumino/CellSidebarWidget.js");


// import { IInputPrompt } from '@jupyterlab/cells';
// import { NotebookInputPrompt } from './../cell/InputPrompt';
/**
 * Extend the default implementation NotebookPanel.ContentFactory of `IContentFactory`.
 */
class JupyterReactContentFactory extends _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.NotebookPanel.ContentFactory {
    CellSidebar;
    notebookId;
    nbgrader;
    commands;
    store;
    constructor(CellSidebar, notebookId, nbgrader, commands, options, store) {
        super(options);
        this.CellSidebar = CellSidebar;
        super.createCodeCell;
        this.notebookId = notebookId,
            this.nbgrader = nbgrader;
        this.commands = commands;
        this.store = store;
    }
    /** @override */
    createCellHeader() {
        return new _cell_sidebar_lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_1__.CellSidebarWidget(this.CellSidebar, this.notebookId, this.nbgrader, this.commands, this.store);
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (JupyterReactContentFactory);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/marked/marked.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/marked/marked.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   "getMarked": () => (/* binding */ getMarked)
/* harmony export */ });
/* harmony import */ var marked__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! marked */ "../../../node_modules/marked/lib/marked.esm.js");

const getMarked = (languages) => {
    Private.initializeMarked(languages);
    return {
        render: (content) => new Promise((resolve, reject) => {
            (0,marked__WEBPACK_IMPORTED_MODULE_0__.marked)(content, (err, content) => {
                if (err) {
                    reject(err);
                }
                else {
                    resolve(content);
                }
            });
        })
    };
};
var Private;
(function (Private) {
    let markedInitialized = false;
    function initializeMarked(languages) {
        if (markedInitialized) {
            return;
        }
        else {
            markedInitialized = true;
        }
        marked__WEBPACK_IMPORTED_MODULE_0__.marked.setOptions({
            gfm: true,
            sanitize: false,
            // breaks: true; We can't use GFM breaks as it causes problems with tables
            langPrefix: `language-`,
            highlight: (code, lang, callback) => {
                const cb = (err, code) => {
                    if (callback) {
                        callback(err, code);
                    }
                    return code;
                };
                if (!lang) {
                    // no language, no highlight
                    return cb(null, code);
                }
                const el = document.createElement('div');
                try {
                    languages
                        .highlight(code, languages.findBest(lang), el)
                        .then(() => {
                        return cb(null, el.innerHTML);
                    })
                        .catch(reason => {
                        return cb(reason, code);
                    });
                }
                catch (err) {
                    console.error(`Failed to highlight ${lang} code`, err);
                    return cb(err, code);
                }
            }
        });
    }
    Private.initializeMarked = initializeMarked;
})(Private || (Private = {}));
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (getMarked);


/***/ }),

/***/ "../ui/packages/react/lib/components/notebook/model/JupyterReactNotebookModelFactory.js":
/*!**********************************************************************************************!*\
  !*** ../ui/packages/react/lib/components/notebook/model/JupyterReactNotebookModelFactory.js ***!
  \**********************************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "JupyterReactNotebookModelFactory": () => (/* binding */ JupyterReactNotebookModelFactory),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/notebook */ "webpack/sharing/consume/default/@jupyterlab/notebook");
/* harmony import */ var _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__);

class JupyterReactNotebookModelFactory extends _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.NotebookModelFactory {
    _nbformat;
    /** @override */
    constructor(options) {
        super(options);
        this._nbformat = options.nbformat;
    }
    /** @override */
    createNew(options) {
        if (this._nbformat) {
            const model = new _jupyterlab_notebook__WEBPACK_IMPORTED_MODULE_0__.NotebookModel();
            model.fromJSON(this._nbformat);
            return model;
        }
        return super.createNew(options);
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (JupyterReactNotebookModelFactory);


/***/ }),

/***/ "../ui/packages/react/lib/components/output/Output.js":
/*!************************************************************!*\
  !*** ../ui/packages/react/lib/components/output/Output.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Output": () => (/* binding */ Output),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ActionMenu.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Button/IconButton.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ActionList/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ProgressBar/index.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/Box/Box.js");
/* harmony import */ var _primer_octicons_react__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @primer/octicons-react */ "../../../node_modules/@primer/octicons-react/dist/index.esm.js");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _OutputAdapter__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./OutputAdapter */ "../ui/packages/react/lib/components/output/OutputAdapter.js");
/* harmony import */ var _OutputState__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./OutputState */ "../ui/packages/react/lib/components/output/OutputState.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../../jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");
/* harmony import */ var _codemirror_CodeMirrorEditor__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ../codemirror/CodeMirrorEditor */ "../ui/packages/react/lib/components/codemirror/CodeMirrorEditor.js");
/* harmony import */ var _OutputRenderer__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./OutputRenderer */ "../ui/packages/react/lib/components/output/OutputRenderer.js");













const KernelProgressMenu = (props) => {
    const { outputAdapter } = props;
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.ActionMenu, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.ActionMenu.Anchor, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_5__.IconButton, { "aria-labelledby": "", icon: _primer_octicons_react__WEBPACK_IMPORTED_MODULE_6__.KebabHorizontalIcon, variant: "invisible" }) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_4__.ActionMenu.Overlay, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_7__.ActionList, { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_7__.ActionList.Item, { onSelect: e => { e.preventDefault(); outputAdapter.interrupt(); }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_7__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_6__.StopIcon, {}) }), "Interrupt kernel"] }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_7__.ActionList.Item, { variant: "danger", onClick: e => { e.preventDefault(); outputAdapter.clearOutput(); }, children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_7__.ActionList.LeadingVisual, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_octicons_react__WEBPACK_IMPORTED_MODULE_6__.PaintbrushIcon, {}) }), "Clear outputs"] })] }) })] }));
};
const KernelProgressBar = () => {
    const [progress, setProgress] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(0);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        const interval = setInterval(() => {
            setProgress((oldValue) => {
                let newValue = oldValue + 1;
                if (newValue > 100) {
                    newValue = 0;
                }
                return newValue;
            });
        }, 100);
        return () => clearInterval(interval);
    }, []);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_8__.ProgressBar, { progress: progress, barSize: "small" }));
};
const Output = (props) => {
    const { injectableStore, defaultKernel: kernel } = (0,_jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_9__.useJupyter)();
    const { sourceId, autoRun, code, showEditor, clearTrigger, executeTrigger, adapter, receipt, disableRun, insertText, toolbarPosition, codePre, luminoWidgets: useLumino } = props;
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_2__.useDispatch)();
    const [id, setId] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(sourceId);
    const [kernelStatus, setKernelStatus] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)('unknown');
    const [outputAdapter, setOutputAdapter] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    const [outputs, setOutputs] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(props.outputs);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => {
        injectableStore.inject('output', _OutputState__WEBPACK_IMPORTED_MODULE_10__.outputReducer);
    }, [sourceId]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (!id) {
            setId(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_3__.UUID.uuid4());
        }
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (id && kernel) {
            const outputAdapter = adapter || new _OutputAdapter__WEBPACK_IMPORTED_MODULE_11__["default"](kernel, outputs || []);
            if (receipt) {
                outputAdapter.outputArea.model.changed.connect((sender, change) => {
                    if (change.type === 'add') {
                        change.newValues.map(val => {
                            if (val && val.data) {
                                const out = val.data['text/html']; // val.data['application/vnd.jupyter.stdout'];
                                if (out) {
                                    if (out.indexOf(receipt) > -1) {
                                        dispatch(_OutputState__WEBPACK_IMPORTED_MODULE_10__.outputActions.grade({
                                            sourceId,
                                            success: true,
                                        }));
                                    }
                                }
                            }
                        });
                    }
                });
            }
            setOutputAdapter(outputAdapter);
            outputAdapter.outputArea.model.changed.connect((outputModel, args) => {
                setOutputs(outputModel.toJSON());
            });
        }
    }, [id, kernel]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (outputAdapter) {
            if (!outputAdapter.kernel) {
                outputAdapter.kernel = kernel;
            }
            if (autoRun) {
                outputAdapter.execute(code);
            }
        }
    }, [outputAdapter]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (kernel) {
            kernel.connection.then((kernelConnection) => {
                setKernelStatus(kernelConnection.status);
                kernelConnection.statusChanged.connect((kernelConnection, status) => {
                    setKernelStatus(status);
                });
            });
            return () => {
                //        kernel.connection.then(k => k.shutdown().then(() => console.log(`Kernel ${k.id} is terminated.`)));
            };
        }
    }, [kernel]);
    const executeRequest = (0,_OutputState__WEBPACK_IMPORTED_MODULE_10__.selectExecute)(sourceId);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (outputAdapter && executeRequest && executeRequest.sourceId === id) {
            outputAdapter.execute(executeRequest.source);
        }
    }, [executeRequest, outputAdapter]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (outputAdapter && executeTrigger > 0) {
            outputAdapter.execute(code);
        }
    }, [executeTrigger]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (outputAdapter && clearTrigger > 0) {
            outputAdapter.clearOutput();
        }
    }, [clearTrigger, outputAdapter]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: [showEditor && outputAdapter && id &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_12__["default"], { sx: {
                        '& .cm-editor': {
                            borderRadius: '5px',
                        },
                    }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_codemirror_CodeMirrorEditor__WEBPACK_IMPORTED_MODULE_13__["default"], { autoRun: autoRun, code: code, codePre: codePre, kernel: kernel, outputAdapter: outputAdapter, sourceId: id, disableRun: disableRun, insertText: insertText, toolbarPosition: toolbarPosition }) }), outputAdapter &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(_primer_react__WEBPACK_IMPORTED_MODULE_12__["default"], { display: "flex", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_12__["default"], { flexGrow: 1, children: kernelStatus !== 'idle' && (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(KernelProgressBar, {}) }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_12__["default"], { style: { marginTop: "-13px" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(KernelProgressMenu, { outputAdapter: outputAdapter }) })] }), outputs &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_12__["default"], { sx: {
                        '& .jp-OutputArea': {
                            fontSize: '10px',
                        },
                        '& .jp-OutputPrompt': {
                        //              display: 'none',
                        },
                        '& .jp-OutputArea-prompt': {
                            display: 'none',
                            //              width: '0px',
                        },
                        '& pre': {
                            fontSize: '12px',
                            wordBreak: 'break-all',
                            wordWrap: 'break-word',
                            whiteSpace: 'pre-wrap',
                        },
                    }, children: useLumino
                        ?
                            (outputAdapter &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_14__["default"], { children: outputAdapter.outputArea }))
                        :
                            (outputs &&
                                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: outputs.map((output) => {
                                        return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_OutputRenderer__WEBPACK_IMPORTED_MODULE_15__["default"], { output: output });
                                    }) })) })] }));
};
Output.defaultProps = {
    outputs: [
        {
            "output_type": "execute_result",
            "data": {
                "text/html": [
                    "<p>Type code in the cell and Shift+Enter to execute.</p>"
                ]
            },
            "execution_count": 0,
            "metadata": {},
        }
    ],
    disableRun: false,
    toolbarPosition: 'up',
    executeTrigger: 0,
    clearTrigger: 0,
    luminoWidgets: true,
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Output);


/***/ }),

/***/ "../ui/packages/react/lib/components/output/OutputAdapter.js":
/*!*******************************************************************!*\
  !*** ../ui/packages/react/lib/components/output/OutputAdapter.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "OutputAdapter": () => (/* binding */ OutputAdapter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/outputarea */ "webpack/sharing/consume/default/@jupyterlab/outputarea");
/* harmony import */ var _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/rendermime */ "webpack/sharing/consume/default/@jupyterlab/rendermime");
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/json-extension */ "webpack/sharing/consume/default/@jupyterlab/json-extension");
/* harmony import */ var _jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/javascript-extension */ "webpack/sharing/consume/default/@jupyterlab/javascript-extension");
/* harmony import */ var _jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyter-widgets/html-manager */ "../../../node_modules/@jupyter-widgets/html-manager/lib/index.js");
/* harmony import */ var _jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyter-widgets/html-manager/lib/output_renderers */ "../../../node_modules/@jupyter-widgets/html-manager/lib/output_renderers.js");
/* harmony import */ var _jupyter_ipywidgets_IPyWidgetsClassicManager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../../jupyter/ipywidgets/IPyWidgetsClassicManager */ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsClassicManager.js");







// import { activateWidgetExtension } from "./../../jupyter/ipywidgets/IPyWidgetsJupyterLabPlugin";
// import { activatePlotlyWidgetExtension } from "./../../jupyter/ipywidgets/plotly/JupyterlabPlugin";
class OutputAdapter {
    _kernel;
    _renderers;
    _outputArea;
    _rendermime;
    _iPyWidgetsClassicManager;
    constructor(kernel, outputs) {
        this._kernel = kernel;
        this._renderers = _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__.standardRendererFactories.filter(factory => factory.mimeTypes[0] !== 'text/javascript');
        this._renderers.push(_jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2__.rendererFactory);
        this._renderers.push(_jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3__.rendererFactory);
        this._rendermime = new _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__.RenderMimeRegistry({
            initialFactories: this._renderers,
        });
        this._iPyWidgetsClassicManager = new _jupyter_ipywidgets_IPyWidgetsClassicManager__WEBPACK_IMPORTED_MODULE_6__.IPyWidgetsClassicManager({ loader: _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_4__.requireLoader });
        this._rendermime.addFactory({
            safe: false,
            mimeTypes: [_jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_5__.WIDGET_MIMETYPE],
            createRenderer: (options) => new _jupyter_widgets_html_manager_lib_output_renderers__WEBPACK_IMPORTED_MODULE_5__.WidgetRenderer(options, this._iPyWidgetsClassicManager),
        }, 0);
        //    const widgetRegistry = activateWidgetExtension(this._rendermime, null, null, null);
        //    activatePlotlyWidgetExtension(widgetRegistry);
        const outputAreaModel = new _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__.OutputAreaModel({
            trusted: true,
            values: outputs,
        });
        this._outputArea = new _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__.OutputArea({
            model: outputAreaModel,
            rendermime: this._rendermime,
        });
        this.initKernel();
    }
    execute(code) {
        if (this._kernel) {
            this.clearOutput();
            this._kernel.connection.then((kernelConnection) => {
                this._outputArea.future = kernelConnection.requestExecute({ code });
            });
        }
    }
    interrupt() {
        if (this._kernel) {
            this._kernel.connection.then((kernelConnection) => {
                kernelConnection.interrupt();
            });
        }
    }
    clearOutput() {
        this._outputArea.model.clear();
    }
    get kernel() {
        return this._kernel;
    }
    set kernel(kernel) {
        this._kernel = kernel;
        this.initKernel();
    }
    get outputArea() {
        return this._outputArea;
    }
    initKernel() {
        if (this._kernel) {
            this._kernel.connection.then((kernelConnection) => {
                this._iPyWidgetsClassicManager.registerWithKernel(kernelConnection);
            });
        }
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (OutputAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/output/OutputRenderer.js":
/*!********************************************************************!*\
  !*** ../ui/packages/react/lib/components/output/OutputRenderer.js ***!
  \********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "OutputRenderer": () => (/* binding */ OutputRenderer),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");

/*
{
    "execution_count": 2,
    "output_type": "execute_result",
    "data": {
        "text/plain": "IntSlider(value=7, max=10)",
        "application/vnd.jupyter.widget-view+json": {
            "version_major": 2,
            "version_minor": 0,
            "model_id": "cf2eac02dda44b08befe1657e1de73a2"
        }
    },
    "metadata": {}
}
{
    "name": "stdout",
    "text": "1\n1\n",
    "output_type": "stream"
}
{
    "traceback": [
        "\u001b[0;36m  Input \u001b[0;32mIn [4]\u001b[0;36m\u001b[0m\n\u001b[0;31m    x=1sdfsq\u001b[0m\n\u001b[0m      ^\u001b[0m\n\u001b[0;31mSyntaxError\u001b[0m\u001b[0;31m:\u001b[0m invalid decimal literal\n"
    ],
    "ename": "SyntaxError",
    "evalue": "invalid decimal literal (2376046737.py, line 1)",
    "output_type": "error"
}
*/
const OutputRenderer = (props) => {
    const { output } = props;
    let plain;
    let html;
    let img;
    switch (output.output_type) {
        case "error": {
            plain = output.traceback.join('\n');
            break;
        }
        case "stream": {
            const t = output.text;
            if (typeof t === "string") {
                plain = t;
            }
            else if (typeof t === "boolean") {
                plain = t ? "true" : "false";
            }
            else if (Array.isArray(t)) {
                plain = t.join('\n');
            }
            else
                plain = t?.toString();
            break;
        }
        case "display_data": {
            const data = output.data;
            if (data) {
                const image_png = data["image/png"];
                if (image_png) {
                    img = image_png;
                }
            }
            break;
        }
        case "execute_result": {
            const data = output.data;
            if (data) {
                const text_plain = data["text/plain"];
                if (text_plain) {
                    if (typeof text_plain === "string") {
                        plain = text_plain;
                    }
                    else if (Array.isArray(text_plain)) {
                        plain = text_plain.join('\n');
                    }
                    else
                        plain = text_plain.toString();
                }
                const text_html = data["text/html"];
                if (text_html) {
                    if (typeof text_html === "string") {
                        html = text_html;
                    }
                    else {
                        html = text_html.join('\n');
                    }
                }
            }
            break;
        }
    }
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: [plain &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("pre", { style: {
                        color: "black",
                        backgroundColor: "white",
                    }, children: plain }), html &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { dangerouslySetInnerHTML: { __html: html } }) }), img &&
                (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("img", { src: `data:image/png;base64,${img}` }) })] }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (OutputRenderer);


/***/ }),

/***/ "../ui/packages/react/lib/components/output/OutputState.js":
/*!*****************************************************************!*\
  !*** ../ui/packages/react/lib/components/output/OutputState.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "OutputActionType": () => (/* binding */ OutputActionType),
/* harmony export */   "outputActions": () => (/* binding */ outputActions),
/* harmony export */   "outputInitialState": () => (/* binding */ outputInitialState),
/* harmony export */   "outputReducer": () => (/* binding */ outputReducer),
/* harmony export */   "selectDataset": () => (/* binding */ selectDataset),
/* harmony export */   "selectExecute": () => (/* binding */ selectExecute),
/* harmony export */   "selectGrade": () => (/* binding */ selectGrade),
/* harmony export */   "selectJupyterSetSource": () => (/* binding */ selectJupyterSetSource),
/* harmony export */   "selectJupyterSource": () => (/* binding */ selectJupyterSource)
/* harmony export */ });
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const outputInitialState = {
    outputs: new Map(),
};
/* Selectors */
const selectJupyterSource = (id) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.output) {
        return state.output.outputs.get(id)?.source;
    }
    return undefined;
});
const selectJupyterSetSource = (id) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.output) {
        return state.output.outputs.get(id)?.setSource;
    }
    return undefined;
});
const selectDataset = (id) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.output) {
        return state.output.outputs.get(id)?.dataset;
    }
    return undefined;
});
const selectExecute = (id) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.output) {
        return state.output.outputs.get(id)?.execute;
    }
    return undefined;
});
const selectGrade = (id) => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.output) {
        return state.output.outputs.get(id)?.grade;
    }
    return undefined;
});
/* Actions */
var OutputActionType;
(function (OutputActionType) {
    OutputActionType["SOURCE"] = "output/SOURCE";
    OutputActionType["DATASET"] = "output/DATASET";
    OutputActionType["EXECUTE"] = "output/EXECUTE";
    OutputActionType["SET_SOURCE"] = "output/SET_SOURCE";
    OutputActionType["GRADE"] = "output/GRADE";
})(OutputActionType || (OutputActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_1__["default"])('jupyterOutput');
const outputActions = {
    source: actionCreator(OutputActionType.SOURCE),
    dataset: actionCreator(OutputActionType.DATASET),
    execute: actionCreator(OutputActionType.EXECUTE),
    setSource: actionCreator(OutputActionType.SET_SOURCE),
    grade: actionCreator(OutputActionType.GRADE),
};
/* Reducers */
const outputReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(outputInitialState)
    .case(outputActions.source, (state, source) => {
    const sourceId = source.sourceId;
    const outputs = state.outputs;
    const s = outputs.get(sourceId);
    if (s) {
        s.source = source;
    }
    else {
        outputs.set(sourceId, { source });
    }
    return {
        ...state,
        outputs,
    };
})
    .case(outputActions.dataset, (state, dataset) => {
    const sourceId = dataset.sourceId;
    const outputs = state.outputs;
    const d = outputs.get(sourceId);
    if (d) {
        d.dataset = dataset;
    }
    else {
        outputs.set(sourceId, { dataset });
    }
    return {
        ...state,
        outputs,
    };
})
    .case(outputActions.execute, (state, execute) => {
    const sourceId = execute.sourceId;
    const outputs = state.outputs;
    const e = outputs.get(sourceId);
    if (e) {
        e.execute = execute;
    }
    else {
        outputs.set(sourceId, { execute });
    }
    return {
        ...state,
        outputs,
    };
})
    .case(outputActions.setSource, (state, setSource) => {
    const sourceId = setSource.sourceId;
    const outputs = state.outputs;
    const s = outputs.get(sourceId);
    if (s) {
        s.setSource = setSource;
    }
    else {
        outputs.set(sourceId, { setSource });
    }
    return {
        ...state,
        outputs,
    };
})
    .case(outputActions.grade, (state, grade) => {
    const sourceId = grade.sourceId;
    const outputs = state.outputs;
    const g = outputs.get(sourceId);
    if (g) {
        g.grade = grade;
    }
    else {
        outputs.set(sourceId, { grade });
    }
    return {
        ...state,
        outputs,
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/settings/Settings.js":
/*!****************************************************************!*\
  !*** ../ui/packages/react/lib/components/settings/Settings.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Settings": () => (/* binding */ Settings),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _SettingsAdapter__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./SettingsAdapter */ "../ui/packages/react/lib/components/settings/SettingsAdapter.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");



const Settings = () => {
    const settingsAdapter = new _SettingsAdapter__WEBPACK_IMPORTED_MODULE_1__["default"]();
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__["default"], { children: settingsAdapter.panel }) });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Settings);


/***/ }),

/***/ "../ui/packages/react/lib/components/settings/SettingsAdapter.js":
/*!***********************************************************************!*\
  !*** ../ui/packages/react/lib/components/settings/SettingsAdapter.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_0__);


class SettingsAdapter {
    settingsPanel;
    constructor() {
        this.settingsPanel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.DockPanel();
        this.settingsPanel.id = 'dla-jlab-settings';
        this.settingsPanel.spacing = 0;
    }
    get panel() {
        return this.settingsPanel;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (SettingsAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/settings/SettingsState.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/components/settings/SettingsState.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "SettingsActionType": () => (/* binding */ SettingsActionType),
/* harmony export */   "selectSettings": () => (/* binding */ selectSettings),
/* harmony export */   "settingsActions": () => (/* binding */ settingsActions),
/* harmony export */   "settingsInitialState": () => (/* binding */ settingsInitialState),
/* harmony export */   "settingsReducer": () => (/* binding */ settingsReducer)
/* harmony export */ });
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const settingsInitialState = {
    outputs: 0,
};
/* Selectors */
const selectSettings = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.settings) {
        return state.settings;
    }
    return { outputs: 0 };
});
/* Actions */
var SettingsActionType;
(function (SettingsActionType) {
    SettingsActionType["OUTPUTS"] = "settings/OUTPUTS";
    SettingsActionType["EXECUTE"] = "settings/EXECUTE";
})(SettingsActionType || (SettingsActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_1__["default"])('jupyterReact');
const settingsActions = {
    outputs: actionCreator(SettingsActionType.OUTPUTS),
    execute: actionCreator(SettingsActionType.EXECUTE),
};
/* Reducers */
const settingsReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(settingsInitialState)
    .case(settingsActions.outputs, (state, success) => {
    return {
        ...state,
        outputs: success
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/terminal/Terminal.js":
/*!****************************************************************!*\
  !*** ../ui/packages/react/lib/components/terminal/Terminal.js ***!
  \****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Terminal": () => (/* binding */ Terminal),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _TerminalAdapter__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./TerminalAdapter */ "../ui/packages/react/lib/components/terminal/TerminalAdapter.js");
/* harmony import */ var _TerminalState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./TerminalState */ "../ui/packages/react/lib/components/terminal/TerminalState.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./../../jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");







const Terminal = () => {
    const { injectableStore } = (0,_jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_3__.useJupyter)();
    const dispatch = (0,react_redux__WEBPACK_IMPORTED_MODULE_2__.useDispatch)();
    const [adapter, setAdapter] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useMemo)(() => {
        injectableStore.inject('terminal', _TerminalState__WEBPACK_IMPORTED_MODULE_4__.terminalReducer);
    }, []);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        const adapter = new _TerminalAdapter__WEBPACK_IMPORTED_MODULE_5__["default"]();
        dispatch(_TerminalState__WEBPACK_IMPORTED_MODULE_4__.terminalActions.update({ adapter }));
        setAdapter(adapter);
    }, []);
    return adapter
        ?
            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_6__["default"], { children: adapter.panel })
        :
            (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: "Loading Jupyter Terminal..." });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Terminal);


/***/ }),

/***/ "../ui/packages/react/lib/components/terminal/TerminalAdapter.js":
/*!***********************************************************************!*\
  !*** ../ui/packages/react/lib/components/terminal/TerminalAdapter.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "TerminalAdapter": () => (/* binding */ TerminalAdapter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_terminal__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/terminal */ "webpack/sharing/consume/default/@jupyterlab/terminal");
/* harmony import */ var _jupyterlab_terminal__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_terminal__WEBPACK_IMPORTED_MODULE_2__);




class TerminalAdapter {
    terminalPanel;
    terminal;
    constructor() {
        this.terminalPanel = new _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.BoxPanel();
        this.terminalPanel.addClass('dla-JupyterLab-terminal');
        this.terminalPanel.spacing = 0;
        const manager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.TerminalManager();
        manager.startNew().then((terminalConnection) => {
            this.terminal = new _jupyterlab_terminal__WEBPACK_IMPORTED_MODULE_2__.Terminal(terminalConnection, { theme: 'light' });
            this.terminal.title.closable = true;
            this.terminalPanel.addWidget(this.terminal);
        });
    }
    get panel() {
        return this.terminalPanel;
    }
    setTheme(theme) {
        this.terminal.setOption('theme', theme);
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (TerminalAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/terminal/TerminalState.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/components/terminal/TerminalState.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "TerminalActionType": () => (/* binding */ TerminalActionType),
/* harmony export */   "selectTerminal": () => (/* binding */ selectTerminal),
/* harmony export */   "terminalActions": () => (/* binding */ terminalActions),
/* harmony export */   "terminalInitialState": () => (/* binding */ terminalInitialState),
/* harmony export */   "terminalReducer": () => (/* binding */ terminalReducer)
/* harmony export */ });
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const terminalInitialState = {
    dark: false,
};
/* Selectors */
const selectTerminal = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.terminal) {
        return state.terminal;
    }
    return terminalInitialState;
});
/* Actions */
var TerminalActionType;
(function (TerminalActionType) {
    TerminalActionType["UPDATE"] = "terminal/UPDATE";
})(TerminalActionType || (TerminalActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_1__["default"])('jupyterReact');
const terminalActions = {
    update: actionCreator(TerminalActionType.UPDATE),
};
/* Reducers */
const terminalReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(terminalInitialState)
    .case(terminalActions.update, (state, update) => {
    if (state.adapter) {
        if (update.dark !== undefined) {
            if (update.dark) {
                state.adapter.setTheme('dark');
            }
            else {
                state.adapter.setTheme('light');
            }
        }
    }
    return {
        ...state,
        ...update,
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/components/viewer/Viewer.js":
/*!************************************************************!*\
  !*** ../ui/packages/react/lib/components/viewer/Viewer.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Viewer": () => (/* binding */ Viewer),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _input_InputViewer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./input/InputViewer */ "../ui/packages/react/lib/components/viewer/input/InputViewer.js");
/* harmony import */ var _output_OutputViewer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./output/OutputViewer */ "../ui/packages/react/lib/components/viewer/output/OutputViewer.js");
/* harmony import */ var _jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./../../jupyter/utils/Ids */ "../ui/packages/react/lib/jupyter/utils/Ids.js");





const Viewer = (props) => {
    const { nbformat, outputs } = props;
    const [model, setModel] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        setModel(nbformat);
    }, [nbformat]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: model?.cells.map(cell => {
            return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)("div", { children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_input_InputViewer__WEBPACK_IMPORTED_MODULE_2__["default"], { cell: cell, languageInfo: nbformat.metadata.language_info }), outputs && (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_output_OutputViewer__WEBPACK_IMPORTED_MODULE_3__["default"], { cell: cell })] }, cell.id?.toString() || (0,_jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_4__.newUuid)()));
        }) }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Viewer);


/***/ }),

/***/ "../ui/packages/react/lib/components/viewer/input/InputViewer.js":
/*!***********************************************************************!*\
  !*** ../ui/packages/react/lib/components/viewer/input/InputViewer.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/codemirror */ "webpack/sharing/consume/default/@jupyterlab/codemirror");
/* harmony import */ var _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/rendermime */ "webpack/sharing/consume/default/@jupyterlab/rendermime");
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/cells */ "webpack/sharing/consume/default/@jupyterlab/cells");
/* harmony import */ var _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/mathjax-extension */ "webpack/sharing/consume/default/@jupyterlab/mathjax-extension");
/* harmony import */ var _jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyter/ydoc */ "webpack/sharing/consume/default/@jupyter/ydoc");
/* harmony import */ var _jupyter_ydoc__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _notebook_marked_marked__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./../../notebook/marked/marked */ "../ui/packages/react/lib/components/notebook/marked/marked.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");








const themes = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.EditorThemeRegistry();
const editorExtensions = () => {
    const registry = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.EditorExtensionRegistry();
    for (const extensionFactory of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.EditorExtensionRegistry.getDefaultExtensions({ themes })) {
        registry.addExtension(extensionFactory);
    }
    registry.addExtension({
        name: 'shared-model-binding',
        factory: options => {
            const sharedModel = options.model.sharedModel;
            return _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.EditorExtensionRegistry.createImmutableExtension((0,_jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.ybinding)({
                ytext: sharedModel.ysource,
                undoManager: sharedModel.undoManager ?? undefined
            }));
        }
    });
    return registry;
};
const languages = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.EditorLanguageRegistry();
for (const language of _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.EditorLanguageRegistry.getDefaultLanguages()) {
    languages.addLanguage(language);
}
languages.addLanguage({
    name: 'ipythongfm',
    mime: 'text/x-ipythongfm',
    load: async () => {
        // TODO: add support for LaTeX
        const m = await __webpack_require__.e(/*! import() */ "vendors-node_modules_codemirror_lang-markdown_dist_index_js").then(__webpack_require__.bind(__webpack_require__, /*! @codemirror/lang-markdown */ "../../../node_modules/@codemirror/lang-markdown/dist/index.js"));
        return m.markdown({
            codeLanguages: (info) => languages.findBest(info)
        });
    }
});
const rendermime = new _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_2__.RenderMimeRegistry({
    initialFactories: _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_2__.standardRendererFactories,
    latexTypesetter: new _jupyterlab_mathjax_extension__WEBPACK_IMPORTED_MODULE_4__.MathJaxTypesetter(),
    markdownParser: (0,_notebook_marked_marked__WEBPACK_IMPORTED_MODULE_6__.getMarked)(languages),
});
const factoryService = new _jupyterlab_codemirror__WEBPACK_IMPORTED_MODULE_1__.CodeMirrorEditorFactory({
    extensions: editorExtensions(),
    languages,
});
const InputViewer = (props) => {
    const { cell, languageInfo } = props;
    switch (cell.cell_type) {
        case 'code': {
            const codeCell = new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCell({
                rendermime,
                model: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.CodeCellModel({
                    sharedModel: (0,_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_5__.createStandaloneCell)(cell)
                }),
                editorConfig: {
                    readOnly: true,
                },
                contentFactory: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.Cell.ContentFactory({
                    editorFactory: factoryService.newInlineEditor.bind(factoryService)
                })
            }).initializeState();
            if (languageInfo && languageInfo.mimetype) {
                codeCell.model.mimeType = languageInfo.mimetype;
            }
            return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_7__["default"], { children: codeCell }) }));
        }
        case 'markdown': {
            const markdownCell = new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.MarkdownCell({
                rendermime,
                showEditorForReadOnlyMarkdown: false,
                model: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.MarkdownCellModel({
                    sharedModel: (0,_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_5__.createStandaloneCell)(cell)
                }),
                contentFactory: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.Cell.ContentFactory({
                    editorFactory: factoryService.newInlineEditor.bind(factoryService)
                })
            }).initializeState();
            return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_7__["default"], { children: markdownCell }) }));
        }
        case 'raw': {
            const rawCell = new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.RawCell({
                model: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.RawCellModel({
                    sharedModel: (0,_jupyter_ydoc__WEBPACK_IMPORTED_MODULE_5__.createStandaloneCell)(cell)
                }),
                contentFactory: new _jupyterlab_cells__WEBPACK_IMPORTED_MODULE_3__.Cell.ContentFactory({
                    editorFactory: factoryService.newInlineEditor.bind(factoryService)
                })
            });
            return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_7__["default"], { children: rawCell }) }));
        }
        default: {
            return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, {});
        }
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (InputViewer);


/***/ }),

/***/ "../ui/packages/react/lib/components/viewer/output/OutputAdapter.js":
/*!**************************************************************************!*\
  !*** ../ui/packages/react/lib/components/viewer/output/OutputAdapter.js ***!
  \**************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "OutputAdapter": () => (/* binding */ OutputAdapter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/outputarea */ "webpack/sharing/consume/default/@jupyterlab/outputarea");
/* harmony import */ var _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/rendermime */ "webpack/sharing/consume/default/@jupyterlab/rendermime");
/* harmony import */ var _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyterlab/json-extension */ "webpack/sharing/consume/default/@jupyterlab/json-extension");
/* harmony import */ var _jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/javascript-extension */ "webpack/sharing/consume/default/@jupyterlab/javascript-extension");
/* harmony import */ var _jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3__);




class OutputAdapter {
    _renderers;
    _outputArea;
    _rendermime;
    constructor(outputs) {
        this._renderers = _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__.standardRendererFactories.filter(factory => factory.mimeTypes[0] !== 'text/javascript');
        this._renderers.push(_jupyterlab_json_extension__WEBPACK_IMPORTED_MODULE_2__.rendererFactory);
        this._renderers.push(_jupyterlab_javascript_extension__WEBPACK_IMPORTED_MODULE_3__.rendererFactory);
        this._rendermime = new _jupyterlab_rendermime__WEBPACK_IMPORTED_MODULE_1__.RenderMimeRegistry({
            initialFactories: this._renderers,
        });
        const outputAreaModel = new _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__.OutputAreaModel({
            trusted: true,
            values: outputs,
        });
        this._outputArea = new _jupyterlab_outputarea__WEBPACK_IMPORTED_MODULE_0__.OutputArea({
            model: outputAreaModel,
            rendermime: this._rendermime,
        });
    }
    clearOutput() {
        this._outputArea.model.clear();
    }
    get outputArea() {
        return this._outputArea;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (OutputAdapter);


/***/ }),

/***/ "../ui/packages/react/lib/components/viewer/output/OutputViewer.js":
/*!*************************************************************************!*\
  !*** ../ui/packages/react/lib/components/viewer/output/OutputViewer.js ***!
  \*************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../../jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");
/* harmony import */ var _OutputAdapter__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./OutputAdapter */ "../ui/packages/react/lib/components/viewer/output/OutputAdapter.js");



const OutputViewer = (props) => {
    const { cell } = props;
    const outputs = cell.outputs ? cell.outputs : undefined;
    const outputAdapter = new _OutputAdapter__WEBPACK_IMPORTED_MODULE_1__["default"](outputs);
    switch (cell.cell_type) {
        case 'code': {
            return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_2__["default"], { children: outputAdapter.outputArea }) }));
        }
        default:
            return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.Fragment, {});
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (OutputViewer);


/***/ }),

/***/ "../ui/packages/react/lib/index.js":
/*!*****************************************!*\
  !*** ../ui/packages/react/lib/index.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ActionType": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.ActionType),
/* harmony export */   "Cell": () => (/* reexport safe */ _components_cell_Cell__WEBPACK_IMPORTED_MODULE_16__.Cell),
/* harmony export */   "CellActionType": () => (/* reexport safe */ _components_cell_CellState__WEBPACK_IMPORTED_MODULE_18__.CellActionType),
/* harmony export */   "CellAdapter": () => (/* reexport safe */ _components_cell_CellAdapter__WEBPACK_IMPORTED_MODULE_17__.CellAdapter),
/* harmony export */   "CellMetadataEditor": () => (/* reexport safe */ _components_notebook_cell_metadata_CellMetadataEditor__WEBPACK_IMPORTED_MODULE_23__.CellMetadataEditor),
/* harmony export */   "CellSidebarDefault": () => (/* reexport safe */ _components_notebook_cell_sidebar_CellSidebarDefault__WEBPACK_IMPORTED_MODULE_28__.CellSidebarDefault),
/* harmony export */   "CellSidebarRun": () => (/* reexport safe */ _components_notebook_cell_sidebar_CellSidebarRun__WEBPACK_IMPORTED_MODULE_29__.CellSidebarRun),
/* harmony export */   "CellSidebarWidget": () => (/* reexport safe */ _components_notebook_cell_sidebar_lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_27__.CellSidebarWidget),
/* harmony export */   "CodeMirrorEditor": () => (/* reexport safe */ _components_codemirror_CodeMirrorEditor__WEBPACK_IMPORTED_MODULE_19__.CodeMirrorEditor),
/* harmony export */   "Commands": () => (/* reexport safe */ _components_commands_Commands__WEBPACK_IMPORTED_MODULE_30__.Commands),
/* harmony export */   "CommandsActionType": () => (/* reexport safe */ _components_commands_CommandsState__WEBPACK_IMPORTED_MODULE_31__.CommandsActionType),
/* harmony export */   "Console": () => (/* reexport safe */ _components_console_Console__WEBPACK_IMPORTED_MODULE_32__.Console),
/* harmony export */   "ConsoleActionType": () => (/* reexport safe */ _components_console_ConsoleState__WEBPACK_IMPORTED_MODULE_33__.ConsoleActionType),
/* harmony export */   "CountdownInputPrompt": () => (/* reexport safe */ _components_notebook_cell_prompt_CountdownInputPrompt__WEBPACK_IMPORTED_MODULE_25__.CountdownInputPrompt),
/* harmony export */   "DATALAYER_CELL_HEADER_CLASS": () => (/* reexport safe */ _components_notebook_cell_sidebar_lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_27__.DATALAYER_CELL_HEADER_CLASS),
/* harmony export */   "Dialog": () => (/* reexport safe */ _components_dialog_Dialog__WEBPACK_IMPORTED_MODULE_34__.Dialog),
/* harmony export */   "FileBrowser": () => (/* reexport safe */ _components_filebrowser_FileBrowser__WEBPACK_IMPORTED_MODULE_35__.FileBrowser),
/* harmony export */   "FileBrowserActionType": () => (/* reexport safe */ _components_filebrowser_FileBrowserState__WEBPACK_IMPORTED_MODULE_37__.FileBrowserActionType),
/* harmony export */   "FileBrowserLab": () => (/* reexport safe */ _components_filebrowser_FileBrowserLab__WEBPACK_IMPORTED_MODULE_36__.FileBrowserLab),
/* harmony export */   "IPyWidgetsManager": () => (/* reexport safe */ _jupyter_ipywidgets_IPyWidgetsManager__WEBPACK_IMPORTED_MODULE_14__.IPyWidgetsManager),
/* harmony export */   "IPyWidgetsOutput": () => (/* reexport safe */ _components_ipywidgets_IPyWidgetsOutput__WEBPACK_IMPORTED_MODULE_15__.IPyWidgetsOutput),
/* harmony export */   "Jupyter": () => (/* reexport safe */ _jupyter_Jupyter__WEBPACK_IMPORTED_MODULE_0__.Jupyter),
/* harmony export */   "JupyterContext": () => (/* reexport safe */ _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.JupyterContext),
/* harmony export */   "JupyterContextConsumer": () => (/* reexport safe */ _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.JupyterContextConsumer),
/* harmony export */   "JupyterContextProvider": () => (/* reexport safe */ _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.JupyterContextProvider),
/* harmony export */   "JupyterReactContentFactory": () => (/* reexport safe */ _components_notebook_content_JupyterReactContentFactory__WEBPACK_IMPORTED_MODULE_26__.JupyterReactContentFactory),
/* harmony export */   "Kernel": () => (/* reexport safe */ _jupyter_services_kernel_Kernel__WEBPACK_IMPORTED_MODULE_12__.Kernel),
/* harmony export */   "KernelModel": () => (/* reexport safe */ _jupyter_services_kernel_KernelModel__WEBPACK_IMPORTED_MODULE_13__.KernelModel),
/* harmony export */   "Lumino": () => (/* reexport safe */ _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_4__.Lumino),
/* harmony export */   "LuminoDetached": () => (/* reexport safe */ _jupyter_lumino_LuminoDetached__WEBPACK_IMPORTED_MODULE_5__.LuminoDetached),
/* harmony export */   "LuminoNotebook": () => (/* reexport safe */ _jupyter_lumino_LuminoNotebook__WEBPACK_IMPORTED_MODULE_6__.LuminoNotebook),
/* harmony export */   "NbGraderType": () => (/* reexport safe */ _components_notebook_cell_metadata_NbGraderCells__WEBPACK_IMPORTED_MODULE_24__.NbGraderType),
/* harmony export */   "Notebook": () => (/* reexport safe */ _components_notebook_Notebook__WEBPACK_IMPORTED_MODULE_20__.Notebook),
/* harmony export */   "NotebookAdapter": () => (/* reexport safe */ _components_notebook_NotebookAdapter__WEBPACK_IMPORTED_MODULE_21__.NotebookAdapter),
/* harmony export */   "Output": () => (/* reexport safe */ _components_output_Output__WEBPACK_IMPORTED_MODULE_38__.Output),
/* harmony export */   "OutputActionType": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.OutputActionType),
/* harmony export */   "OutputAdapter": () => (/* reexport safe */ _components_output_OutputAdapter__WEBPACK_IMPORTED_MODULE_39__.OutputAdapter),
/* harmony export */   "ReactPortalWidget": () => (/* reexport safe */ _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_8__.ReactPortalWidget),
/* harmony export */   "Services": () => (/* reexport safe */ _jupyter_services_Services__WEBPACK_IMPORTED_MODULE_11__.Services),
/* harmony export */   "Settings": () => (/* reexport safe */ _components_settings_Settings__WEBPACK_IMPORTED_MODULE_41__.Settings),
/* harmony export */   "SettingsActionType": () => (/* reexport safe */ _components_settings_SettingsState__WEBPACK_IMPORTED_MODULE_42__.SettingsActionType),
/* harmony export */   "Terminal": () => (/* reexport safe */ _components_terminal_Terminal__WEBPACK_IMPORTED_MODULE_43__.Terminal),
/* harmony export */   "TerminalActionType": () => (/* reexport safe */ _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_44__.TerminalActionType),
/* harmony export */   "UseSignal": () => (/* reexport safe */ _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_8__.UseSignal),
/* harmony export */   "VDomModel": () => (/* reexport safe */ _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_8__.VDomModel),
/* harmony export */   "VDomRenderer": () => (/* reexport safe */ _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_8__.VDomRenderer),
/* harmony export */   "Viewer": () => (/* reexport safe */ _components_viewer_Viewer__WEBPACK_IMPORTED_MODULE_45__.Viewer),
/* harmony export */   "asObservable": () => (/* reexport safe */ _jupyter_lumino_LuminoObservable__WEBPACK_IMPORTED_MODULE_7__.asObservable),
/* harmony export */   "cellActions": () => (/* reexport safe */ _components_cell_CellState__WEBPACK_IMPORTED_MODULE_18__.cellActions),
/* harmony export */   "cellInitialState": () => (/* reexport safe */ _components_cell_CellState__WEBPACK_IMPORTED_MODULE_18__.cellInitialState),
/* harmony export */   "cellReducer": () => (/* reexport safe */ _components_cell_CellState__WEBPACK_IMPORTED_MODULE_18__.cellReducer),
/* harmony export */   "commandsActions": () => (/* reexport safe */ _components_commands_CommandsState__WEBPACK_IMPORTED_MODULE_31__.commandsActions),
/* harmony export */   "commandsInitialState": () => (/* reexport safe */ _components_commands_CommandsState__WEBPACK_IMPORTED_MODULE_31__.commandsInitialState),
/* harmony export */   "commandsReducer": () => (/* reexport safe */ _components_commands_CommandsState__WEBPACK_IMPORTED_MODULE_31__.commandsReducer),
/* harmony export */   "consoleActions": () => (/* reexport safe */ _components_console_ConsoleState__WEBPACK_IMPORTED_MODULE_33__.consoleActions),
/* harmony export */   "consoleInitialState": () => (/* reexport safe */ _components_console_ConsoleState__WEBPACK_IMPORTED_MODULE_33__.consoleInitialState),
/* harmony export */   "consoleReducer": () => (/* reexport safe */ _components_console_ConsoleState__WEBPACK_IMPORTED_MODULE_33__.consoleReducer),
/* harmony export */   "createInjectableStore": () => (/* reexport safe */ _redux_Store__WEBPACK_IMPORTED_MODULE_10__.createInjectableStore),
/* harmony export */   "createReduxEpicStore": () => (/* reexport safe */ _redux_Store__WEBPACK_IMPORTED_MODULE_10__.createReduxEpicStore),
/* harmony export */   "createServerSettings": () => (/* reexport safe */ _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.createServerSettings),
/* harmony export */   "ensureJupyterAuth": () => (/* reexport safe */ _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.ensureJupyterAuth),
/* harmony export */   "epics": () => (/* reexport safe */ _redux_State__WEBPACK_IMPORTED_MODULE_9__.epics),
/* harmony export */   "fileBrowserActions": () => (/* reexport safe */ _components_filebrowser_FileBrowserState__WEBPACK_IMPORTED_MODULE_37__.fileBrowserActions),
/* harmony export */   "fileBrowserInitialState": () => (/* reexport safe */ _components_filebrowser_FileBrowserState__WEBPACK_IMPORTED_MODULE_37__.fileBrowserInitialState),
/* harmony export */   "fileBrowserReducer": () => (/* reexport safe */ _components_filebrowser_FileBrowserState__WEBPACK_IMPORTED_MODULE_37__.fileBrowserReducer),
/* harmony export */   "getJupyterServerHttpUrl": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.getJupyterServerHttpUrl),
/* harmony export */   "getJupyterServerWsUrl": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.getJupyterServerWsUrl),
/* harmony export */   "getJupyterToken": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.getJupyterToken),
/* harmony export */   "getNbGraderType": () => (/* reexport safe */ _components_notebook_cell_metadata_NbGraderCells__WEBPACK_IMPORTED_MODULE_24__.getNbGraderType),
/* harmony export */   "initialState": () => (/* reexport safe */ _redux_State__WEBPACK_IMPORTED_MODULE_9__.initialState),
/* harmony export */   "loadJupyterConfig": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.loadJupyterConfig),
/* harmony export */   "newSourceId": () => (/* reexport safe */ _jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_46__.newSourceId),
/* harmony export */   "newUuid": () => (/* reexport safe */ _jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_46__.newUuid),
/* harmony export */   "notebookActions": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.notebookActions),
/* harmony export */   "notebookEpics": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.notebookEpics),
/* harmony export */   "notebookInitialState": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.notebookInitialState),
/* harmony export */   "notebookReducer": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.notebookReducer),
/* harmony export */   "outputActions": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.outputActions),
/* harmony export */   "outputInitialState": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.outputInitialState),
/* harmony export */   "outputReducer": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.outputReducer),
/* harmony export */   "reducers": () => (/* reexport safe */ _redux_State__WEBPACK_IMPORTED_MODULE_9__.reducers),
/* harmony export */   "selectActiveCell": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectActiveCell),
/* harmony export */   "selectCell": () => (/* reexport safe */ _components_cell_CellState__WEBPACK_IMPORTED_MODULE_18__.selectCell),
/* harmony export */   "selectCommands": () => (/* reexport safe */ _components_commands_CommandsState__WEBPACK_IMPORTED_MODULE_31__.selectCommands),
/* harmony export */   "selectConsole": () => (/* reexport safe */ _components_console_ConsoleState__WEBPACK_IMPORTED_MODULE_33__.selectConsole),
/* harmony export */   "selectDataset": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.selectDataset),
/* harmony export */   "selectExecute": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.selectExecute),
/* harmony export */   "selectFileBrowser": () => (/* reexport safe */ _components_filebrowser_FileBrowserState__WEBPACK_IMPORTED_MODULE_37__.selectFileBrowser),
/* harmony export */   "selectGrade": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.selectGrade),
/* harmony export */   "selectJupyterSetSource": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.selectJupyterSetSource),
/* harmony export */   "selectJupyterSource": () => (/* reexport safe */ _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__.selectJupyterSource),
/* harmony export */   "selectKernelStatus": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectKernelStatus),
/* harmony export */   "selectNotebook": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectNotebook),
/* harmony export */   "selectNotebookModel": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectNotebookModel),
/* harmony export */   "selectNotebookPortalDisplay": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectNotebookPortalDisplay),
/* harmony export */   "selectNotebookPortals": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectNotebookPortals),
/* harmony export */   "selectSaveRequest": () => (/* reexport safe */ _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__.selectSaveRequest),
/* harmony export */   "selectSettings": () => (/* reexport safe */ _components_settings_SettingsState__WEBPACK_IMPORTED_MODULE_42__.selectSettings),
/* harmony export */   "selectTerminal": () => (/* reexport safe */ _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_44__.selectTerminal),
/* harmony export */   "setJupyterServerHttpUrl": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.setJupyterServerHttpUrl),
/* harmony export */   "setJupyterServerWsUrl": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.setJupyterServerWsUrl),
/* harmony export */   "setJupyterToken": () => (/* reexport safe */ _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__.setJupyterToken),
/* harmony export */   "settingsActions": () => (/* reexport safe */ _components_settings_SettingsState__WEBPACK_IMPORTED_MODULE_42__.settingsActions),
/* harmony export */   "settingsInitialState": () => (/* reexport safe */ _components_settings_SettingsState__WEBPACK_IMPORTED_MODULE_42__.settingsInitialState),
/* harmony export */   "settingsReducer": () => (/* reexport safe */ _components_settings_SettingsState__WEBPACK_IMPORTED_MODULE_42__.settingsReducer),
/* harmony export */   "sourceAsString": () => (/* reexport safe */ _jupyter_utils_Utils__WEBPACK_IMPORTED_MODULE_47__.sourceAsString),
/* harmony export */   "startLiteServer": () => (/* reexport safe */ _jupyter_lite_LiteServer__WEBPACK_IMPORTED_MODULE_3__.startLiteServer),
/* harmony export */   "terminalActions": () => (/* reexport safe */ _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_44__.terminalActions),
/* harmony export */   "terminalInitialState": () => (/* reexport safe */ _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_44__.terminalInitialState),
/* harmony export */   "terminalReducer": () => (/* reexport safe */ _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_44__.terminalReducer),
/* harmony export */   "useJupyter": () => (/* reexport safe */ _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__.useJupyter)
/* harmony export */ });
/* harmony import */ var _jupyter_Jupyter__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./jupyter/Jupyter */ "../ui/packages/react/lib/jupyter/Jupyter.js");
/* harmony import */ var _jupyter_JupyterContext__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./jupyter/JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _jupyter_JupyterConfig__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./jupyter/JupyterConfig */ "../ui/packages/react/lib/jupyter/JupyterConfig.js");
/* harmony import */ var _jupyter_lite_LiteServer__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./jupyter/lite/LiteServer */ "../ui/packages/react/lib/jupyter/lite/LiteServer.js");
/* harmony import */ var _jupyter_lumino_Lumino__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./jupyter/lumino/Lumino */ "../ui/packages/react/lib/jupyter/lumino/Lumino.js");
/* harmony import */ var _jupyter_lumino_LuminoDetached__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./jupyter/lumino/LuminoDetached */ "../ui/packages/react/lib/jupyter/lumino/LuminoDetached.js");
/* harmony import */ var _jupyter_lumino_LuminoNotebook__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./jupyter/lumino/LuminoNotebook */ "../ui/packages/react/lib/jupyter/lumino/LuminoNotebook.js");
/* harmony import */ var _jupyter_lumino_LuminoObservable__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./jupyter/lumino/LuminoObservable */ "../ui/packages/react/lib/jupyter/lumino/LuminoObservable.js");
/* harmony import */ var _jupyter_lumino_ReactPortalWidget__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./jupyter/lumino/ReactPortalWidget */ "../ui/packages/react/lib/jupyter/lumino/ReactPortalWidget.js");
/* harmony import */ var _redux_State__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./redux/State */ "../ui/packages/react/lib/redux/State.js");
/* harmony import */ var _redux_Store__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./redux/Store */ "../ui/packages/react/lib/redux/Store.js");
/* harmony import */ var _jupyter_services_Services__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./jupyter/services/Services */ "../ui/packages/react/lib/jupyter/services/Services.js");
/* harmony import */ var _jupyter_services_kernel_Kernel__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./jupyter/services/kernel/Kernel */ "../ui/packages/react/lib/jupyter/services/kernel/Kernel.js");
/* harmony import */ var _jupyter_services_kernel_KernelModel__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./jupyter/services/kernel/KernelModel */ "../ui/packages/react/lib/jupyter/services/kernel/KernelModel.js");
/* harmony import */ var _jupyter_ipywidgets_IPyWidgetsManager__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./jupyter/ipywidgets/IPyWidgetsManager */ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsManager.js");
/* harmony import */ var _components_ipywidgets_IPyWidgetsOutput__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./components/ipywidgets/IPyWidgetsOutput */ "../ui/packages/react/lib/components/ipywidgets/IPyWidgetsOutput.js");
/* harmony import */ var _components_cell_Cell__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./components/cell/Cell */ "../ui/packages/react/lib/components/cell/Cell.js");
/* harmony import */ var _components_cell_CellAdapter__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./components/cell/CellAdapter */ "../ui/packages/react/lib/components/cell/CellAdapter.js");
/* harmony import */ var _components_cell_CellState__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./components/cell/CellState */ "../ui/packages/react/lib/components/cell/CellState.js");
/* harmony import */ var _components_codemirror_CodeMirrorEditor__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./components/codemirror/CodeMirrorEditor */ "../ui/packages/react/lib/components/codemirror/CodeMirrorEditor.js");
/* harmony import */ var _components_notebook_Notebook__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./components/notebook/Notebook */ "../ui/packages/react/lib/components/notebook/Notebook.js");
/* harmony import */ var _components_notebook_NotebookAdapter__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./components/notebook/NotebookAdapter */ "../ui/packages/react/lib/components/notebook/NotebookAdapter.js");
/* harmony import */ var _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./components/notebook/NotebookState */ "../ui/packages/react/lib/components/notebook/NotebookState.js");
/* harmony import */ var _components_notebook_cell_metadata_CellMetadataEditor__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./components/notebook/cell/metadata/CellMetadataEditor */ "../ui/packages/react/lib/components/notebook/cell/metadata/CellMetadataEditor.js");
/* harmony import */ var _components_notebook_cell_metadata_NbGraderCells__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./components/notebook/cell/metadata/NbGraderCells */ "../ui/packages/react/lib/components/notebook/cell/metadata/NbGraderCells.js");
/* harmony import */ var _components_notebook_cell_prompt_CountdownInputPrompt__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./components/notebook/cell/prompt/CountdownInputPrompt */ "../ui/packages/react/lib/components/notebook/cell/prompt/CountdownInputPrompt.js");
/* harmony import */ var _components_notebook_content_JupyterReactContentFactory__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ./components/notebook/content/JupyterReactContentFactory */ "../ui/packages/react/lib/components/notebook/content/JupyterReactContentFactory.js");
/* harmony import */ var _components_notebook_cell_sidebar_lumino_CellSidebarWidget__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ./components/notebook/cell/sidebar/lumino/CellSidebarWidget */ "../ui/packages/react/lib/components/notebook/cell/sidebar/lumino/CellSidebarWidget.js");
/* harmony import */ var _components_notebook_cell_sidebar_CellSidebarDefault__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! ./components/notebook/cell/sidebar/CellSidebarDefault */ "../ui/packages/react/lib/components/notebook/cell/sidebar/CellSidebarDefault.js");
/* harmony import */ var _components_notebook_cell_sidebar_CellSidebarRun__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! ./components/notebook/cell/sidebar/CellSidebarRun */ "../ui/packages/react/lib/components/notebook/cell/sidebar/CellSidebarRun.js");
/* harmony import */ var _components_commands_Commands__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! ./components/commands/Commands */ "../ui/packages/react/lib/components/commands/Commands.js");
/* harmony import */ var _components_commands_CommandsState__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! ./components/commands/CommandsState */ "../ui/packages/react/lib/components/commands/CommandsState.js");
/* harmony import */ var _components_console_Console__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! ./components/console/Console */ "../ui/packages/react/lib/components/console/Console.js");
/* harmony import */ var _components_console_ConsoleState__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! ./components/console/ConsoleState */ "../ui/packages/react/lib/components/console/ConsoleState.js");
/* harmony import */ var _components_dialog_Dialog__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! ./components/dialog/Dialog */ "../ui/packages/react/lib/components/dialog/Dialog.js");
/* harmony import */ var _components_filebrowser_FileBrowser__WEBPACK_IMPORTED_MODULE_35__ = __webpack_require__(/*! ./components/filebrowser/FileBrowser */ "../ui/packages/react/lib/components/filebrowser/FileBrowser.js");
/* harmony import */ var _components_filebrowser_FileBrowserLab__WEBPACK_IMPORTED_MODULE_36__ = __webpack_require__(/*! ./components/filebrowser/FileBrowserLab */ "../ui/packages/react/lib/components/filebrowser/FileBrowserLab.js");
/* harmony import */ var _components_filebrowser_FileBrowserState__WEBPACK_IMPORTED_MODULE_37__ = __webpack_require__(/*! ./components/filebrowser/FileBrowserState */ "../ui/packages/react/lib/components/filebrowser/FileBrowserState.js");
/* harmony import */ var _components_output_Output__WEBPACK_IMPORTED_MODULE_38__ = __webpack_require__(/*! ./components/output/Output */ "../ui/packages/react/lib/components/output/Output.js");
/* harmony import */ var _components_output_OutputAdapter__WEBPACK_IMPORTED_MODULE_39__ = __webpack_require__(/*! ./components/output/OutputAdapter */ "../ui/packages/react/lib/components/output/OutputAdapter.js");
/* harmony import */ var _components_output_OutputState__WEBPACK_IMPORTED_MODULE_40__ = __webpack_require__(/*! ./components/output/OutputState */ "../ui/packages/react/lib/components/output/OutputState.js");
/* harmony import */ var _components_settings_Settings__WEBPACK_IMPORTED_MODULE_41__ = __webpack_require__(/*! ./components/settings/Settings */ "../ui/packages/react/lib/components/settings/Settings.js");
/* harmony import */ var _components_settings_SettingsState__WEBPACK_IMPORTED_MODULE_42__ = __webpack_require__(/*! ./components/settings/SettingsState */ "../ui/packages/react/lib/components/settings/SettingsState.js");
/* harmony import */ var _components_terminal_Terminal__WEBPACK_IMPORTED_MODULE_43__ = __webpack_require__(/*! ./components/terminal/Terminal */ "../ui/packages/react/lib/components/terminal/Terminal.js");
/* harmony import */ var _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_44__ = __webpack_require__(/*! ./components/terminal/TerminalState */ "../ui/packages/react/lib/components/terminal/TerminalState.js");
/* harmony import */ var _components_viewer_Viewer__WEBPACK_IMPORTED_MODULE_45__ = __webpack_require__(/*! ./components/viewer/Viewer */ "../ui/packages/react/lib/components/viewer/Viewer.js");
/* harmony import */ var _jupyter_utils_Ids__WEBPACK_IMPORTED_MODULE_46__ = __webpack_require__(/*! ./jupyter/utils/Ids */ "../ui/packages/react/lib/jupyter/utils/Ids.js");
/* harmony import */ var _jupyter_utils_Utils__WEBPACK_IMPORTED_MODULE_47__ = __webpack_require__(/*! ./jupyter/utils/Utils */ "../ui/packages/react/lib/jupyter/utils/Utils.js");
// Jupyter.










// CSS.

// Redux.


// Services.



// IPyWidgets.


// Cell.



// CodeMirror Editor.

// Notebook.










// Commands.


// Console.


// Dialog.

// FileBrowser.



// Outputs.



// Settings.


// Terminal.


// Viewer.

// Utils




/***/ }),

/***/ "../ui/packages/react/lib/jupyter/Jupyter.js":
/*!***************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/Jupyter.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Jupyter": () => (/* binding */ Jupyter),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/ThemeProvider.js");
/* harmony import */ var _primer_react__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! @primer/react */ "../../../node_modules/@primer/react/lib-esm/BaseStyles.js");
/* harmony import */ var react_error_boundary__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! react-error-boundary */ "../../../node_modules/react-error-boundary/dist/react-error-boundary.umd.js");
/* harmony import */ var react_error_boundary__WEBPACK_IMPORTED_MODULE_21___default = /*#__PURE__*/__webpack_require__.n(react_error_boundary__WEBPACK_IMPORTED_MODULE_21__);
/* harmony import */ var _JupyterContext__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./JupyterContext */ "../ui/packages/react/lib/jupyter/JupyterContext.js");
/* harmony import */ var _JupyterConfig__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./JupyterConfig */ "../ui/packages/react/lib/jupyter/JupyterConfig.js");
/* harmony import */ var _redux_Store__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ../redux/Store */ "../ui/packages/react/lib/redux/Store.js");
/* harmony import */ var _lumino_widgets_style_index_css__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/widgets/style/index.css */ "../../../node_modules/@lumino/widgets/style/index.css");
/* harmony import */ var _lumino_dragdrop_style_index_css__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/dragdrop/style/index.css */ "../../../node_modules/@lumino/dragdrop/style/index.css");
/* harmony import */ var _jupyterlab_ui_components_style_base_css__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/ui-components/style/base.css */ "../../../node_modules/@jupyterlab/ui-components/style/base.css");
/* harmony import */ var _jupyterlab_apputils_style_base_css__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyterlab/apputils/style/base.css */ "../../../node_modules/@jupyterlab/apputils/style/base.css");
/* harmony import */ var _jupyterlab_rendermime_style_base_css__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyterlab/rendermime/style/base.css */ "../../../node_modules/@jupyterlab/rendermime/style/base.css");
/* harmony import */ var _jupyterlab_codeeditor_style_base_css__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @jupyterlab/codeeditor/style/base.css */ "../../../node_modules/@jupyterlab/codeeditor/style/base.css");
/* harmony import */ var _jupyterlab_documentsearch_style_base_css__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @jupyterlab/documentsearch/style/base.css */ "../../../node_modules/@jupyterlab/documentsearch/style/base.css");
/* harmony import */ var _jupyterlab_outputarea_style_base_css__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @jupyterlab/outputarea/style/base.css */ "../../../node_modules/@jupyterlab/outputarea/style/base.css");
/* harmony import */ var _jupyterlab_console_style_base_css__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! @jupyterlab/console/style/base.css */ "../../../node_modules/@jupyterlab/console/style/base.css");
/* harmony import */ var _jupyterlab_completer_style_base_css__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @jupyterlab/completer/style/base.css */ "../../../node_modules/@jupyterlab/completer/style/base.css");
/* harmony import */ var _jupyterlab_codemirror_style_base_css__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! @jupyterlab/codemirror/style/base.css */ "../../../node_modules/@jupyterlab/codemirror/style/base.css");
/* harmony import */ var _jupyterlab_cells_style_base_css__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! @jupyterlab/cells/style/base.css */ "../../../node_modules/@jupyterlab/cells/style/base.css");
/* harmony import */ var _jupyterlab_notebook_style_base_css__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! @jupyterlab/notebook/style/base.css */ "../../../node_modules/@jupyterlab/notebook/style/base.css");
/* harmony import */ var _jupyterlab_filebrowser_style_base_css__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! @jupyterlab/filebrowser/style/base.css */ "../../../node_modules/@jupyterlab/filebrowser/style/base.css");
/* harmony import */ var _jupyterlab_terminal_style_index_css__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @jupyterlab/terminal/style/index.css */ "../../../node_modules/@jupyterlab/terminal/style/index.css");
/* harmony import */ var _jupyterlab_theme_light_extension_style_theme_css__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! @jupyterlab/theme-light-extension/style/theme.css */ "../../../node_modules/@jupyterlab/theme-light-extension/style/theme.css");
/* harmony import */ var _jupyterlab_theme_light_extension_style_variables_css__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @jupyterlab/theme-light-extension/style/variables.css */ "../../../node_modules/@jupyterlab/theme-light-extension/style/variables.css");
/* harmony import */ var _jupyter_widgets_base_css_index_css__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @jupyter-widgets/base/css/index.css */ "../../../node_modules/@jupyter-widgets/base/css/index.css");
/* harmony import */ var _jupyter_widgets_controls_css_widgets_base_css__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! @jupyter-widgets/controls/css/widgets-base.css */ "../../../node_modules/@jupyter-widgets/controls/css/widgets-base.css");


























/**
 * The component to be used as fallback in case of error.
 */
const ErrorFallback = ({ error, resetErrorBoundary }) => {
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsxs)("div", { role: "alert", children: [(0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("p", { children: "Oops, something went wrong." }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("pre", { children: error.message }), (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { style: { visibility: "hidden" }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("button", { onClick: resetErrorBoundary, children: "Try again" }) })] }));
};
/**
 * The Jupyter context. This handles the needed initialization
 * and ensure the Redux and the Material UI theme providers
 * are available.
 */
const Jupyter = (props) => {
    const { lite, startDefaultKernel, defaultKernelName, injectableStore, useRunningKernelId, useRunningKernelIndex, children } = props;
    (0,_JupyterConfig__WEBPACK_IMPORTED_MODULE_20__.loadJupyterConfig)(props);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_error_boundary__WEBPACK_IMPORTED_MODULE_21__.ErrorBoundary, { FallbackComponent: ErrorFallback, onReset: () => { console.log('Error Boundary reset has been invoked...'); }, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_22__["default"], { colorMode: "day", children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_primer_react__WEBPACK_IMPORTED_MODULE_23__["default"], { children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(_JupyterContext__WEBPACK_IMPORTED_MODULE_24__.JupyterContextProvider, { lite: lite, startDefaultKernel: startDefaultKernel, defaultKernelName: defaultKernelName, useRunningKernelId: useRunningKernelId, useRunningKernelIndex: useRunningKernelIndex, baseUrl: (0,_JupyterConfig__WEBPACK_IMPORTED_MODULE_20__.getJupyterServerHttpUrl)(), wsUrl: (0,_JupyterConfig__WEBPACK_IMPORTED_MODULE_20__.getJupyterServerWsUrl)(), injectableStore: injectableStore || _redux_Store__WEBPACK_IMPORTED_MODULE_25__["default"], variant: "default", children: children }) }) }) }));
};
Jupyter.defaultProps = {
    lite: false,
    defaultKernelName: 'python',
    startDefaultKernel: true,
    collaborative: false,
    terminals: false,
    useRunningKernelIndex: -1,
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Jupyter);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/JupyterAuthError.js":
/*!************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/JupyterAuthError.js ***!
  \************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/**
 * Error class in case of Authentication or
 * Authorization exception.
 */
class JupyterAuthError extends Error {
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (JupyterAuthError);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/JupyterConfig.js":
/*!*********************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/JupyterConfig.js ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getJupyterServerHttpUrl": () => (/* binding */ getJupyterServerHttpUrl),
/* harmony export */   "getJupyterServerWsUrl": () => (/* binding */ getJupyterServerWsUrl),
/* harmony export */   "getJupyterToken": () => (/* binding */ getJupyterToken),
/* harmony export */   "loadJupyterConfig": () => (/* binding */ loadJupyterConfig),
/* harmony export */   "setJupyterServerHttpUrl": () => (/* binding */ setJupyterServerHttpUrl),
/* harmony export */   "setJupyterServerWsUrl": () => (/* binding */ setJupyterServerWsUrl),
/* harmony export */   "setJupyterToken": () => (/* binding */ setJupyterToken)
/* harmony export */ });
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__);

/**
 * The default Jupyter configuration.
 */
let config = {
    jupyterServerHttpUrl: '',
    jupyterServerWsUrl: '',
    jupyterToken: '',
};
/**
 * Setter for jupyterServerHttpUrl.
 */
const setJupyterServerHttpUrl = (jupyterServerHttpUrl) => {
    config.jupyterServerHttpUrl = jupyterServerHttpUrl;
};
/**
 * Getter for jupyterServerHttpUrl.
 */
const getJupyterServerHttpUrl = () => config.jupyterServerHttpUrl;
/**
 * Setter for jupyterServerWsUrl.
 */
const setJupyterServerWsUrl = (jupyterServerWsUrl) => {
    config.jupyterServerWsUrl = jupyterServerWsUrl;
};
/**
 * Getter for jupyterServerWsUrl.
 */
const getJupyterServerWsUrl = () => config.jupyterServerWsUrl;
/**
 * Setter for jupyterToken.
 */
const setJupyterToken = (jupyterToken) => {
    config.jupyterToken = jupyterToken;
};
/**
 * Getter for jupyterToken.
 */
const getJupyterToken = () => config.jupyterToken;
/**
 * Method to load the Jupyter configuration from the
 * host HTML page.
 */
const loadJupyterConfig = (props) => {
    const { lite, jupyterServerHttpUrl, jupyterServerWsUrl, collaborative, terminals, jupyterToken } = props;
    const htmlConfig = document.getElementById('datalayer-config-data');
    if (htmlConfig) {
        config = JSON.parse(htmlConfig.textContent || '');
    }
    if (lite) {
        setJupyterServerHttpUrl(location.protocol + '//' + location.host);
    }
    else if (config.jupyterServerHttpUrl) {
        setJupyterServerHttpUrl(config.jupyterServerHttpUrl);
    }
    else {
        setJupyterServerHttpUrl(jupyterServerHttpUrl || location.protocol + '//' + location.host + "/api/jupyter");
    }
    if (lite) {
        setJupyterServerWsUrl(location.protocol === "https" ? "wss://" + location.host : "ws://" + location.host);
    }
    else if (config.jupyterServerWsUrl) {
        setJupyterServerWsUrl(config.jupyterServerWsUrl);
    }
    else {
        setJupyterServerWsUrl(jupyterServerWsUrl || location.protocol.replace('http', 'ws') + '//' + location.host + "/api/jupyter");
    }
    if (config.jupyterToken) {
        setJupyterToken(config.jupyterToken);
    }
    else {
        setJupyterToken(jupyterToken || '');
    }
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('baseUrl', getJupyterServerHttpUrl());
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('wsUrl', getJupyterServerWsUrl());
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('token', getJupyterToken());
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('collaborative', String(collaborative || false));
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('terminalsAvailable', String(terminals || false));
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('mathjaxUrl', 'https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/MathJax.js');
    _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.setOption('mathjaxConfig', 'TeX-AMS_CHTML-full,Safe');
    return config;
};


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/JupyterContext.js":
/*!**********************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/JupyterContext.js ***!
  \**********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "JupyterContext": () => (/* binding */ JupyterContext),
/* harmony export */   "JupyterContextConsumer": () => (/* binding */ JupyterContextConsumer),
/* harmony export */   "JupyterContextProvider": () => (/* binding */ JupyterContextProvider),
/* harmony export */   "createServerSettings": () => (/* binding */ createServerSettings),
/* harmony export */   "ensureJupyterAuth": () => (/* binding */ ensureJupyterAuth),
/* harmony export */   "useJupyter": () => (/* binding */ useJupyter)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _JupyterConfig__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./JupyterConfig */ "../ui/packages/react/lib/jupyter/JupyterConfig.js");
/* harmony import */ var _JupyterHandlers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./JupyterHandlers */ "../ui/packages/react/lib/jupyter/JupyterHandlers.js");
/* harmony import */ var _jupyter_lite_LiteServer__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./../jupyter/lite/LiteServer */ "../ui/packages/react/lib/jupyter/lite/LiteServer.js");
/* harmony import */ var _services_kernel_Kernel__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./services/kernel/Kernel */ "../ui/packages/react/lib/jupyter/services/kernel/Kernel.js");








/**
 * The instance for the Jupyter context.
 */
const JupyterContext = (0,react__WEBPACK_IMPORTED_MODULE_1__.createContext)(undefined);
const useJupyter = () => {
    const context = (0,react__WEBPACK_IMPORTED_MODULE_1__.useContext)(JupyterContext);
    if (!context)
        throw new Error("useContext must be inside a provider with a value.");
    return context;
};
/**
 * The type for the Jupyter context consumer.
 */
const JupyterContextConsumer = JupyterContext.Consumer;
/**
 * The type for the Jupyter context provider.
 */
const JupyterProvider = JupyterContext.Provider;
/**
 * Utiliy method to ensure the Jupyter context is authenticated
 * with the Jupyter server.
 */
const ensureJupyterAuth = (serverSettings) => {
    return (0,_JupyterHandlers__WEBPACK_IMPORTED_MODULE_4__.requestAPI)(serverSettings, 'api', '').then(data => {
        return true;
    })
        .catch(reason => {
        console.log('The Jupyter Server API has failed with reason', reason);
        return false;
    });
};
/*
const headers = new Headers({
  "Cache-Control": "no-cache, no-store, must-revalidate",
  "Pragma": "no-cache",
  "Expires": "0",
});
*/
const createServerSettings = (baseUrl, wsUrl) => {
    return _jupyterlab_services__WEBPACK_IMPORTED_MODULE_3__.ServerConnection.makeSettings({
        baseUrl,
        wsUrl,
        appendToken: true,
        init: {
            mode: 'cors',
            credentials: 'include',
            cache: 'no-cache',
            //      headers,
        }
    });
};
/**
 * The Jupyter context provider.
 */
const JupyterContextProvider = ({ children, lite, startDefaultKernel, defaultKernelName, useRunningKernelId, useRunningKernelIndex, variant, baseUrl, wsUrl, injectableStore }) => {
    const [_, setVariant] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)('default');
    const [serverSettings] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(createServerSettings(baseUrl, wsUrl));
    const [serviceManager, setServiceManager] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    const [kernelManager, setKernelManager] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    const [kernel, setKernel] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)();
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (lite) {
            (0,_jupyter_lite_LiteServer__WEBPACK_IMPORTED_MODULE_5__.startLiteServer)().then((serviceManager) => {
                setServiceManager(serviceManager);
                const kernelManager = serviceManager.sessions._kernelManager;
                setKernelManager(kernelManager);
                kernelManager.ready.then(() => {
                    console.log('Kernel Manager is ready', kernelManager);
                    if (startDefaultKernel) {
                        const kernel = new _services_kernel_Kernel__WEBPACK_IMPORTED_MODULE_6__["default"]({ kernelManager, kernelName: defaultKernelName });
                        kernel.connection.then(kernelConnection => {
                            console.log(`Kernel started with session client_id:id ${kernelConnection.clientId}:${kernelConnection.id}`);
                            kernelConnection.info.then(info => {
                                console.log('Kernel information', info);
                            });
                            setKernel(kernel);
                        });
                    }
                });
            });
        }
        else {
            ensureJupyterAuth(serverSettings).then(isAuth => {
                if (!isAuth) {
                    const loginUrl = (0,_JupyterConfig__WEBPACK_IMPORTED_MODULE_7__.getJupyterServerHttpUrl)() + '/login?next=' + window.location;
                    console.warn('Redirecting to Jupyter Server login URL', loginUrl);
                    window.location.replace(loginUrl);
                }
                if (useRunningKernelId && useRunningKernelIndex > -1) {
                    throw new Error("You can not ask for useRunningKernelId and useRunningKernelIndex at the same time.");
                }
                if (startDefaultKernel && (useRunningKernelId || useRunningKernelIndex > -1)) {
                    throw new Error("You can not ask for startDefaultKernel and (useRunningKernelId or useRunningKernelIndex) at the same time.");
                }
                const serviceManager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_3__.ServiceManager({ serverSettings });
                setServiceManager(serviceManager);
                const kernelManager = serviceManager.sessions._kernelManager;
                setKernelManager(kernelManager);
                kernelManager.ready.then(() => {
                    console.log('The Jupyter Kernel Manager is now ready');
                    /*
                    const running = kernelManager.running();
                    let kernel = running.next();
                    let i = 0;
                    while (! kernel.done) {
                      console.log(`This Jupyter server is hosting a kernel [${i}]`, kernel.value);
                      kernel = running.next();
                      i++;
                    }
                    */
                    if (useRunningKernelIndex > -1) {
                        const running = kernelManager.running();
                        let kernel = running.next();
                        let i = 0;
                        while (!kernel.done) {
                            if (i === useRunningKernelIndex) {
                                setKernel(new _services_kernel_Kernel__WEBPACK_IMPORTED_MODULE_6__["default"]({ kernelManager, kernelName: defaultKernelName, kernelModel: kernel.value }));
                                break;
                            }
                            kernel = running.next();
                            i++;
                        }
                    }
                    else if (startDefaultKernel) {
                        const kernel = new _services_kernel_Kernel__WEBPACK_IMPORTED_MODULE_6__["default"]({ kernelManager, kernelName: defaultKernelName });
                        kernel.connection.then(kernelConnection => {
                            console.log(`The default Kernel is now started with session client_id:id ${kernelConnection.clientId}:${kernelConnection.id}`);
                            kernelConnection.info.then(kernelInfo => {
                                console.log('Kernel information', kernelInfo);
                            });
                            setKernel(kernel);
                        });
                    }
                });
            });
        }
        setVariant(variant);
    }, [lite, variant]);
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(react_redux__WEBPACK_IMPORTED_MODULE_2__.Provider, { store: injectableStore, children: (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)(JupyterProvider, { value: {
                lite,
                serverSettings,
                serviceManager,
                kernelManager,
                defaultKernel: kernel,
                startDefaultKernel,
                variant,
                setVariant,
                baseUrl,
                wsUrl,
                injectableStore,
            }, children: children }) }));
};


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/JupyterHandlers.js":
/*!***********************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/JupyterHandlers.js ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "requestAPI": () => (/* binding */ requestAPI)
/* harmony export */ });
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _JupyterAuthError__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./JupyterAuthError */ "../ui/packages/react/lib/jupyter/JupyterAuthError.js");



/**
 * Call the Jupyter server API.
 *
 * @param endPoint API REST end point for the extension
 * @param init Initial values for the request
 * @returns The response body interpreted as JSON
 */
async function requestAPI(serverSettings, namespace = '', endPoint = '', init = {}) {
    // Make request to the Jupyter API.
    const requestUrl = _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.URLExt.join(serverSettings.baseUrl, namespace, endPoint);
    let response;
    try {
        response = await _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.makeRequest(requestUrl, init, serverSettings);
        if (response.status === 403) {
            throw new _JupyterAuthError__WEBPACK_IMPORTED_MODULE_2__["default"]();
        }
    }
    catch (error) {
        throw new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.NetworkError(error);
    }
    let data = await response.text();
    if (data.length > 0) {
        try {
            data = JSON.parse(data);
        }
        catch (error) {
            console.warn('Not a JSON response body.', response);
        }
    }
    if (!response.ok) {
        throw new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_1__.ServerConnection.ResponseError(response, data.message || data);
    }
    return data;
}


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsClassicManager.js":
/*!*******************************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsClassicManager.js ***!
  \*******************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "IPyWidgetsClassicManager": () => (/* binding */ IPyWidgetsClassicManager)
/* harmony export */ });
/* harmony import */ var _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter-widgets/html-manager */ "../../../node_modules/@jupyter-widgets/html-manager/lib/index.js");
/* harmony import */ var _jupyter_widgets_base_lib_services_shim__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyter-widgets/base/lib/services-shim */ "../../../node_modules/@jupyter-widgets/base/lib/services-shim.js");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyter_widgets_jupyterlab_manager_lib_output__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyter-widgets/jupyterlab-manager/lib/output */ "../../../node_modules/@jupyter-widgets/jupyterlab-manager/lib/output.js");
/* harmony import */ var _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyter-widgets/base */ "../../../node_modules/@jupyter-widgets/base/lib/index.js");
/* harmony import */ var _jupyter_widgets_controls__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyter-widgets/controls */ "../../../node_modules/@jupyter-widgets/controls/lib/index.js");




// Exposing @jupyter-widgets/base and @jupyter-widgets/controls as AMD modules for custom widget bundles that depend on it.


if (typeof window !== "undefined" && typeof window.define !== "undefined") {
    window.define("@jupyter-widgets/base", _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__);
    window.define("@jupyter-widgets/controls", _jupyter_widgets_controls__WEBPACK_IMPORTED_MODULE_4__);
}
/**
 * The class responsible for the classic IPyWidget rendering.
 */
class IPyWidgetsClassicManager extends _jupyter_widgets_html_manager__WEBPACK_IMPORTED_MODULE_0__.HTMLManager {
    _kernelConnection;
    _commRegistration;
    _onError;
    registerWithKernel(kernelConnection) {
        this._kernelConnection = kernelConnection;
        if (this._commRegistration) {
            this._commRegistration.dispose();
        }
        if (kernelConnection) {
            this._commRegistration = kernelConnection.registerCommTarget(this.comm_target_name, (comm, message) => {
                this.handle_comm_open(new _jupyter_widgets_base_lib_services_shim__WEBPACK_IMPORTED_MODULE_1__.shims.services.Comm(comm), message);
            });
        }
    }
    get onError() {
        return this._onError;
    }
    display_view(view, el) {
        return Promise.resolve(view).then((view) => {
            _lumino_widgets__WEBPACK_IMPORTED_MODULE_2__.Widget.attach(view.luminoWidget, el);
            view.on("remove", function () {
                console.log("view removed", view);
            });
            //      return view;
        });
    }
    loadClass(className, moduleName, moduleVersion) {
        if (moduleName === "@jupyter-widgets/output") {
            return Promise.resolve(_jupyter_widgets_jupyterlab_manager_lib_output__WEBPACK_IMPORTED_MODULE_5__).then((module) => {
                if (module[className]) {
                    return module[className];
                }
                else {
                    return Promise.reject(`Class ${className} not found in module ${moduleName}`);
                }
            });
        }
        else {
            return super.loadClass(className, moduleName, moduleVersion);
        }
    }
    callbacks(view) {
        const baseCallbacks = super.callbacks(view);
        return Object.assign({}, baseCallbacks, {
            iopub: { output: (msg) => this._onError.emit(msg) },
        });
    }
    _create_comm(target_name, model_id, data, metadata, buffers) {
        const comm = this._kernelConnection?.createComm(target_name, model_id);
        if (data || metadata) {
            comm?.open(data, metadata);
        }
        return Promise.resolve(new _jupyter_widgets_base_lib_services_shim__WEBPACK_IMPORTED_MODULE_1__.shims.services.Comm(comm));
    }
    _get_comm_info() {
        return this._kernelConnection
            .requestCommInfo({ target_name: this.comm_target_name })
            .then((reply) => reply.content.comms);
    }
}


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsJupyterLabPlugin.js":
/*!*********************************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsJupyterLabPlugin.js ***!
  \*********************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "activateWidgetExtension": () => (/* binding */ activateWidgetExtension),
/* harmony export */   "registerWidgetManager": () => (/* binding */ registerWidgetManager)
/* harmony export */ });
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/algorithm */ "webpack/sharing/consume/default/@lumino/algorithm");
/* harmony import */ var _lumino_algorithm__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_algorithm__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_disposable__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/disposable */ "webpack/sharing/consume/default/@lumino/disposable");
/* harmony import */ var _lumino_disposable__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_disposable__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_properties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/properties */ "webpack/sharing/consume/default/@lumino/properties");
/* harmony import */ var _lumino_properties__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_properties__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @jupyter-widgets/jupyterlab-manager */ "../../../node_modules/@jupyter-widgets/jupyterlab-manager/lib/renderer.js");
/* harmony import */ var _jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @jupyter-widgets/jupyterlab-manager/lib/manager */ "../../../node_modules/@jupyter-widgets/jupyterlab-manager/lib/manager.js");
/* harmony import */ var _jupyter_widgets_jupyterlab_manager_lib_output__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! @jupyter-widgets/jupyterlab-manager/lib/output */ "../../../node_modules/@jupyter-widgets/jupyterlab-manager/lib/output.js");
/* harmony import */ var _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyter-widgets/base */ "../../../node_modules/@jupyter-widgets/base/lib/index.js");
/* harmony import */ var _jupyter_widgets_controls_lib_version__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @jupyter-widgets/controls/lib/version */ "../../../node_modules/@jupyter-widgets/controls/lib/version.js");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_5__);







// !!! We import only the version from the specific module in controls so that the controls code can be split and dynamically loaded in webpack.


const WIDGET_REGISTRY = [];
/**
 * The cached settings.
 */
const SETTINGS = { saveState: false };
/**
 * Iterate through all widget renderers in a notebook.
 */
function* widgetRenderers(notebook) {
    for (const cell of notebook.widgets) {
        if (cell.model.type === 'code') {
            for (const codecell of cell.outputArea.widgets) {
                for (const output of (0,_lumino_algorithm__WEBPACK_IMPORTED_MODULE_0__.toArray)(codecell.children())) {
                    if (output instanceof _jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_6__.WidgetRenderer) {
                        console.log('IPyWidgetsJupyterLabPlugin widgetRenderers output', output);
                        yield output;
                    }
                }
            }
        }
    }
}
/**
 * Iterate through all matching linked output views
 */
/*
function* outputViews(
  app: JupyterFrontEnd,
  path: string
): Generator<WidgetRenderer, void, unknown> {
  const linkedViews = filter(
    app.shell.widgets(),
    (w) => w.id.startsWith('LinkedOutputView-') && (w as any).path === path
  );
  for (const view of toArray(linkedViews)) {
    for (const outputs of toArray(view.children())) {
      for (const output of toArray(outputs.children())) {
        if (output instanceof WidgetRenderer) {
          yield output;
        }
      }
    }
  }
}
*/
function* chain(...args) {
    for (const it of args) {
        yield* it;
    }
}
function registerWidgetManager(context, rendermime, renderers) {
    let widgetManager = Private.widgetManagerProperty.get(context);
    if (!widgetManager) {
        widgetManager = new _jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_7__.WidgetManager(context, rendermime, SETTINGS);
        WIDGET_REGISTRY.forEach((data) => widgetManager.register(data));
        Private.widgetManagerProperty.set(context, widgetManager);
    }
    for (const r of renderers) {
        r.manager = widgetManager;
    }
    // Replace the placeholder widget renderer with one bound to this widget manager.
    rendermime.removeMimeType(_jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_7__.WIDGET_VIEW_MIMETYPE);
    rendermime.addFactory({
        safe: false,
        mimeTypes: [_jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_7__.WIDGET_VIEW_MIMETYPE],
        createRenderer: (options) => new _jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_6__.WidgetRenderer(options, widgetManager),
    }, 0);
    return new _lumino_disposable__WEBPACK_IMPORTED_MODULE_1__.DisposableDelegate(() => {
        if (rendermime) {
            rendermime.removeMimeType(_jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_7__.WIDGET_VIEW_MIMETYPE);
        }
        widgetManager.dispose();
    });
}
/**
 * Activate the widget extension.
 */
function activateWidgetExtension(rendermime, tracker, menu, loggerRegistry) {
    const bindUnhandledIOPubMessageSignal = (notebookPanel) => {
        if (!loggerRegistry) {
            return;
        }
        const widgetManager = Private.widgetManagerProperty.get(notebookPanel.context);
        if (widgetManager) {
            widgetManager.onUnhandledIOPubMessage.connect((sender, msg) => {
                const logger = loggerRegistry.getLogger(notebookPanel.context.path);
                let level = 'warning';
                if (_jupyterlab_services__WEBPACK_IMPORTED_MODULE_5__.KernelMessage.isErrorMsg(msg) ||
                    (_jupyterlab_services__WEBPACK_IMPORTED_MODULE_5__.KernelMessage.isStreamMsg(msg) && msg.content.name === 'stderr')) {
                    level = 'error';
                }
                const data = {
                    ...msg.content,
                    output_type: msg.header.msg_type,
                };
                logger.rendermime = notebookPanel.content.rendermime;
                logger.log({ type: 'output', data, level });
            });
        }
    };
    // Add a placeholder widget renderer.
    rendermime.addFactory({
        safe: false,
        mimeTypes: [_jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_7__.WIDGET_VIEW_MIMETYPE],
        createRenderer: (options) => new _jupyter_widgets_jupyterlab_manager__WEBPACK_IMPORTED_MODULE_6__.WidgetRenderer(options),
    }, -10);
    if (tracker !== null) {
        tracker.forEach((panel) => {
            registerWidgetManager(panel.context, panel.content.rendermime, chain(widgetRenderers(panel.content)));
            bindUnhandledIOPubMessageSignal(panel);
        });
        tracker.widgetAdded.connect((sender, panel) => {
            registerWidgetManager(panel.context, panel.content.rendermime, chain(widgetRenderers(panel.content)));
            bindUnhandledIOPubMessageSignal(panel);
        });
    }
    if (menu) {
        menu.settingsMenu.addGroup([
            { command: '@jupyter-widgets/jupyterlab-manager:saveWidgetState' },
        ]);
    }
    WIDGET_REGISTRY.push({
        name: '@jupyter-widgets/base',
        version: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.JUPYTER_WIDGETS_VERSION,
        exports: {
            WidgetModel: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.WidgetModel,
            WidgetView: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.WidgetView,
            DOMWidgetView: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.DOMWidgetView,
            DOMWidgetModel: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.DOMWidgetModel,
            LayoutModel: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.LayoutModel,
            LayoutView: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.LayoutView,
            StyleModel: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.StyleModel,
            StyleView: _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_3__.StyleView,
        },
    });
    WIDGET_REGISTRY.push({
        name: '@jupyter-widgets/controls',
        version: _jupyter_widgets_controls_lib_version__WEBPACK_IMPORTED_MODULE_4__.JUPYTER_CONTROLS_VERSION,
        exports: () => {
            return new Promise((resolve, reject) => {
                Promise.resolve(/*! require.ensure */).then(((require) => {
                    // eslint-disable-next-line @typescript-eslint/no-var-requires
                    resolve(__webpack_require__(/*! @jupyter-widgets/controls */ "../../../node_modules/@jupyter-widgets/controls/lib/index.js"));
                }).bind(null, __webpack_require__))['catch']((err) => {
                    reject(err);
                });
            });
        },
    });
    WIDGET_REGISTRY.push({
        name: '@jupyter-widgets/output',
        version: _jupyter_widgets_jupyterlab_manager_lib_output__WEBPACK_IMPORTED_MODULE_8__.OUTPUT_WIDGET_VERSION,
        exports: { OutputModel: _jupyter_widgets_jupyterlab_manager_lib_output__WEBPACK_IMPORTED_MODULE_8__.OutputModel, OutputView: _jupyter_widgets_jupyterlab_manager_lib_output__WEBPACK_IMPORTED_MODULE_8__.OutputView },
    });
    const widgetRegistry = {
        registerWidget(data) {
            WIDGET_REGISTRY.push(data);
        },
    };
    return widgetRegistry;
}
var Private;
(function (Private) {
    /**
     * A private attached property for a widget manager.
     */
    Private.widgetManagerProperty = new _lumino_properties__WEBPACK_IMPORTED_MODULE_2__.AttachedProperty({
        name: 'widgetManager',
        create: (owner) => undefined,
    });
})(Private || (Private = {}));


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsManager.js":
/*!************************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsManager.js ***!
  \************************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "IPyWidgetsManager": () => (/* binding */ IPyWidgetsManager),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _jupyter_widgets_base_manager__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @jupyter-widgets/base-manager */ "../../../node_modules/@jupyter-widgets/base-manager/lib/index.js");
/* harmony import */ var _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @jupyter-widgets/base */ "../../../node_modules/@jupyter-widgets/base/lib/index.js");
/* harmony import */ var _jupyter_widgets_controls__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @jupyter-widgets/controls */ "../../../node_modules/@jupyter-widgets/controls/lib/index.js");




class IPyWidgetsManager extends _jupyter_widgets_base_manager__WEBPACK_IMPORTED_MODULE_1__.ManagerBase {
    el;
    constructor(el) {
        super();
        this.el = el;
    }
    async loadClass(className, moduleName, moduleVersion) {
        return new Promise(function (resolve, reject) {
            if (moduleName === '@jupyter-widgets/controls') {
                resolve(_jupyter_widgets_controls__WEBPACK_IMPORTED_MODULE_3__);
            }
            else if (moduleName === '@jupyter-widgets/base') {
                resolve(_jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_2__);
            }
            else {
                var fallback = function (err) {
                    let failedId = err.requireModules && err.requireModules[0];
                    if (failedId) {
                        console.log(`Falling back to jsDelivr for ${moduleName}@${moduleVersion}`);
                        window.require([
                            `https://cdn.jsdelivr.net/npm/${moduleName}@${moduleVersion}/dist/index.js`,
                        ], resolve, reject);
                    }
                    else {
                        throw err;
                    }
                };
                window.require([`${moduleName}.js`], resolve, fallback);
            }
        }).then(function (module) {
            if (module[className]) {
                return module[className];
            }
            else {
                return Promise.reject(`Class ${className} not found in module ${moduleName}@${moduleVersion}`);
            }
        });
    }
    async display_view(view) {
        var that = this;
        return Promise.resolve(view).then(function (view) {
            _lumino_widgets__WEBPACK_IMPORTED_MODULE_0__.Widget.attach(view.luminoWidget, that.el);
            return view;
        });
    }
    _get_comm_info() {
        return Promise.resolve({});
    }
    _create_comm() {
        return Promise.reject('no comms available');
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (IPyWidgetsManager);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lite/LiteServer.js":
/*!***********************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lite/LiteServer.js ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "startLiteServer": () => (/* binding */ startLiteServer)
/* harmony export */ });
/* harmony import */ var _datalayer_jupyterlite_server__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @datalayer/jupyterlite-server */ "../ui/packages/lite/server/lib/app.js");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/coreutils */ "webpack/sharing/consume/default/@jupyterlab/coreutils");
/* harmony import */ var _jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__);


const serverExtensions = [
    //  import('@jupyterlite/javascript-kernel-extension'),
    __webpack_require__.e(/*! import() */ "ui_packages_lite_ipykernel-extension_lib_index_js").then(__webpack_require__.bind(__webpack_require__, /*! @datalayer/jupyterlite-ipykernel-extension */ "../ui/packages/lite/ipykernel-extension/lib/index.js")),
    Promise.all(/*! import() */[__webpack_require__.e("vendors-node_modules_async-mutex_index_mjs-node_modules_jupyterlab_services_lib_kernel_serial-bcf9d7"), __webpack_require__.e("ui_packages_lite_server-extension_lib_index_js")]).then(__webpack_require__.bind(__webpack_require__, /*! @datalayer/jupyterlite-server-extension */ "../ui/packages/lite/server-extension/lib/index.js"))
];
// custom list of disabled plugins.
const disabled = [
    '@jupyterlab/apputils-extension:workspaces',
    '@jupyterlab/application-extension:logo',
    '@jupyterlab/application-extension:main',
    '@jupyterlab/application-extension:tree-resolver',
    '@jupyterlab/apputils-extension:resolver',
    '@jupyterlab/docmanager-extension:download',
    '@jupyterlab/filebrowser-extension:download',
    '@jupyterlab/filebrowser-extension:share-file',
    '@jupyterlab/help-extension:about',
    /*
      '@jupyterlite/server-extension:contents',
      '@jupyterlite/server-extension:contents-routes',
      '@jupyterlite/server-extension:emscripten-filesystem',
      '@jupyterlite/server-extension:licenses',
      '@jupyterlite/server-extension:licenses-routes',
      '@jupyterlite/server-extension:localforage-memory-storage',
      '@jupyterlite/server-extension:localforage',
      '@jupyterlite/server-extension:nbconvert-routes',
      '@jupyterlite/server-extension:service-worker',
      '@jupyterlite/server-extension:settings',
      '@jupyterlite/server-extension:settings-routes',
      '@jupyterlite/server-extension:translation',
      '@jupyterlite/server-extension:translation-routes',
    */
];
async function startLiteServer() {
    const litePluginsToRegister = [];
    /**
     * Iterate over active plugins in an extension.
     */
    function* activePlugins(extension) {
        // Handle commonjs or es2015 modules.
        let exports;
        if (extension.hasOwnProperty('__esModule')) {
            exports = extension.default;
        }
        else {
            // CommonJS exports.
            exports = extension;
        }
        let plugins = Array.isArray(exports) ? exports : [exports];
        for (let plugin of plugins) {
            if (_jupyterlab_coreutils__WEBPACK_IMPORTED_MODULE_0__.PageConfig.Extension.isDisabled(plugin.id) ||
                disabled.includes(plugin.id) ||
                disabled.includes(plugin.id.split(':')[0])) {
                continue;
            }
            yield plugin;
        }
    }
    // Add the base serverlite extensions.
    const baseServerExtensions = await Promise.all(serverExtensions);
    baseServerExtensions.forEach(p => {
        for (let plugin of activePlugins(p)) {
            litePluginsToRegister.push(plugin);
        }
    });
    // Create the in-browser JupyterLite Server.
    const jupyterLiteServer = new _datalayer_jupyterlite_server__WEBPACK_IMPORTED_MODULE_1__.JupyterLiteServer({});
    jupyterLiteServer.registerPluginModules(litePluginsToRegister);
    // Start the server.
    await jupyterLiteServer.start();
    // Retrieve the custom service manager from the server app.
    const { serviceManager } = jupyterLiteServer;
    return serviceManager;
}


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lumino/IPyWidgetsAttached.js":
/*!*********************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lumino/IPyWidgetsAttached.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var _jupyter_ipywidgets_IPyWidgetsManager__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../../jupyter/ipywidgets/IPyWidgetsManager */ "../ui/packages/react/lib/jupyter/ipywidgets/IPyWidgetsManager.js");


/**
 * IPyWidgetAttached allows to render a Lumino
 * Widget being mounted in the React.js tree.
 */
const IPyWidgetsAttached = (props) => {
    const { view, state } = props;
    return ((0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { ref: ref => {
            if (ref) {
                var manager = new _jupyter_ipywidgets_IPyWidgetsManager__WEBPACK_IMPORTED_MODULE_1__["default"](ref);
                manager
                    .set_state(state)
                    .then((models) => manager.create_view(models.find((element) => element.model_id === view.model_id)))
                    .then((view) => manager.display_view(view));
            }
        } }));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (IPyWidgetsAttached);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lumino/Lumino.js":
/*!*********************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lumino/Lumino.js ***!
  \*********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Lumino": () => (/* binding */ Lumino),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-dom */ "webpack/sharing/consume/default/react-dom");
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_3__);




const Lumino = (props) => {
    const ref = (0,react__WEBPACK_IMPORTED_MODULE_1__.useRef)(null);
    const { children } = props;
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        const widget = children;
        try {
            _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.Widget.attach(widget, ref.current);
        }
        catch (e) {
            console.warn('Exception while attaching Lumino widget.', e);
        }
        return () => {
            try {
                (0,react_dom__WEBPACK_IMPORTED_MODULE_2__.unmountComponentAtNode)(widget.node);
                if (widget.isAttached || widget.node.isConnected) {
                    widget.dispose();
                    _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.Widget.detach(widget);
                }
            }
            catch (e) {
                console.debug('Exception while detaching Lumino widget.', e);
            }
        };
    }, [children]);
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { ref: ref });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Lumino);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lumino/LuminoDetached.js":
/*!*****************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lumino/LuminoDetached.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "LuminoDetached": () => (/* binding */ LuminoDetached),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);


/**
 * The LuminoDetached class allows to render a Lumino
 * Widget that is not mounted in the React.js tree.
 */
class LuminoDetached extends (react__WEBPACK_IMPORTED_MODULE_1___default().Component) {
    render() {
        return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { ref: ref => { } });
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LuminoDetached);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lumino/LuminoNotebook.js":
/*!*****************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lumino/LuminoNotebook.js ***!
  \*****************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "LuminoNotebook": () => (/* binding */ LuminoNotebook),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react/jsx-runtime */ "../../../node_modules/react/jsx-runtime.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react-dom */ "webpack/sharing/consume/default/react-dom");
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_3__);




const LuminoNotebook = (props) => {
    const { adapter } = props;
    const panel = adapter.panel;
    const ref = (0,react__WEBPACK_IMPORTED_MODULE_1__.useRef)(null);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        if (!panel) {
            return;
        }
        _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.Widget.attach(panel, ref.current);
        return () => {
            try {
                (0,react_dom__WEBPACK_IMPORTED_MODULE_2__.unmountComponentAtNode)(panel.node);
                if (panel.isAttached || panel.node.isConnected) {
                    adapter.dispose();
                    _lumino_widgets__WEBPACK_IMPORTED_MODULE_3__.Widget.detach(panel);
                }
            }
            catch (e) {
                console.debug('Exception while detaching Lumino widget.', e);
            }
        };
    }, [adapter.uid]);
    return (0,react_jsx_runtime__WEBPACK_IMPORTED_MODULE_0__.jsx)("div", { ref: ref });
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LuminoNotebook);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lumino/LuminoObservable.js":
/*!*******************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lumino/LuminoObservable.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "asObservable": () => (/* binding */ asObservable)
/* harmony export */ });
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! rxjs */ "../../../node_modules/rxjs/_esm5/internal/Observable.js");

/**
 * Convert a Lumino Signal to a Rx-js Observable.
 */
function asObservable(signal) {
    return new rxjs__WEBPACK_IMPORTED_MODULE_0__.Observable((subscriber) => {
        function slot(_, args) {
            subscriber.next(args);
        }
        signal.connect(slot);
        return () => {
            signal.disconnect(slot);
        };
    });
}


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/lumino/ReactPortalWidget.js":
/*!********************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/lumino/ReactPortalWidget.js ***!
  \********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ReactPortalWidget": () => (/* binding */ ReactPortalWidget),
/* harmony export */   "UseSignal": () => (/* binding */ UseSignal),
/* harmony export */   "VDomModel": () => (/* binding */ VDomModel),
/* harmony export */   "VDomRenderer": () => (/* binding */ VDomRenderer)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react-dom */ "webpack/sharing/consume/default/react-dom");
/* harmony import */ var react_dom__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react_dom__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _lumino_messaging__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @lumino/messaging */ "webpack/sharing/consume/default/@lumino/messaging");
/* harmony import */ var _lumino_messaging__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_lumino_messaging__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @lumino/widgets */ "webpack/sharing/consume/default/@lumino/widgets");
/* harmony import */ var _lumino_widgets__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_lumino_widgets__WEBPACK_IMPORTED_MODULE_4__);





/**
 * An abstract class for a Lumino widget which renders a React component as a Portal.
 */
class ReactPortalWidget extends _lumino_widgets__WEBPACK_IMPORTED_MODULE_4__.Widget {
    /**
     * Creates a new `ReactPortalWidget` that renders a constant element.
     * @param element React element to render.
     */
    static create(element) {
        return new (class extends ReactPortalWidget {
            render() {
                return element;
            }
        })();
    }
    /**
     * Called to update the state of the widget.
     *
     * The default implementation of this method triggers
     * VDOM based rendering by calling the `renderDOM` method.
     */
    onUpdateRequest(msg) {
        this.renderPromise = this.renderDOM();
    }
    /**
     * Called after the widget is attached to the DOM
     */
    onAfterAttach(msg) {
        // Make *sure* the widget is rendered.
        _lumino_messaging__WEBPACK_IMPORTED_MODULE_2__.MessageLoop.sendMessage(this, _lumino_widgets__WEBPACK_IMPORTED_MODULE_4__.Widget.Msg.UpdateRequest);
    }
    /**
     * Called before the widget is detached from the DOM.
     */
    onBeforeDetach(msg) {
        // Unmount the component so it can tear down.
        react_dom__WEBPACK_IMPORTED_MODULE_1___default().unmountComponentAtNode(this.node);
    }
    /**
     * Render the React nodes to the DOM.
     *
     * @returns a promise that resolves when the rendering is done.
     */
    renderDOM() {
        return new Promise(resolve => {
            // no-op
        });
    }
    // Set whenever a new render is triggered and resolved when it is finished.
    renderPromise;
}
/**
 * An abstract ReactPortalWidget with a model.
 */
class VDomRenderer extends ReactPortalWidget {
    /**
     * Create a new VDomRenderer
     */
    constructor(model) {
        super();
        this.model = (model ?? null);
    }
    /**
     * A signal emitted when the model changes.
     */
    get modelChanged() {
        return this._modelChanged;
    }
    /**
     * Set the model and fire changed signals.
     */
    set model(newValue) {
        if (this._model === newValue) {
            return;
        }
        if (this._model) {
            this._model.stateChanged.disconnect(this.update, this);
        }
        this._model = newValue;
        if (newValue) {
            newValue.stateChanged.connect(this.update, this);
        }
        this.update();
        this._modelChanged.emit(void 0);
    }
    /**
     * Get the current model.
     */
    get model() {
        return this._model;
    }
    /**
     * Dispose this widget.
     */
    dispose() {
        if (this.isDisposed) {
            return;
        }
        this._model = null;
        super.dispose();
    }
    _model;
    _modelChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__.Signal(this);
}
/**
 * UseSignal provides a way to hook up a Phosphor signal to a React element,
 * so that the element is re-rendered every time the signal fires.
 *
 * It is implemented through the "render props" technique, using the `children`
 * prop as a function to render, so that it can be used either as a prop or as a child
 * of this element
 * https://reactjs.org/docs/render-props.html
 *
 *
 * Example as child:
 *
 * ```
 * function LiveButton(isActiveSignal: ISignal<any, boolean>) {
 *  return (
 *    <UseSignal signal={isActiveSignal} initialArgs={True}>
 *     {(_, isActive) => <Button isActive={isActive}>}
 *    </UseSignal>
 *  )
 * }
 * ```
 *
 * Example as prop:
 *
 * ```
 * function LiveButton(isActiveSignal: ISignal<any, boolean>) {
 *  return (
 *    <UseSignal
 *      signal={isActiveSignal}
 *      initialArgs={True}
 *      children={(_, isActive) => <Button isActive={isActive}>}
 *    />
 *  )
 * }
 * ```
 */
class UseSignal extends (react__WEBPACK_IMPORTED_MODULE_0___default().Component) {
    constructor(props) {
        super(props);
        this.state = { value: [this.props.initialSender, this.props.initialArgs] };
    }
    componentDidMount() {
        this.props.signal.connect(this.slot);
    }
    componentWillUnmount() {
        this.props.signal.disconnect(this.slot);
    }
    slot = (sender, args) => {
        // skip setting new state if we have a shouldUpdate function and it returns false
        if (this.props.shouldUpdate && !this.props.shouldUpdate(sender, args)) {
            return;
        }
        this.setState({ value: [sender, args] });
    };
    render() {
        return this.props.children(...this.state.value);
    }
}
/**
 * Concrete implementation of VDomRenderer model.
 */
class VDomModel {
    /**
     * A signal emitted when any model state changes.
     */
    stateChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__.Signal(this);
    /**
     * Test whether the model is disposed.
     */
    get isDisposed() {
        return this._isDisposed;
    }
    /**
     * Dispose the model.
     */
    dispose() {
        if (this.isDisposed) {
            return;
        }
        this._isDisposed = true;
        _lumino_signaling__WEBPACK_IMPORTED_MODULE_3__.Signal.clearData(this);
    }
    _isDisposed = false;
}


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/services/Services.js":
/*!*************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/services/Services.js ***!
  \*************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Services": () => (/* binding */ Services),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
class Services {
    _serviceManager;
    constructor(services) {
        this._serviceManager = services;
    }
    kernelspecs() {
        return this._serviceManager.kernelspecs;
    }
    contents() {
        return this._serviceManager.contents;
    }
    nbconvert() {
        return this._serviceManager.nbconvert;
    }
    sessions() {
        return this._serviceManager.sessions;
    }
    settings() {
        return this._serviceManager.settings;
    }
    terminals() {
        return this._serviceManager.terminals;
    }
    workspaces() {
        return this._serviceManager.workspaces;
    }
    builder() {
        return this._serviceManager.builder;
    }
    serverSettings() {
        return this._serviceManager.serverSettings;
    }
    refreshKernelspecs() {
        return this.kernelspecs().refreshSpecs();
    }
    getKernelspecs() {
        return this.kernelspecs().specs;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Services);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/services/kernel/Kernel.js":
/*!******************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/services/kernel/Kernel.js ***!
  \******************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "Kernel": () => (/* binding */ Kernel),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/services */ "webpack/sharing/consume/default/@jupyterlab/services");
/* harmony import */ var _jupyterlab_services__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @lumino/coreutils */ "webpack/sharing/consume/default/@lumino/coreutils");
/* harmony import */ var _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__);


class Kernel {
    _kernelManager;
    _kernelName;
    _kernelConnection;
    _session;
    _id;
    _info;
    constructor(props) {
        const { kernelManager, kernelName, kernelModel } = props;
        this._kernelManager = kernelManager;
        this._kernelName = kernelName;
        this._kernelConnection = this.requestJupyterKernel(kernelModel); // Request the effective Jupyter Kernel.
    }
    async requestJupyterKernel(kernelModel) {
        await this._kernelManager.ready;
        const sessionManager = new _jupyterlab_services__WEBPACK_IMPORTED_MODULE_0__.SessionManager({
            kernelManager: this._kernelManager,
            serverSettings: this._kernelManager.serverSettings,
            standby: 'never',
        });
        await sessionManager.ready;
        if (kernelModel) {
            console.log('Reusing a pre-existing kernel model.');
            const runningModel = sessionManager.running().next().value;
            this._session = sessionManager.connectTo({ model: runningModel });
        }
        else {
            const randomName = _lumino_coreutils__WEBPACK_IMPORTED_MODULE_1__.UUID.uuid4();
            this._session = await sessionManager.startNew({
                name: randomName,
                path: randomName,
                type: this._kernelName,
                kernel: {
                    name: this._kernelName,
                },
            });
        }
        this._info = await this._session.kernel.info;
        this._id = this._session.kernel.id;
        return this._session.kernel;
    }
    get id() {
        return this._id;
    }
    get info() {
        return this._info;
    }
    get session() {
        return this._session;
    }
    get connection() {
        return this._kernelConnection;
    }
    shutdown() {
        this._session.kernel?.shutdown();
        this.connection.then(k => k.dispose());
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Kernel);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/services/kernel/KernelModel.js":
/*!***********************************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/services/kernel/KernelModel.js ***!
  \***********************************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "KernelModel": () => (/* binding */ KernelModel),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @lumino/signaling */ "webpack/sharing/consume/default/@lumino/signaling");
/* harmony import */ var _lumino_signaling__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_lumino_signaling__WEBPACK_IMPORTED_MODULE_0__);

class KernelModel {
    constructor(session) {
        this._sessionContext = session;
    }
    get future() {
        return this._future;
    }
    set future(value) {
        this._future = value;
        if (!value) {
            return;
        }
        value.onIOPub = this._onIOPub;
    }
    get output() {
        return this._output;
    }
    get stateChanged() {
        return this._stateChanged;
    }
    execute(code) {
        if (!this._sessionContext || !this._sessionContext.session?.kernel) {
            return;
        }
        this.future = this._sessionContext.session?.kernel?.requestExecute({
            code
        });
    }
    _onIOPub = (msg) => {
        const msgType = msg.header.msg_type;
        switch (msgType) {
            case 'execute_result':
                break;
            case 'display_data':
                break;
            case 'update_display_data':
                this._output = msg.content;
                this._stateChanged.emit();
                break;
            default:
                break;
        }
        return;
    };
    _future = null;
    _output = null;
    _sessionContext;
    _stateChanged = new _lumino_signaling__WEBPACK_IMPORTED_MODULE_0__.Signal(this);
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (KernelModel);


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/utils/Ids.js":
/*!*****************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/utils/Ids.js ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "newSourceId": () => (/* binding */ newSourceId),
/* harmony export */   "newUuid": () => (/* binding */ newUuid)
/* harmony export */ });
/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! uuid */ "../../../node_modules/uuid/dist/esm-browser/v4.js");

// const MAX = Number.MAX_SAFE_INTEGER;
// const MAX = 999999;
const newSourceId = (base) => {
    //  return base + Math.floor(Math.random() * MAX).toString();
    return base;
};
const newUuid = () => {
    return (0,uuid__WEBPACK_IMPORTED_MODULE_0__["default"])();
};


/***/ }),

/***/ "../ui/packages/react/lib/jupyter/utils/Utils.js":
/*!*******************************************************!*\
  !*** ../ui/packages/react/lib/jupyter/utils/Utils.js ***!
  \*******************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "sourceAsString": () => (/* binding */ sourceAsString)
/* harmony export */ });
const sourceAsString = (cell) => {
    let source = cell.source;
    if (typeof (source) === 'object') {
        source = source.join('\n');
    }
    return source;
};


/***/ }),

/***/ "../ui/packages/react/lib/redux/InitState.js":
/*!***************************************************!*\
  !*** ../ui/packages/react/lib/redux/InitState.js ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "InitActionType": () => (/* binding */ InitActionType),
/* harmony export */   "initActions": () => (/* binding */ initActions),
/* harmony export */   "initInitialState": () => (/* binding */ initInitialState),
/* harmony export */   "initReducer": () => (/* binding */ initReducer),
/* harmony export */   "selectStart": () => (/* binding */ selectStart)
/* harmony export */ });
/* harmony import */ var react_redux__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react-redux */ "../../../node_modules/react-redux/es/index.js");
/* harmony import */ var typescript_fsa__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! typescript-fsa */ "../../../node_modules/typescript-fsa/lib/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! typescript-fsa-reducers */ "../../../node_modules/typescript-fsa-reducers/dist/index.js");
/* harmony import */ var typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__);



const initInitialState = {
    start: undefined,
};
/* Selectors */
const selectStart = () => (0,react_redux__WEBPACK_IMPORTED_MODULE_0__.useSelector)((state) => {
    if (state.init) {
        return state.init.start;
    }
    return initInitialState.start;
});
/* Actions */
var InitActionType;
(function (InitActionType) {
    InitActionType["GET_START"] = "jupyterReact/GET_START";
})(InitActionType || (InitActionType = {}));
const actionCreator = (0,typescript_fsa__WEBPACK_IMPORTED_MODULE_1__["default"])('jupyterReact');
const initActions = {
    getStart: actionCreator(InitActionType.GET_START),
};
/* Reducers */
const initReducer = (0,typescript_fsa_reducers__WEBPACK_IMPORTED_MODULE_2__.reducerWithInitialState)(initInitialState)
    .case(initActions.getStart, (state, start) => {
    return {
        ...state,
        start,
    };
});


/***/ }),

/***/ "../ui/packages/react/lib/redux/State.js":
/*!***********************************************!*\
  !*** ../ui/packages/react/lib/redux/State.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "epics": () => (/* binding */ epics),
/* harmony export */   "initialState": () => (/* binding */ initialState),
/* harmony export */   "reducers": () => (/* binding */ reducers)
/* harmony export */ });
/* harmony import */ var redux__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! redux */ "../../../node_modules/redux/es/redux.js");
/* harmony import */ var redux_observable__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! redux-observable */ "../../../node_modules/redux-observable/lib/esm/combineEpics.js");
/* harmony import */ var _InitState__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./InitState */ "../ui/packages/react/lib/redux/InitState.js");
/* harmony import */ var _components_cell_CellState__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/cell/CellState */ "../ui/packages/react/lib/components/cell/CellState.js");
/* harmony import */ var _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../components/notebook/NotebookState */ "../ui/packages/react/lib/components/notebook/NotebookState.js");
/* harmony import */ var _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../components/terminal/TerminalState */ "../ui/packages/react/lib/components/terminal/TerminalState.js");
/* harmony import */ var _components_output_OutputState__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../components/output/OutputState */ "../ui/packages/react/lib/components/output/OutputState.js");







const initialState = {
    init: _InitState__WEBPACK_IMPORTED_MODULE_0__.initInitialState,
    cell: _components_cell_CellState__WEBPACK_IMPORTED_MODULE_1__.cellInitialState,
    output: _components_output_OutputState__WEBPACK_IMPORTED_MODULE_2__.outputInitialState,
    notebook: _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookInitialState,
    terminal: _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_4__.terminalInitialState,
};
/* Actions
export type ActionUnion<
  A extends { [asyncActionCreator: string]: (...args: any[]) => any; }
> = Exclude<ReturnType<A[keyof A]>, (...args: any[]) => Promise<void>>;

export type CellAction = ActionUnion<typeof cellActions>;
export type NotebookAction = ActionUnion<typeof notebookActions>;

export type AppAction = CellAction | NotebookAction;
*/
/* Epics */
const epics = (0,redux_observable__WEBPACK_IMPORTED_MODULE_5__.combineEpics)(_components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookEpics);
/* Reducers */
const reducers = (0,redux__WEBPACK_IMPORTED_MODULE_6__.combineReducers)({
    init: _InitState__WEBPACK_IMPORTED_MODULE_0__.initReducer,
    cell: _components_cell_CellState__WEBPACK_IMPORTED_MODULE_1__.cellReducer,
    output: _components_output_OutputState__WEBPACK_IMPORTED_MODULE_2__.outputReducer,
    notebook: _components_notebook_NotebookState__WEBPACK_IMPORTED_MODULE_3__.notebookReducer,
    terminal: _components_terminal_TerminalState__WEBPACK_IMPORTED_MODULE_4__.terminalReducer,
});


/***/ }),

/***/ "../ui/packages/react/lib/redux/Store.js":
/*!***********************************************!*\
  !*** ../ui/packages/react/lib/redux/Store.js ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createInjectableStore": () => (/* binding */ createInjectableStore),
/* harmony export */   "createReduxEpicStore": () => (/* binding */ createReduxEpicStore),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var redux__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! redux */ "../../../node_modules/redux/es/redux.js");
/* harmony import */ var redux_observable__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! redux-observable */ "../../../node_modules/redux-observable/lib/esm/createEpicMiddleware.js");
/* harmony import */ var _InitState__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./InitState */ "../ui/packages/react/lib/redux/InitState.js");



const epicMiddleware = (0,redux_observable__WEBPACK_IMPORTED_MODULE_0__.createEpicMiddleware)();
function createReducer(asyncReducers) {
    return (0,redux__WEBPACK_IMPORTED_MODULE_1__.combineReducers)({
        ...asyncReducers,
    });
}
/*
export const createEpics = (initEpics: any) => {
  const epic$ = new BehaviorSubject(initEpics);
  const rootEpic = (action$: any, state$: any, deps: any) => epic$.pipe(
    mergeMap(epic => epic(action$, state$, deps))
  );
  epicMiddleware.run(rootEpic as any);
}
*/
const createInjectableStore = (store) => {
    const injectableStore = store;
    injectableStore.asyncReducers = {};
    injectableStore.inject = (key, asyncReducer, epic) => {
        const reducer = injectableStore.asyncReducers[key];
        if (key === 'init' || !reducer) {
            if (epic) {
                epicMiddleware.run(epic);
            }
            injectableStore.asyncReducers[key] = asyncReducer;
            const newReducer = createReducer(injectableStore.asyncReducers);
            injectableStore.replaceReducer(newReducer);
        }
    };
    return injectableStore;
};
const createReduxEpicStore = () => (0,redux__WEBPACK_IMPORTED_MODULE_1__.createStore)(createReducer({ initReducer: _InitState__WEBPACK_IMPORTED_MODULE_2__.initReducer }), (0,redux__WEBPACK_IMPORTED_MODULE_1__.applyMiddleware)(epicMiddleware));
const store = createReduxEpicStore();
const injectableStore = createInjectableStore(store);
injectableStore.inject('init', _InitState__WEBPACK_IMPORTED_MODULE_2__.initReducer);
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (injectableStore);


/***/ }),

/***/ "?b7a6":
/*!**************************************!*\
  !*** ./terminal-highlight (ignored) ***!
  \**************************************/
/***/ (() => {

/* (ignored) */

/***/ }),

/***/ "?15c5":
/*!********************!*\
  !*** fs (ignored) ***!
  \********************/
/***/ (() => {

/* (ignored) */

/***/ }),

/***/ "?d81c":
/*!**********************!*\
  !*** path (ignored) ***!
  \**********************/
/***/ (() => {

/* (ignored) */

/***/ }),

/***/ "?0389":
/*!*******************************!*\
  !*** source-map-js (ignored) ***!
  \*******************************/
/***/ (() => {

/* (ignored) */

/***/ }),

/***/ "?6aad":
/*!*********************!*\
  !*** url (ignored) ***!
  \*********************/
/***/ (() => {

/* (ignored) */

/***/ })

}]);
//# sourceMappingURL=ui_packages_react_lib_index_js-webpack_sharing_consume_default_codemirror_language-webpack_sh-0fd2e6.8d82b515d37edf69fb8d.js.map